/*
 * $Id$
 */

/*
 * $Id$
 */
#ifndef HIPE_PPC_ASM_H
#define HIPE_PPC_ASM_H

/*
 * Handle 32 vs 64-bit.
 */

/* 32-bit PowerPC */
#define LOAD	lwz
#define STORE	stw
#define CMPI	cmpwi
#define WSIZE	4

/*
 * Tunables.
 */

#define PPC_LEAF_WORDS	16

/*
 * Workarounds for Darwin.
 */

/* Not Darwin */

/* 32-bit */
#define CSYM(NAME)	NAME

#define ASYM(NAME)	NAME
#define GLOBAL(NAME)	.global NAME
#define SEMI		;
#define SET_SIZE(NAME)	.size NAME,.-NAME
#define TYPE_FUNCTION(NAME)	.type NAME,@function
#define lo16(X)		X@l
#define ha16(X)		X@ha

/*
 * Standard register names.
 */
#define r0	0
#define r1	1
#define r2	2
#define r3	3
#define r4	4
#define r5	5
#define r6	6
#define r7	7
#define r8	8
#define r9	9
#define r10	10
#define r11	11
#define r12	12
#define r13	13
#define r14	14
#define r15	15
#define r16	16
#define r17	17
#define r18	18
#define r19	19
#define r20	20
#define r21	21
#define r22	22
#define r23	23
#define r24	24
#define r25	25
#define r26	26
#define r27	27
#define r28	28
#define r29	29
#define r30	30
#define r31	31

/*
 * Reserved registers.
 */
#define P	r31
#define NSP	r30
#define HP	r29
#define TEMP_LR	r28

/*
 * Context switching macros.
 *
 * RESTORE_CONTEXT and RESTORE_CONTEXT_QUICK do not affect
 * the condition register.
 */
#define SAVE_CONTEXT_QUICK	\
	mflr	TEMP_LR

#define RESTORE_CONTEXT_QUICK	\
	mtlr	TEMP_LR

#define SAVE_CACHED_STATE	\
	STORE	HP, P_HP(P) SEMI\
	STORE	NSP, P_NSP(P)

#define RESTORE_CACHED_STATE	\
	LOAD	HP, P_HP(P) SEMI\
	LOAD	NSP, P_NSP(P)

#define SAVE_CONTEXT		\
	mflr	TEMP_LR SEMI	\
	STORE	TEMP_LR, P_NRA(P) SEMI\
	SAVE_CACHED_STATE

#define RESTORE_CONTEXT	\
	mtlr	TEMP_LR SEMI	\
	RESTORE_CACHED_STATE

/*
 * Argument (parameter) registers.
 */
#define PPC_NR_ARG_REGS	4
#define NR_ARG_REGS	4


#define ARG0	r4
#define ARG1	r5
#define ARG2	r6
#define ARG3	r7

/*
 * TEMP_ARG{0,1}:
 *	Used by NBIF_SAVE_RESCHED_ARGS to save argument
 *	registers in locations preserved by C.
 *	May be registers or process-private memory locations.
 *	Must not be C caller-save registers.
 *	Must not overlap with any Erlang global registers.
 */
#define TEMP_ARG0	r27
#define TEMP_ARG1	r26


#define LOAD_ARG_REGS	lwz r4, P_ARG0(P) SEMI lwz r5, P_ARG1(P) SEMI lwz r6, P_ARG2(P) SEMI lwz r7, P_ARG3(P) SEMI 

#define STORE_ARG_REGS	stw r4, P_ARG0(P) SEMI stw r5, P_ARG1(P) SEMI stw r6, P_ARG2(P) SEMI stw r7, P_ARG3(P) SEMI 




/* #define NBIF_ARG_1_0	mr	r3, r4 */
/* #define NBIF_ARG_2_0	mr	r3, r4 */
/* #define NBIF_ARG_2_1	mr	r3, r5 */
/* #define NBIF_ARG_3_0	mr	r3, r4 */
/* #define NBIF_ARG_3_1	mr	r3, r5 */
/* #define NBIF_ARG_3_2	mr	r3, r6 */
/* #define NBIF_ARG_5_0	mr	r3, r4 */
/* #define NBIF_ARG_5_1	mr	r3, r5 */
/* #define NBIF_ARG_5_2	mr	r3, r6 */
/* #define NBIF_ARG_5_3	mr	r3, r7 */
/* #define NBIF_ARG_5_4	lwz	r3, 0(NSP) */

/* #define NBIF_RET_0	blr */
/* #define NBIF_RET_1	blr */
/* #define NBIF_RET_2	blr */
/* #define NBIF_RET_3	blr */
/* #define NBIF_RET_5	addi	NSP, NSP, 4
	blr */

/* #define NBIF_SAVE_RESCHED_ARGS_1 mr TEMP_ARG0,r4 SEMI  */
/* #define NBIF_SAVE_RESCHED_ARGS_2 mr TEMP_ARG0,r4 SEMI mr TEMP_ARG1,r5 SEMI  */

#endif /* HIPE_PPC_ASM_H */

#include "hipe_literals.h"

	.text
	.p2align 2

/*
 * XXX: TODO:
 * - Can a BIF with arity 0 fail? beam_emu doesn't think so.
 * - All standard BIF interfaces save RA in the PCB now. This
 *   is needed for those BIFs that can trigger a walk of the
 *   native stack, which includes those that can do a gc.
 *   Ideally this overhead should only be imposed for those BIFs
 *   that actually need it, but that set changes from time to
 *   time, and is difficult for us to track.
 * - Can a GC:ing BIF change P_NRA(P) due to the stack trap thingy?
 */

/*
 * standard_bif_interface_0(nbif_name, cbif_name)
 * standard_bif_interface_1(nbif_name, cbif_name)
 * standard_bif_interface_2(nbif_name, cbif_name)
 * standard_bif_interface_3(nbif_name, cbif_name)
 *
 * Generate native interface for a BIF with 0-3 parameters and
 * standard failure mode (may fail, but not with RESCHEDULE).
 */








/*
 * expensive_bif_interface_1(nbif_name, cbif_name)
 * expensive_bif_interface_2(nbif_name, cbif_name)
 *
 * Generate native interface for a BIF with 1-2 parameters and
 * an expensive failure mode (may fail with RESCHEDULE).
 */




/*
 * nofail_primop_interface_0(nbif_name, cbif_name)
 * nofail_primop_interface_1(nbif_name, cbif_name)
 * nofail_primop_interface_2(nbif_name, cbif_name)
 * nofail_primop_interface_3(nbif_name, cbif_name)
 *
 * Generate native interface for a primop with implicit P
 * parameter, 0-3 ordinary parameters and no failure mode.
 * Also used for guard BIFs.
 */








/*
 * nocons_nofail_primop_interface_0(nbif_name, cbif_name)
 * nocons_nofail_primop_interface_1(nbif_name, cbif_name)
 * nocons_nofail_primop_interface_2(nbif_name, cbif_name)
 * nocons_nofail_primop_interface_3(nbif_name, cbif_name)
 * nocons_nofail_primop_interface_5(nbif_name, cbif_name)
 *
 * Generate native interface for a primop with implicit P
 * parameter, 0-3 or 5 ordinary parameters, and no failure mode.
 * The primop cannot CONS or gc.
 */










/*
 * noproc_primop_interface_0(nbif_name, cbif_name)
 * noproc_primop_interface_1(nbif_name, cbif_name)
 * noproc_primop_interface_2(nbif_name, cbif_name)
 * noproc_primop_interface_3(nbif_name, cbif_name)
 * noproc_primop_interface_5(nbif_name, cbif_name)
 *
 * Generate native interface for a primop with no implicit P
 * parameter, 0-3 or 5 ordinary parameters, and no failure mode.
 * The primop cannot CONS or gc.
 */










/*
 * Implement gc_nofail_primop_interface_1 as nofail_primop_interface_1.
 */


/* $Id$
 *
 * List all non architecture-specific BIFs and primops, and
 * classify each as belonging to one of the classes below.
 * This list is included in hipe_${ARCH}_bifs.m4, which is
 * responsible for translating these classifications to the
 * best possible native code wrappers.
 *
 * XXX: We should have a more detailed BIF classification
 * with a number of orthogonal properties (e.g., UPDATES_HP,
 * NEEDS_NSP, CAN_FAIL, CAN_GC, etc), from which we should
 * generate appropriate interfaces.
 */

/****************************************************************
 *			BIF CLASS DESCRIPTIONS			*
 ****************************************************************/

/*
 * standard_bif_interface_0(nbif_name, cbif_name)
 * standard_bif_interface_1(nbif_name, cbif_name)
 * standard_bif_interface_2(nbif_name, cbif_name)
 * standard_bif_interface_3(nbif_name, cbif_name)
 *
 * A BIF with implicit P parameter, 0-3 ordinary parameters,
 * which may fail but not with RESCHEDULE.
 * Native P state (RA/NSP/HP/etc) may be accessed and updated.
 * [XXX: most will CONS but not access P->hipe]
 * GC may not occur (NSP/HP limits unchanged).
 * [XXX: Some actually do GC. SPARC could be broken.]
 */

/*
 * expensive_bif_interface_1(nbif_name, cbif_name)
 * expensive_bif_interface_2(nbif_name, cbif_name)
 *
 * A BIF which may fail with RESCHEDULE, otherwise
 * identical to standard_bif_interface_N.
 */

/*
 * nofail_primop_interface_0(nbif_name, cbif_name)
 * nofail_primop_interface_1(nbif_name, cbif_name)
 * nofail_primop_interface_2(nbif_name, cbif_name)
 * nofail_primop_interface_3(nbif_name, cbif_name)
 *
 * A primop or guard BIF with no failure mode, otherwise
 * identical to standard_bif_interface_N.
 */

/*
 * gc_nofail_primop_interface_1(nbif_name, cbif_name)
 *
 * A primop with implicit P parameter, 1 ordinary parameter,
 * and no failure mode.
 * Native P state (RA/NSP/HP/etc) may be accessed and updated.
 * GC may occur (NSP/HP limits changed).
 */

/*
 * nocons_nofail_primop_interface_0(nbif_name, cbif_name)
 * nocons_nofail_primop_interface_1(nbif_name, cbif_name)
 * nocons_nofail_primop_interface_2(nbif_name, cbif_name)
 * nocons_nofail_primop_interface_3(nbif_name, cbif_name)
 * nocons_nofail_primop_interface_5(nbif_name, cbif_name)
 *
 * A primop with implicit P parameter, 0-3 or 5 ordinary parameters,
 * and no failure mode.
 * Native P state will not be accessed or updated.
 * GC may not occur (NSP/HP limits unchanged).
 */

/*
 * noproc_primop_interface_0(nbif_name, cbif_name)
 * noproc_primop_interface_1(nbif_name, cbif_name)
 * noproc_primop_interface_2(nbif_name, cbif_name)
 * noproc_primop_interface_3(nbif_name, cbif_name)
 * noproc_primop_interface_5(nbif_name, cbif_name)
 *
 * A primop with no P parameter, 0-3 or 5 ordinary parameters,
 * and no failure mode.
 * Native P state will not be accessed or updated.
 * GC may not occur (NSP/HP limits unchanged).
 */

/****************************************************************
 *			BIF CLASSIFICATION			*
 ****************************************************************/

/*
 * BIFs with expensive failure modes.
 */

#ifndef HAVE_nbif_demonitor_1
#define HAVE_nbif_demonitor_1
	GLOBAL(ASYM(nbif_demonitor_1))
ASYM(nbif_demonitor_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save actual parameters in case we must reschedule. */
	mr TEMP_ARG0,r4 SEMI 

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(demonitor_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:
	/* XXX: may need to change for PPC64 */
	addi	r5, 0, lo16(ASYM(nbif_demonitor_1))
	addis	r5, r5, ha16(ASYM(nbif_demonitor_1))
	b	CSYM(nbif_1_hairy_exception)
	SET_SIZE(ASYM(nbif_demonitor_1))
	TYPE_FUNCTION(ASYM(nbif_demonitor_1))
#endif

#ifndef HAVE_nbif_exit_2
#define HAVE_nbif_exit_2
	GLOBAL(ASYM(nbif_exit_2))
ASYM(nbif_exit_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save actual parameters in case we must reschedule. */
	mr TEMP_ARG0,r4 SEMI mr TEMP_ARG1,r5 SEMI 

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(exit_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:
	/* XXX: may need to change for PPC64 */
	addi	r5, 0, lo16(ASYM(nbif_exit_2))
	addis	r5, r5, ha16(ASYM(nbif_exit_2))
	b	CSYM(nbif_2_hairy_exception)
	SET_SIZE(ASYM(nbif_exit_2))
	TYPE_FUNCTION(ASYM(nbif_exit_2))
#endif

#ifndef HAVE_nbif_group_leader_2
#define HAVE_nbif_group_leader_2
	GLOBAL(ASYM(nbif_group_leader_2))
ASYM(nbif_group_leader_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save actual parameters in case we must reschedule. */
	mr TEMP_ARG0,r4 SEMI mr TEMP_ARG1,r5 SEMI 

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(group_leader_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:
	/* XXX: may need to change for PPC64 */
	addi	r5, 0, lo16(ASYM(nbif_group_leader_2))
	addis	r5, r5, ha16(ASYM(nbif_group_leader_2))
	b	CSYM(nbif_2_hairy_exception)
	SET_SIZE(ASYM(nbif_group_leader_2))
	TYPE_FUNCTION(ASYM(nbif_group_leader_2))
#endif

#ifndef HAVE_nbif_link_1
#define HAVE_nbif_link_1
	GLOBAL(ASYM(nbif_link_1))
ASYM(nbif_link_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save actual parameters in case we must reschedule. */
	mr TEMP_ARG0,r4 SEMI 

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(link_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:
	/* XXX: may need to change for PPC64 */
	addi	r5, 0, lo16(ASYM(nbif_link_1))
	addis	r5, r5, ha16(ASYM(nbif_link_1))
	b	CSYM(nbif_1_hairy_exception)
	SET_SIZE(ASYM(nbif_link_1))
	TYPE_FUNCTION(ASYM(nbif_link_1))
#endif

#ifndef HAVE_nbif_monitor_2
#define HAVE_nbif_monitor_2
	GLOBAL(ASYM(nbif_monitor_2))
ASYM(nbif_monitor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save actual parameters in case we must reschedule. */
	mr TEMP_ARG0,r4 SEMI mr TEMP_ARG1,r5 SEMI 

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(monitor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:
	/* XXX: may need to change for PPC64 */
	addi	r5, 0, lo16(ASYM(nbif_monitor_2))
	addis	r5, r5, ha16(ASYM(nbif_monitor_2))
	b	CSYM(nbif_2_hairy_exception)
	SET_SIZE(ASYM(nbif_monitor_2))
	TYPE_FUNCTION(ASYM(nbif_monitor_2))
#endif

#ifndef HAVE_nbif_port_command_2
#define HAVE_nbif_port_command_2
	GLOBAL(ASYM(nbif_port_command_2))
ASYM(nbif_port_command_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save actual parameters in case we must reschedule. */
	mr TEMP_ARG0,r4 SEMI mr TEMP_ARG1,r5 SEMI 

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_command_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:
	/* XXX: may need to change for PPC64 */
	addi	r5, 0, lo16(ASYM(nbif_port_command_2))
	addis	r5, r5, ha16(ASYM(nbif_port_command_2))
	b	CSYM(nbif_2_hairy_exception)
	SET_SIZE(ASYM(nbif_port_command_2))
	TYPE_FUNCTION(ASYM(nbif_port_command_2))
#endif

#ifndef HAVE_nbif_send_2
#define HAVE_nbif_send_2
	GLOBAL(ASYM(nbif_send_2))
ASYM(nbif_send_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save actual parameters in case we must reschedule. */
	mr TEMP_ARG0,r4 SEMI mr TEMP_ARG1,r5 SEMI 

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(send_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:
	/* XXX: may need to change for PPC64 */
	addi	r5, 0, lo16(ASYM(nbif_send_2))
	addis	r5, r5, ha16(ASYM(nbif_send_2))
	b	CSYM(nbif_2_hairy_exception)
	SET_SIZE(ASYM(nbif_send_2))
	TYPE_FUNCTION(ASYM(nbif_send_2))
#endif

#ifndef HAVE_nbif_unlink_1
#define HAVE_nbif_unlink_1
	GLOBAL(ASYM(nbif_unlink_1))
ASYM(nbif_unlink_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save actual parameters in case we must reschedule. */
	mr TEMP_ARG0,r4 SEMI 

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(unlink_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:
	/* XXX: may need to change for PPC64 */
	addi	r5, 0, lo16(ASYM(nbif_unlink_1))
	addis	r5, r5, ha16(ASYM(nbif_unlink_1))
	b	CSYM(nbif_1_hairy_exception)
	SET_SIZE(ASYM(nbif_unlink_1))
	TYPE_FUNCTION(ASYM(nbif_unlink_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_test_reschedule_1
#define HAVE_nbif_hipe_bifs_test_reschedule_1
	GLOBAL(ASYM(nbif_hipe_bifs_test_reschedule_1))
ASYM(nbif_hipe_bifs_test_reschedule_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save actual parameters in case we must reschedule. */
	mr TEMP_ARG0,r4 SEMI 

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_test_reschedule_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:
	/* XXX: may need to change for PPC64 */
	addi	r5, 0, lo16(ASYM(nbif_hipe_bifs_test_reschedule_1))
	addis	r5, r5, ha16(ASYM(nbif_hipe_bifs_test_reschedule_1))
	b	CSYM(nbif_1_hairy_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_test_reschedule_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_test_reschedule_1))
#endif

/*
 * BIFs that may trigger a native stack walk with p->hipe.narity != 0.
 * Relevant when NR_ARG_REGS < the arity of the BIF.
 */

#ifndef HAVE_nbif_check_process_code_2
#define HAVE_nbif_check_process_code_2
	GLOBAL(ASYM(nbif_check_process_code_2))
ASYM(nbif_check_process_code_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_check_process_code_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_check_process_code_2))
	TYPE_FUNCTION(ASYM(nbif_check_process_code_2))
#endif

#ifndef HAVE_nbif_garbage_collect_1
#define HAVE_nbif_garbage_collect_1
	GLOBAL(ASYM(nbif_garbage_collect_1))
ASYM(nbif_garbage_collect_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_garbage_collect_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_garbage_collect_1))
	TYPE_FUNCTION(ASYM(nbif_garbage_collect_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_show_nstack_1
#define HAVE_nbif_hipe_bifs_show_nstack_1
	GLOBAL(ASYM(nbif_hipe_bifs_show_nstack_1))
ASYM(nbif_hipe_bifs_show_nstack_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_show_nstack_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_show_nstack_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_show_nstack_1))
#endif

/*
 * Arithmetic operators called indirectly by the HiPE compiler.
 */

#ifndef HAVE_nbif_add_2
#define HAVE_nbif_add_2
	GLOBAL(ASYM(nbif_add_2))
ASYM(nbif_add_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_mixed_plus)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_add_2))
	TYPE_FUNCTION(ASYM(nbif_add_2))
#endif

#ifndef HAVE_nbif_sub_2
#define HAVE_nbif_sub_2
	GLOBAL(ASYM(nbif_sub_2))
ASYM(nbif_sub_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_mixed_minus)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_sub_2))
	TYPE_FUNCTION(ASYM(nbif_sub_2))
#endif

#ifndef HAVE_nbif_mul_2
#define HAVE_nbif_mul_2
	GLOBAL(ASYM(nbif_mul_2))
ASYM(nbif_mul_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_mixed_times)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_mul_2))
	TYPE_FUNCTION(ASYM(nbif_mul_2))
#endif

#ifndef HAVE_nbif_div_2
#define HAVE_nbif_div_2
	GLOBAL(ASYM(nbif_div_2))
ASYM(nbif_div_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_mixed_div)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_div_2))
	TYPE_FUNCTION(ASYM(nbif_div_2))
#endif

#ifndef HAVE_nbif_intdiv_2
#define HAVE_nbif_intdiv_2
	GLOBAL(ASYM(nbif_intdiv_2))
ASYM(nbif_intdiv_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(intdiv_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_intdiv_2))
	TYPE_FUNCTION(ASYM(nbif_intdiv_2))
#endif

#ifndef HAVE_nbif_rem_2
#define HAVE_nbif_rem_2
	GLOBAL(ASYM(nbif_rem_2))
ASYM(nbif_rem_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(rem_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_rem_2))
	TYPE_FUNCTION(ASYM(nbif_rem_2))
#endif

#ifndef HAVE_nbif_bsl_2
#define HAVE_nbif_bsl_2
	GLOBAL(ASYM(nbif_bsl_2))
ASYM(nbif_bsl_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bsl_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_bsl_2))
	TYPE_FUNCTION(ASYM(nbif_bsl_2))
#endif

#ifndef HAVE_nbif_bsr_2
#define HAVE_nbif_bsr_2
	GLOBAL(ASYM(nbif_bsr_2))
ASYM(nbif_bsr_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bsr_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_bsr_2))
	TYPE_FUNCTION(ASYM(nbif_bsr_2))
#endif

#ifndef HAVE_nbif_band_2
#define HAVE_nbif_band_2
	GLOBAL(ASYM(nbif_band_2))
ASYM(nbif_band_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(band_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_band_2))
	TYPE_FUNCTION(ASYM(nbif_band_2))
#endif

#ifndef HAVE_nbif_bor_2
#define HAVE_nbif_bor_2
	GLOBAL(ASYM(nbif_bor_2))
ASYM(nbif_bor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_bor_2))
	TYPE_FUNCTION(ASYM(nbif_bor_2))
#endif

#ifndef HAVE_nbif_bxor_2
#define HAVE_nbif_bxor_2
	GLOBAL(ASYM(nbif_bxor_2))
ASYM(nbif_bxor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bxor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_bxor_2))
	TYPE_FUNCTION(ASYM(nbif_bxor_2))
#endif

#ifndef HAVE_nbif_bnot_1
#define HAVE_nbif_bnot_1
	GLOBAL(ASYM(nbif_bnot_1))
ASYM(nbif_bnot_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bnot_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_bnot_1))
	TYPE_FUNCTION(ASYM(nbif_bnot_1))
#endif

/*
 * Miscellaneous primops.
 */

#ifndef HAVE_nbif_gc_1
#define HAVE_nbif_gc_1
	GLOBAL(ASYM(nbif_gc_1))
ASYM(nbif_gc_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_gc)

	/* Restore registers. */
	RESTORE_CONTEXT
	blr
	SET_SIZE(ASYM(nbif_gc_1))
	TYPE_FUNCTION(ASYM(nbif_gc_1))
#endif

#ifndef HAVE_nbif_set_timeout
#define HAVE_nbif_set_timeout
	GLOBAL(ASYM(nbif_set_timeout))
ASYM(nbif_set_timeout):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_set_timeout)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_set_timeout))
	TYPE_FUNCTION(ASYM(nbif_set_timeout))
#endif

#ifndef HAVE_nbif_conv_big_to_float
#define HAVE_nbif_conv_big_to_float
	GLOBAL(ASYM(nbif_conv_big_to_float))
ASYM(nbif_conv_big_to_float):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_conv_big_to_float)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_conv_big_to_float))
	TYPE_FUNCTION(ASYM(nbif_conv_big_to_float))
#endif

#ifndef HAVE_nbif_rethrow
#define HAVE_nbif_rethrow
	GLOBAL(ASYM(nbif_rethrow))
ASYM(nbif_rethrow):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_rethrow)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_rethrow))
	TYPE_FUNCTION(ASYM(nbif_rethrow))
#endif

#ifndef HAVE_nbif_find_na_or_make_stub
#define HAVE_nbif_find_na_or_make_stub
	GLOBAL(ASYM(nbif_find_na_or_make_stub))
ASYM(nbif_find_na_or_make_stub):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_find_na_or_make_stub)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_find_na_or_make_stub))
	TYPE_FUNCTION(ASYM(nbif_find_na_or_make_stub))
#endif

/*
 * Mbox primops with implicit P parameter.
 */

#ifndef HAVE_nbif_select_msg
#define HAVE_nbif_select_msg
	GLOBAL(ASYM(nbif_select_msg))
ASYM(nbif_select_msg):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(hipe_select_msg)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_select_msg))
	TYPE_FUNCTION(ASYM(nbif_select_msg))
#endif

/*
 * Primops without any P parameter.
 * These cannot CONS or gc.
 */

#ifndef HAVE_nbif_cmp_2
#define HAVE_nbif_cmp_2
	GLOBAL(ASYM(nbif_cmp_2))
ASYM(nbif_cmp_2):
	/* Set up C argument registers. */
	mr	r3, r4
	mr	r4, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(cmp)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_cmp_2))
	TYPE_FUNCTION(ASYM(nbif_cmp_2))
#endif

#ifndef HAVE_nbif_eq_2
#define HAVE_nbif_eq_2
	GLOBAL(ASYM(nbif_eq_2))
ASYM(nbif_eq_2):
	/* Set up C argument registers. */
	mr	r3, r4
	mr	r4, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(eq)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_eq_2))
	TYPE_FUNCTION(ASYM(nbif_eq_2))
#endif

/*
 * Bit-syntax primops with implicit P parameter.
 * XXX: only get_integer conses on the ordinary heap
 */

#ifndef HAVE_nbif_bs_get_integer
#define HAVE_nbif_bs_get_integer
	GLOBAL(ASYM(nbif_bs_get_integer))
ASYM(nbif_bs_get_integer):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_bs_get_integer)

	/* Restore registers. */
	RESTORE_CONTEXT
	blr
	SET_SIZE(ASYM(nbif_bs_get_integer))
	TYPE_FUNCTION(ASYM(nbif_bs_get_integer))
#endif

#ifndef HAVE_nbif_bs_get_binary
#define HAVE_nbif_bs_get_binary
	GLOBAL(ASYM(nbif_bs_get_binary))
ASYM(nbif_bs_get_binary):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_bs_get_binary)

	/* Restore registers. */
	RESTORE_CONTEXT
	blr
	SET_SIZE(ASYM(nbif_bs_get_binary))
	TYPE_FUNCTION(ASYM(nbif_bs_get_binary))
#endif

#ifndef HAVE_nbif_bs_get_float
#define HAVE_nbif_bs_get_float
	GLOBAL(ASYM(nbif_bs_get_float))
ASYM(nbif_bs_get_float):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_bs_get_float)

	/* Restore registers. */
	RESTORE_CONTEXT
	blr
	SET_SIZE(ASYM(nbif_bs_get_float))
	TYPE_FUNCTION(ASYM(nbif_bs_get_float))
#endif

#ifndef HAVE_nbif_bs_get_binary_all
#define HAVE_nbif_bs_get_binary_all
	GLOBAL(ASYM(nbif_bs_get_binary_all))
ASYM(nbif_bs_get_binary_all):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_bs_get_binary_all)

	/* Restore registers. */
	RESTORE_CONTEXT
	blr
	SET_SIZE(ASYM(nbif_bs_get_binary_all))
	TYPE_FUNCTION(ASYM(nbif_bs_get_binary_all))
#endif

#ifndef HAVE_nbif_bs_final
#define HAVE_nbif_bs_final
	GLOBAL(ASYM(nbif_bs_final))
ASYM(nbif_bs_final):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_bs_final)

	/* Restore registers. */
	RESTORE_CONTEXT
	blr
	SET_SIZE(ASYM(nbif_bs_final))
	TYPE_FUNCTION(ASYM(nbif_bs_final))
#endif

/*
 * Bit-syntax primops without any P parameter.
 * These cannot CONS or gc.
 */

#ifndef HAVE_nbif_bs_allocate
#define HAVE_nbif_bs_allocate
	GLOBAL(ASYM(nbif_bs_allocate))
ASYM(nbif_bs_allocate):
	/* Set up C argument registers. */
	mr	r3, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(hipe_bs_allocate)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_allocate))
	TYPE_FUNCTION(ASYM(nbif_bs_allocate))
#endif

/*
 * Bit-syntax primops. The ERTS_SMP runtime system requires P,
 * hence the use of nocons_nofail_primop_interface_N().
 * When ERTS_SMP is disabled, noproc_primop_interface_N()
 * should be used instead.
 */


#ifndef HAVE_nbif_bs_start_match
#define HAVE_nbif_bs_start_match
	GLOBAL(ASYM(nbif_bs_start_match))
ASYM(nbif_bs_start_match):
	/* Set up C argument registers. */
	mr	r3, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_start_match)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_start_match))
	TYPE_FUNCTION(ASYM(nbif_bs_start_match))
#endif

#ifndef HAVE_nbif_bs_skip_bits
#define HAVE_nbif_bs_skip_bits
	GLOBAL(ASYM(nbif_bs_skip_bits))
ASYM(nbif_bs_skip_bits):
	/* Set up C argument registers. */
	mr	r3, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_skip_bits)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_skip_bits))
	TYPE_FUNCTION(ASYM(nbif_bs_skip_bits))
#endif

#ifndef HAVE_nbif_bs_skip_bits_all
#define HAVE_nbif_bs_skip_bits_all
	GLOBAL(ASYM(nbif_bs_skip_bits_all))
ASYM(nbif_bs_skip_bits_all):
	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_skip_bits_all)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_skip_bits_all))
	TYPE_FUNCTION(ASYM(nbif_bs_skip_bits_all))
#endif

#ifndef HAVE_nbif_bs_test_tail
#define HAVE_nbif_bs_test_tail
	GLOBAL(ASYM(nbif_bs_test_tail))
ASYM(nbif_bs_test_tail):
	/* Set up C argument registers. */
	mr	r3, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_test_tail)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_test_tail))
	TYPE_FUNCTION(ASYM(nbif_bs_test_tail))
#endif

#ifndef HAVE_nbif_bs_save
#define HAVE_nbif_bs_save
	GLOBAL(ASYM(nbif_bs_save))
ASYM(nbif_bs_save):
	/* Set up C argument registers. */
	mr	r3, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_save)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_save))
	TYPE_FUNCTION(ASYM(nbif_bs_save))
#endif

#ifndef HAVE_nbif_bs_restore
#define HAVE_nbif_bs_restore
	GLOBAL(ASYM(nbif_bs_restore))
ASYM(nbif_bs_restore):
	/* Set up C argument registers. */
	mr	r3, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_restore)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_restore))
	TYPE_FUNCTION(ASYM(nbif_bs_restore))
#endif

#ifndef HAVE_nbif_bs_init
#define HAVE_nbif_bs_init
	GLOBAL(ASYM(nbif_bs_init))
ASYM(nbif_bs_init):
	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_init)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_init))
	TYPE_FUNCTION(ASYM(nbif_bs_init))
#endif

#ifndef HAVE_nbif_bs_put_integer
#define HAVE_nbif_bs_put_integer
	GLOBAL(ASYM(nbif_bs_put_integer))
ASYM(nbif_bs_put_integer):
	/* Set up C argument registers. */
	mr	r3, r4
	mr	r4, r5
	mr	r5, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_put_integer)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_put_integer))
	TYPE_FUNCTION(ASYM(nbif_bs_put_integer))
#endif

#ifndef HAVE_nbif_bs_put_binary
#define HAVE_nbif_bs_put_binary
	GLOBAL(ASYM(nbif_bs_put_binary))
ASYM(nbif_bs_put_binary):
	/* Set up C argument registers. */
	mr	r3, r4
	mr	r4, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_put_binary)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_put_binary))
	TYPE_FUNCTION(ASYM(nbif_bs_put_binary))
#endif

#ifndef HAVE_nbif_bs_put_binary_all
#define HAVE_nbif_bs_put_binary_all
	GLOBAL(ASYM(nbif_bs_put_binary_all))
ASYM(nbif_bs_put_binary_all):
	/* Set up C argument registers. */
	mr	r3, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_put_binary_all)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_put_binary_all))
	TYPE_FUNCTION(ASYM(nbif_bs_put_binary_all))
#endif

#ifndef HAVE_nbif_bs_put_float
#define HAVE_nbif_bs_put_float
	GLOBAL(ASYM(nbif_bs_put_float))
ASYM(nbif_bs_put_float):
	/* Set up C argument registers. */
	mr	r3, r4
	mr	r4, r5
	mr	r5, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_put_float)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_put_float))
	TYPE_FUNCTION(ASYM(nbif_bs_put_float))
#endif

#ifndef HAVE_nbif_bs_put_string
#define HAVE_nbif_bs_put_string
	GLOBAL(ASYM(nbif_bs_put_string))
ASYM(nbif_bs_put_string):
	/* Set up C argument registers. */
	mr	r3, r4
	mr	r4, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(erts_bs_put_string)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	blr
	SET_SIZE(ASYM(nbif_bs_put_string))
	TYPE_FUNCTION(ASYM(nbif_bs_put_string))
#endif

#ifndef HAVE_nbif_bs_put_big_integer
#define HAVE_nbif_bs_put_big_integer
	GLOBAL(ASYM(nbif_bs_put_big_integer))
ASYM(nbif_bs_put_big_integer):
	/* Set up C argument registers. */
	mr	r3, r4
	mr	r4, r5
	mr	r5, r6
	mr	r6, r7
	lwz	r7, 0(NSP)

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(hipe_bs_put_big_integer)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	addi	NSP, NSP, 4
	blr
	SET_SIZE(ASYM(nbif_bs_put_big_integer))
	TYPE_FUNCTION(ASYM(nbif_bs_put_big_integer))
#endif

#ifndef HAVE_nbif_bs_put_small_float
#define HAVE_nbif_bs_put_small_float
	GLOBAL(ASYM(nbif_bs_put_small_float))
ASYM(nbif_bs_put_small_float):
	/* Set up C argument registers. */
	mr	r3, r4
	mr	r4, r5
	mr	r5, r6
	mr	r6, r7
	lwz	r7, 0(NSP)

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT_QUICK
	bl	CSYM(hipe_bs_put_small_float)

	/* Restore registers. */
	RESTORE_CONTEXT_QUICK
	addi	NSP, NSP, 4
	blr
	SET_SIZE(ASYM(nbif_bs_put_small_float))
	TYPE_FUNCTION(ASYM(nbif_bs_put_small_float))
#endif

/*
 * SMP-specific stuff
 */

/*
 * Standard BIFs.
 * BIF_LIST(ModuleAtom,FunctionAtom,Arity,CFun,Index)
 */

/*
 *  Warning: Do not edit this file.  It was automatically
 *  generated by 'make_tables' on Tue Sep  1 09:51:54 2009.
 */


#ifndef HAVE_nbif_abs_1
#define HAVE_nbif_abs_1
	GLOBAL(ASYM(nbif_abs_1))
ASYM(nbif_abs_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(abs_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_abs_1))
	TYPE_FUNCTION(ASYM(nbif_abs_1))
#endif

#ifndef HAVE_nbif_ebif_abs_1
#define HAVE_nbif_ebif_abs_1
	GLOBAL(ASYM(nbif_ebif_abs_1))
ASYM(nbif_ebif_abs_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_abs_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_abs_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_abs_1))
#endif

#ifndef HAVE_nbif_apply_3
#define HAVE_nbif_apply_3
	GLOBAL(ASYM(nbif_apply_3))
ASYM(nbif_apply_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(apply_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_apply_3))
	TYPE_FUNCTION(ASYM(nbif_apply_3))
#endif

#ifndef HAVE_nbif_ebif_apply_3
#define HAVE_nbif_ebif_apply_3
	GLOBAL(ASYM(nbif_ebif_apply_3))
ASYM(nbif_ebif_apply_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_apply_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_apply_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_apply_3))
#endif

#ifndef HAVE_nbif_atom_to_list_1
#define HAVE_nbif_atom_to_list_1
	GLOBAL(ASYM(nbif_atom_to_list_1))
ASYM(nbif_atom_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(atom_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_atom_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_atom_to_list_1))
#endif

#ifndef HAVE_nbif_ebif_atom_to_string_1
#define HAVE_nbif_ebif_atom_to_string_1
	GLOBAL(ASYM(nbif_ebif_atom_to_string_1))
ASYM(nbif_ebif_atom_to_string_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_atom_to_string_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_atom_to_string_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_atom_to_string_1))
#endif

#ifndef HAVE_nbif_binary_to_list_1
#define HAVE_nbif_binary_to_list_1
	GLOBAL(ASYM(nbif_binary_to_list_1))
ASYM(nbif_binary_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(binary_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_binary_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_binary_to_list_1))
#endif

#ifndef HAVE_nbif_ebif_binary_to_list_1
#define HAVE_nbif_ebif_binary_to_list_1
	GLOBAL(ASYM(nbif_ebif_binary_to_list_1))
ASYM(nbif_ebif_binary_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_binary_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_binary_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_binary_to_list_1))
#endif

#ifndef HAVE_nbif_binary_to_list_3
#define HAVE_nbif_binary_to_list_3
	GLOBAL(ASYM(nbif_binary_to_list_3))
ASYM(nbif_binary_to_list_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(binary_to_list_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_binary_to_list_3))
	TYPE_FUNCTION(ASYM(nbif_binary_to_list_3))
#endif

#ifndef HAVE_nbif_ebif_binary_to_list_3
#define HAVE_nbif_ebif_binary_to_list_3
	GLOBAL(ASYM(nbif_ebif_binary_to_list_3))
ASYM(nbif_ebif_binary_to_list_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_binary_to_list_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_binary_to_list_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_binary_to_list_3))
#endif

#ifndef HAVE_nbif_binary_to_term_1
#define HAVE_nbif_binary_to_term_1
	GLOBAL(ASYM(nbif_binary_to_term_1))
ASYM(nbif_binary_to_term_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(binary_to_term_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_binary_to_term_1))
	TYPE_FUNCTION(ASYM(nbif_binary_to_term_1))
#endif

#ifndef HAVE_nbif_ebif_binary_to_term_1
#define HAVE_nbif_ebif_binary_to_term_1
	GLOBAL(ASYM(nbif_ebif_binary_to_term_1))
ASYM(nbif_ebif_binary_to_term_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_binary_to_term_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_binary_to_term_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_binary_to_term_1))
#endif

#ifndef HAVE_nbif_check_process_code_2
#define HAVE_nbif_check_process_code_2
	GLOBAL(ASYM(nbif_check_process_code_2))
ASYM(nbif_check_process_code_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(check_process_code_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_check_process_code_2))
	TYPE_FUNCTION(ASYM(nbif_check_process_code_2))
#endif

#ifndef HAVE_nbif_ebif_check_process_code_2
#define HAVE_nbif_ebif_check_process_code_2
	GLOBAL(ASYM(nbif_ebif_check_process_code_2))
ASYM(nbif_ebif_check_process_code_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_check_process_code_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_check_process_code_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_check_process_code_2))
#endif

#ifndef HAVE_nbif_date_0
#define HAVE_nbif_date_0
	GLOBAL(ASYM(nbif_date_0))
ASYM(nbif_date_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(date_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_date_0))
	TYPE_FUNCTION(ASYM(nbif_date_0))
#endif

#ifndef HAVE_nbif_ebif_date_0
#define HAVE_nbif_ebif_date_0
	GLOBAL(ASYM(nbif_ebif_date_0))
ASYM(nbif_ebif_date_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_date_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_date_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_date_0))
#endif

#ifndef HAVE_nbif_delete_module_1
#define HAVE_nbif_delete_module_1
	GLOBAL(ASYM(nbif_delete_module_1))
ASYM(nbif_delete_module_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(delete_module_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_delete_module_1))
	TYPE_FUNCTION(ASYM(nbif_delete_module_1))
#endif

#ifndef HAVE_nbif_ebif_delete_module_1
#define HAVE_nbif_ebif_delete_module_1
	GLOBAL(ASYM(nbif_ebif_delete_module_1))
ASYM(nbif_ebif_delete_module_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_delete_module_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_delete_module_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_delete_module_1))
#endif

#ifndef HAVE_nbif_display_1
#define HAVE_nbif_display_1
	GLOBAL(ASYM(nbif_display_1))
ASYM(nbif_display_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(display_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_display_1))
	TYPE_FUNCTION(ASYM(nbif_display_1))
#endif

#ifndef HAVE_nbif_ebif_display_1
#define HAVE_nbif_ebif_display_1
	GLOBAL(ASYM(nbif_ebif_display_1))
ASYM(nbif_ebif_display_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_display_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_display_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_display_1))
#endif

#ifndef HAVE_nbif_display_string_1
#define HAVE_nbif_display_string_1
	GLOBAL(ASYM(nbif_display_string_1))
ASYM(nbif_display_string_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(display_string_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_display_string_1))
	TYPE_FUNCTION(ASYM(nbif_display_string_1))
#endif

#ifndef HAVE_nbif_ebif_display_string_1
#define HAVE_nbif_ebif_display_string_1
	GLOBAL(ASYM(nbif_ebif_display_string_1))
ASYM(nbif_ebif_display_string_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_display_string_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_display_string_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_display_string_1))
#endif

#ifndef HAVE_nbif_display_nl_0
#define HAVE_nbif_display_nl_0
	GLOBAL(ASYM(nbif_display_nl_0))
ASYM(nbif_display_nl_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(display_nl_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_display_nl_0))
	TYPE_FUNCTION(ASYM(nbif_display_nl_0))
#endif

#ifndef HAVE_nbif_ebif_display_nl_0
#define HAVE_nbif_ebif_display_nl_0
	GLOBAL(ASYM(nbif_ebif_display_nl_0))
ASYM(nbif_ebif_display_nl_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_display_nl_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_display_nl_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_display_nl_0))
#endif

#ifndef HAVE_nbif_element_2
#define HAVE_nbif_element_2
	GLOBAL(ASYM(nbif_element_2))
ASYM(nbif_element_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(element_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_element_2))
	TYPE_FUNCTION(ASYM(nbif_element_2))
#endif

#ifndef HAVE_nbif_ebif_element_2
#define HAVE_nbif_ebif_element_2
	GLOBAL(ASYM(nbif_ebif_element_2))
ASYM(nbif_ebif_element_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_element_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_element_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_element_2))
#endif

#ifndef HAVE_nbif_erase_0
#define HAVE_nbif_erase_0
	GLOBAL(ASYM(nbif_erase_0))
ASYM(nbif_erase_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erase_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_erase_0))
	TYPE_FUNCTION(ASYM(nbif_erase_0))
#endif

#ifndef HAVE_nbif_ebif_erase_0
#define HAVE_nbif_ebif_erase_0
	GLOBAL(ASYM(nbif_ebif_erase_0))
ASYM(nbif_ebif_erase_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_erase_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_erase_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_erase_0))
#endif

#ifndef HAVE_nbif_erase_1
#define HAVE_nbif_erase_1
	GLOBAL(ASYM(nbif_erase_1))
ASYM(nbif_erase_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erase_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_erase_1))
	TYPE_FUNCTION(ASYM(nbif_erase_1))
#endif

#ifndef HAVE_nbif_ebif_erase_1
#define HAVE_nbif_ebif_erase_1
	GLOBAL(ASYM(nbif_ebif_erase_1))
ASYM(nbif_ebif_erase_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_erase_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_erase_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_erase_1))
#endif

#ifndef HAVE_nbif_exit_1
#define HAVE_nbif_exit_1
	GLOBAL(ASYM(nbif_exit_1))
ASYM(nbif_exit_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(exit_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_exit_1))
	TYPE_FUNCTION(ASYM(nbif_exit_1))
#endif

#ifndef HAVE_nbif_ebif_exit_1
#define HAVE_nbif_ebif_exit_1
	GLOBAL(ASYM(nbif_ebif_exit_1))
ASYM(nbif_ebif_exit_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_exit_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_exit_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_exit_1))
#endif

#ifndef HAVE_nbif_exit_2
#define HAVE_nbif_exit_2
	GLOBAL(ASYM(nbif_exit_2))
ASYM(nbif_exit_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(exit_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_exit_2))
	TYPE_FUNCTION(ASYM(nbif_exit_2))
#endif

#ifndef HAVE_nbif_ebif_signal_2
#define HAVE_nbif_ebif_signal_2
	GLOBAL(ASYM(nbif_ebif_signal_2))
ASYM(nbif_ebif_signal_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_signal_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_signal_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_signal_2))
#endif

#ifndef HAVE_nbif_external_size_1
#define HAVE_nbif_external_size_1
	GLOBAL(ASYM(nbif_external_size_1))
ASYM(nbif_external_size_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(external_size_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_external_size_1))
	TYPE_FUNCTION(ASYM(nbif_external_size_1))
#endif

#ifndef HAVE_nbif_ebif_external_size_1
#define HAVE_nbif_ebif_external_size_1
	GLOBAL(ASYM(nbif_ebif_external_size_1))
ASYM(nbif_ebif_external_size_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_external_size_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_external_size_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_external_size_1))
#endif

#ifndef HAVE_nbif_float_1
#define HAVE_nbif_float_1
	GLOBAL(ASYM(nbif_float_1))
ASYM(nbif_float_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(float_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_float_1))
	TYPE_FUNCTION(ASYM(nbif_float_1))
#endif

#ifndef HAVE_nbif_ebif_to_float_1
#define HAVE_nbif_ebif_to_float_1
	GLOBAL(ASYM(nbif_ebif_to_float_1))
ASYM(nbif_ebif_to_float_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_to_float_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_to_float_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_to_float_1))
#endif

#ifndef HAVE_nbif_float_to_list_1
#define HAVE_nbif_float_to_list_1
	GLOBAL(ASYM(nbif_float_to_list_1))
ASYM(nbif_float_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(float_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_float_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_float_to_list_1))
#endif

#ifndef HAVE_nbif_ebif_float_to_string_1
#define HAVE_nbif_ebif_float_to_string_1
	GLOBAL(ASYM(nbif_ebif_float_to_string_1))
ASYM(nbif_ebif_float_to_string_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_float_to_string_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_float_to_string_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_float_to_string_1))
#endif

#ifndef HAVE_nbif_fun_info_2
#define HAVE_nbif_fun_info_2
	GLOBAL(ASYM(nbif_fun_info_2))
ASYM(nbif_fun_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(fun_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_fun_info_2))
	TYPE_FUNCTION(ASYM(nbif_fun_info_2))
#endif

#ifndef HAVE_nbif_ebif_fun_info_2
#define HAVE_nbif_ebif_fun_info_2
	GLOBAL(ASYM(nbif_ebif_fun_info_2))
ASYM(nbif_ebif_fun_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_fun_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_fun_info_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_fun_info_2))
#endif

#ifndef HAVE_nbif_garbage_collect_0
#define HAVE_nbif_garbage_collect_0
	GLOBAL(ASYM(nbif_garbage_collect_0))
ASYM(nbif_garbage_collect_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(garbage_collect_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_garbage_collect_0))
	TYPE_FUNCTION(ASYM(nbif_garbage_collect_0))
#endif

#ifndef HAVE_nbif_ebif_garbage_collect_0
#define HAVE_nbif_ebif_garbage_collect_0
	GLOBAL(ASYM(nbif_ebif_garbage_collect_0))
ASYM(nbif_ebif_garbage_collect_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_garbage_collect_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_garbage_collect_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_garbage_collect_0))
#endif

#ifndef HAVE_nbif_garbage_collect_1
#define HAVE_nbif_garbage_collect_1
	GLOBAL(ASYM(nbif_garbage_collect_1))
ASYM(nbif_garbage_collect_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(garbage_collect_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_garbage_collect_1))
	TYPE_FUNCTION(ASYM(nbif_garbage_collect_1))
#endif

#ifndef HAVE_nbif_ebif_garbage_collect_1
#define HAVE_nbif_ebif_garbage_collect_1
	GLOBAL(ASYM(nbif_ebif_garbage_collect_1))
ASYM(nbif_ebif_garbage_collect_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_garbage_collect_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_garbage_collect_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_garbage_collect_1))
#endif

#ifndef HAVE_nbif_garbage_collect_message_area_0
#define HAVE_nbif_garbage_collect_message_area_0
	GLOBAL(ASYM(nbif_garbage_collect_message_area_0))
ASYM(nbif_garbage_collect_message_area_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(garbage_collect_message_area_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_garbage_collect_message_area_0))
	TYPE_FUNCTION(ASYM(nbif_garbage_collect_message_area_0))
#endif

#ifndef HAVE_nbif_ebif_garbage_collect_message_area_0
#define HAVE_nbif_ebif_garbage_collect_message_area_0
	GLOBAL(ASYM(nbif_ebif_garbage_collect_message_area_0))
ASYM(nbif_ebif_garbage_collect_message_area_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_garbage_collect_message_area_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_garbage_collect_message_area_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_garbage_collect_message_area_0))
#endif

#ifndef HAVE_nbif_get_0
#define HAVE_nbif_get_0
	GLOBAL(ASYM(nbif_get_0))
ASYM(nbif_get_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(get_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_get_0))
	TYPE_FUNCTION(ASYM(nbif_get_0))
#endif

#ifndef HAVE_nbif_ebif_get_0
#define HAVE_nbif_ebif_get_0
	GLOBAL(ASYM(nbif_ebif_get_0))
ASYM(nbif_ebif_get_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_get_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_get_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_get_0))
#endif

#ifndef HAVE_nbif_get_1
#define HAVE_nbif_get_1
	GLOBAL(ASYM(nbif_get_1))
ASYM(nbif_get_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(get_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_get_1))
	TYPE_FUNCTION(ASYM(nbif_get_1))
#endif

#ifndef HAVE_nbif_ebif_get_1
#define HAVE_nbif_ebif_get_1
	GLOBAL(ASYM(nbif_ebif_get_1))
ASYM(nbif_ebif_get_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_get_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_get_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_get_1))
#endif

#ifndef HAVE_nbif_get_keys_1
#define HAVE_nbif_get_keys_1
	GLOBAL(ASYM(nbif_get_keys_1))
ASYM(nbif_get_keys_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(get_keys_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_get_keys_1))
	TYPE_FUNCTION(ASYM(nbif_get_keys_1))
#endif

#ifndef HAVE_nbif_ebif_get_keys_1
#define HAVE_nbif_ebif_get_keys_1
	GLOBAL(ASYM(nbif_ebif_get_keys_1))
ASYM(nbif_ebif_get_keys_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_get_keys_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_get_keys_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_get_keys_1))
#endif

#ifndef HAVE_nbif_group_leader_0
#define HAVE_nbif_group_leader_0
	GLOBAL(ASYM(nbif_group_leader_0))
ASYM(nbif_group_leader_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(group_leader_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_group_leader_0))
	TYPE_FUNCTION(ASYM(nbif_group_leader_0))
#endif

#ifndef HAVE_nbif_ebif_group_leader_0
#define HAVE_nbif_ebif_group_leader_0
	GLOBAL(ASYM(nbif_ebif_group_leader_0))
ASYM(nbif_ebif_group_leader_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_group_leader_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_group_leader_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_group_leader_0))
#endif

#ifndef HAVE_nbif_group_leader_2
#define HAVE_nbif_group_leader_2
	GLOBAL(ASYM(nbif_group_leader_2))
ASYM(nbif_group_leader_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(group_leader_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_group_leader_2))
	TYPE_FUNCTION(ASYM(nbif_group_leader_2))
#endif

#ifndef HAVE_nbif_ebif_group_leader_2
#define HAVE_nbif_ebif_group_leader_2
	GLOBAL(ASYM(nbif_ebif_group_leader_2))
ASYM(nbif_ebif_group_leader_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_group_leader_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_group_leader_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_group_leader_2))
#endif

#ifndef HAVE_nbif_halt_0
#define HAVE_nbif_halt_0
	GLOBAL(ASYM(nbif_halt_0))
ASYM(nbif_halt_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(halt_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_halt_0))
	TYPE_FUNCTION(ASYM(nbif_halt_0))
#endif

#ifndef HAVE_nbif_ebif_halt_0
#define HAVE_nbif_ebif_halt_0
	GLOBAL(ASYM(nbif_ebif_halt_0))
ASYM(nbif_ebif_halt_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_halt_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_halt_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_halt_0))
#endif

#ifndef HAVE_nbif_halt_1
#define HAVE_nbif_halt_1
	GLOBAL(ASYM(nbif_halt_1))
ASYM(nbif_halt_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(halt_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_halt_1))
	TYPE_FUNCTION(ASYM(nbif_halt_1))
#endif

#ifndef HAVE_nbif_ebif_halt_1
#define HAVE_nbif_ebif_halt_1
	GLOBAL(ASYM(nbif_ebif_halt_1))
ASYM(nbif_ebif_halt_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_halt_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_halt_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_halt_1))
#endif

#ifndef HAVE_nbif_phash_2
#define HAVE_nbif_phash_2
	GLOBAL(ASYM(nbif_phash_2))
ASYM(nbif_phash_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(phash_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_phash_2))
	TYPE_FUNCTION(ASYM(nbif_phash_2))
#endif

#ifndef HAVE_nbif_phash2_1
#define HAVE_nbif_phash2_1
	GLOBAL(ASYM(nbif_phash2_1))
ASYM(nbif_phash2_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(phash2_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_phash2_1))
	TYPE_FUNCTION(ASYM(nbif_phash2_1))
#endif

#ifndef HAVE_nbif_phash2_2
#define HAVE_nbif_phash2_2
	GLOBAL(ASYM(nbif_phash2_2))
ASYM(nbif_phash2_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(phash2_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_phash2_2))
	TYPE_FUNCTION(ASYM(nbif_phash2_2))
#endif

#ifndef HAVE_nbif_ebif_phash2_1
#define HAVE_nbif_ebif_phash2_1
	GLOBAL(ASYM(nbif_ebif_phash2_1))
ASYM(nbif_ebif_phash2_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_phash2_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_phash2_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_phash2_1))
#endif

#ifndef HAVE_nbif_ebif_phash2_2
#define HAVE_nbif_ebif_phash2_2
	GLOBAL(ASYM(nbif_ebif_phash2_2))
ASYM(nbif_ebif_phash2_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_phash2_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_phash2_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_phash2_2))
#endif

#ifndef HAVE_nbif_hd_1
#define HAVE_nbif_hd_1
	GLOBAL(ASYM(nbif_hd_1))
ASYM(nbif_hd_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hd_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hd_1))
	TYPE_FUNCTION(ASYM(nbif_hd_1))
#endif

#ifndef HAVE_nbif_ebif_hd_1
#define HAVE_nbif_ebif_hd_1
	GLOBAL(ASYM(nbif_ebif_hd_1))
ASYM(nbif_ebif_hd_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_hd_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_hd_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_hd_1))
#endif

#ifndef HAVE_nbif_integer_to_list_1
#define HAVE_nbif_integer_to_list_1
	GLOBAL(ASYM(nbif_integer_to_list_1))
ASYM(nbif_integer_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(integer_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_integer_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_integer_to_list_1))
#endif

#ifndef HAVE_nbif_ebif_integer_to_string_1
#define HAVE_nbif_ebif_integer_to_string_1
	GLOBAL(ASYM(nbif_ebif_integer_to_string_1))
ASYM(nbif_ebif_integer_to_string_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_integer_to_string_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_integer_to_string_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_integer_to_string_1))
#endif

#ifndef HAVE_nbif_is_alive_0
#define HAVE_nbif_is_alive_0
	GLOBAL(ASYM(nbif_is_alive_0))
ASYM(nbif_is_alive_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_alive_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_is_alive_0))
	TYPE_FUNCTION(ASYM(nbif_is_alive_0))
#endif

#ifndef HAVE_nbif_ebif_is_alive_0
#define HAVE_nbif_ebif_is_alive_0
	GLOBAL(ASYM(nbif_ebif_is_alive_0))
ASYM(nbif_ebif_is_alive_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_alive_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_alive_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_alive_0))
#endif

#ifndef HAVE_nbif_length_1
#define HAVE_nbif_length_1
	GLOBAL(ASYM(nbif_length_1))
ASYM(nbif_length_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(length_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_length_1))
	TYPE_FUNCTION(ASYM(nbif_length_1))
#endif

#ifndef HAVE_nbif_ebif_length_1
#define HAVE_nbif_ebif_length_1
	GLOBAL(ASYM(nbif_ebif_length_1))
ASYM(nbif_ebif_length_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_length_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_length_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_length_1))
#endif

#ifndef HAVE_nbif_link_1
#define HAVE_nbif_link_1
	GLOBAL(ASYM(nbif_link_1))
ASYM(nbif_link_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(link_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_link_1))
	TYPE_FUNCTION(ASYM(nbif_link_1))
#endif

#ifndef HAVE_nbif_ebif_link_1
#define HAVE_nbif_ebif_link_1
	GLOBAL(ASYM(nbif_ebif_link_1))
ASYM(nbif_ebif_link_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_link_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_link_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_link_1))
#endif

#ifndef HAVE_nbif_list_to_atom_1
#define HAVE_nbif_list_to_atom_1
	GLOBAL(ASYM(nbif_list_to_atom_1))
ASYM(nbif_list_to_atom_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(list_to_atom_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_list_to_atom_1))
	TYPE_FUNCTION(ASYM(nbif_list_to_atom_1))
#endif

#ifndef HAVE_nbif_ebif_string_to_atom_1
#define HAVE_nbif_ebif_string_to_atom_1
	GLOBAL(ASYM(nbif_ebif_string_to_atom_1))
ASYM(nbif_ebif_string_to_atom_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_string_to_atom_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_string_to_atom_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_string_to_atom_1))
#endif

#ifndef HAVE_nbif_list_to_binary_1
#define HAVE_nbif_list_to_binary_1
	GLOBAL(ASYM(nbif_list_to_binary_1))
ASYM(nbif_list_to_binary_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(list_to_binary_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_list_to_binary_1))
	TYPE_FUNCTION(ASYM(nbif_list_to_binary_1))
#endif

#ifndef HAVE_nbif_ebif_list_to_binary_1
#define HAVE_nbif_ebif_list_to_binary_1
	GLOBAL(ASYM(nbif_ebif_list_to_binary_1))
ASYM(nbif_ebif_list_to_binary_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_list_to_binary_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_list_to_binary_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_list_to_binary_1))
#endif

#ifndef HAVE_nbif_list_to_float_1
#define HAVE_nbif_list_to_float_1
	GLOBAL(ASYM(nbif_list_to_float_1))
ASYM(nbif_list_to_float_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(list_to_float_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_list_to_float_1))
	TYPE_FUNCTION(ASYM(nbif_list_to_float_1))
#endif

#ifndef HAVE_nbif_ebif_string_to_float_1
#define HAVE_nbif_ebif_string_to_float_1
	GLOBAL(ASYM(nbif_ebif_string_to_float_1))
ASYM(nbif_ebif_string_to_float_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_string_to_float_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_string_to_float_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_string_to_float_1))
#endif

#ifndef HAVE_nbif_list_to_integer_1
#define HAVE_nbif_list_to_integer_1
	GLOBAL(ASYM(nbif_list_to_integer_1))
ASYM(nbif_list_to_integer_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(list_to_integer_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_list_to_integer_1))
	TYPE_FUNCTION(ASYM(nbif_list_to_integer_1))
#endif

#ifndef HAVE_nbif_ebif_string_to_integer_1
#define HAVE_nbif_ebif_string_to_integer_1
	GLOBAL(ASYM(nbif_ebif_string_to_integer_1))
ASYM(nbif_ebif_string_to_integer_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_string_to_integer_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_string_to_integer_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_string_to_integer_1))
#endif

#ifndef HAVE_nbif_list_to_pid_1
#define HAVE_nbif_list_to_pid_1
	GLOBAL(ASYM(nbif_list_to_pid_1))
ASYM(nbif_list_to_pid_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(list_to_pid_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_list_to_pid_1))
	TYPE_FUNCTION(ASYM(nbif_list_to_pid_1))
#endif

#ifndef HAVE_nbif_ebif_string_to_pid_1
#define HAVE_nbif_ebif_string_to_pid_1
	GLOBAL(ASYM(nbif_ebif_string_to_pid_1))
ASYM(nbif_ebif_string_to_pid_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_string_to_pid_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_string_to_pid_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_string_to_pid_1))
#endif

#ifndef HAVE_nbif_list_to_tuple_1
#define HAVE_nbif_list_to_tuple_1
	GLOBAL(ASYM(nbif_list_to_tuple_1))
ASYM(nbif_list_to_tuple_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(list_to_tuple_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_list_to_tuple_1))
	TYPE_FUNCTION(ASYM(nbif_list_to_tuple_1))
#endif

#ifndef HAVE_nbif_ebif_list_to_tuple_1
#define HAVE_nbif_ebif_list_to_tuple_1
	GLOBAL(ASYM(nbif_ebif_list_to_tuple_1))
ASYM(nbif_ebif_list_to_tuple_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_list_to_tuple_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_list_to_tuple_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_list_to_tuple_1))
#endif

#ifndef HAVE_nbif_load_module_2
#define HAVE_nbif_load_module_2
	GLOBAL(ASYM(nbif_load_module_2))
ASYM(nbif_load_module_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(load_module_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_load_module_2))
	TYPE_FUNCTION(ASYM(nbif_load_module_2))
#endif

#ifndef HAVE_nbif_ebif_load_module_2
#define HAVE_nbif_ebif_load_module_2
	GLOBAL(ASYM(nbif_ebif_load_module_2))
ASYM(nbif_ebif_load_module_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_load_module_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_load_module_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_load_module_2))
#endif

#ifndef HAVE_nbif_loaded_0
#define HAVE_nbif_loaded_0
	GLOBAL(ASYM(nbif_loaded_0))
ASYM(nbif_loaded_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(loaded_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_loaded_0))
	TYPE_FUNCTION(ASYM(nbif_loaded_0))
#endif

#ifndef HAVE_nbif_ebif_loaded_0
#define HAVE_nbif_ebif_loaded_0
	GLOBAL(ASYM(nbif_ebif_loaded_0))
ASYM(nbif_ebif_loaded_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_loaded_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_loaded_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_loaded_0))
#endif

#ifndef HAVE_nbif_localtime_0
#define HAVE_nbif_localtime_0
	GLOBAL(ASYM(nbif_localtime_0))
ASYM(nbif_localtime_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(localtime_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_localtime_0))
	TYPE_FUNCTION(ASYM(nbif_localtime_0))
#endif

#ifndef HAVE_nbif_ebif_localtime_0
#define HAVE_nbif_ebif_localtime_0
	GLOBAL(ASYM(nbif_ebif_localtime_0))
ASYM(nbif_ebif_localtime_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_localtime_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_localtime_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_localtime_0))
#endif

#ifndef HAVE_nbif_localtime_to_universaltime_2
#define HAVE_nbif_localtime_to_universaltime_2
	GLOBAL(ASYM(nbif_localtime_to_universaltime_2))
ASYM(nbif_localtime_to_universaltime_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(localtime_to_universaltime_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_localtime_to_universaltime_2))
	TYPE_FUNCTION(ASYM(nbif_localtime_to_universaltime_2))
#endif

#ifndef HAVE_nbif_ebif_localtime_to_universaltime_2
#define HAVE_nbif_ebif_localtime_to_universaltime_2
	GLOBAL(ASYM(nbif_ebif_localtime_to_universaltime_2))
ASYM(nbif_ebif_localtime_to_universaltime_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_localtime_to_universaltime_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_localtime_to_universaltime_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_localtime_to_universaltime_2))
#endif

#ifndef HAVE_nbif_make_ref_0
#define HAVE_nbif_make_ref_0
	GLOBAL(ASYM(nbif_make_ref_0))
ASYM(nbif_make_ref_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(make_ref_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_make_ref_0))
	TYPE_FUNCTION(ASYM(nbif_make_ref_0))
#endif

#ifndef HAVE_nbif_ebif_make_ref_0
#define HAVE_nbif_ebif_make_ref_0
	GLOBAL(ASYM(nbif_ebif_make_ref_0))
ASYM(nbif_ebif_make_ref_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_make_ref_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_make_ref_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_make_ref_0))
#endif

#ifndef HAVE_nbif_md5_1
#define HAVE_nbif_md5_1
	GLOBAL(ASYM(nbif_md5_1))
ASYM(nbif_md5_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(md5_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_md5_1))
	TYPE_FUNCTION(ASYM(nbif_md5_1))
#endif

#ifndef HAVE_nbif_ebif_md5_1
#define HAVE_nbif_ebif_md5_1
	GLOBAL(ASYM(nbif_ebif_md5_1))
ASYM(nbif_ebif_md5_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_md5_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_md5_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_md5_1))
#endif

#ifndef HAVE_nbif_md5_init_0
#define HAVE_nbif_md5_init_0
	GLOBAL(ASYM(nbif_md5_init_0))
ASYM(nbif_md5_init_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(md5_init_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_md5_init_0))
	TYPE_FUNCTION(ASYM(nbif_md5_init_0))
#endif

#ifndef HAVE_nbif_ebif_md5_init_0
#define HAVE_nbif_ebif_md5_init_0
	GLOBAL(ASYM(nbif_ebif_md5_init_0))
ASYM(nbif_ebif_md5_init_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_md5_init_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_md5_init_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_md5_init_0))
#endif

#ifndef HAVE_nbif_md5_update_2
#define HAVE_nbif_md5_update_2
	GLOBAL(ASYM(nbif_md5_update_2))
ASYM(nbif_md5_update_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(md5_update_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_md5_update_2))
	TYPE_FUNCTION(ASYM(nbif_md5_update_2))
#endif

#ifndef HAVE_nbif_ebif_md5_update_2
#define HAVE_nbif_ebif_md5_update_2
	GLOBAL(ASYM(nbif_ebif_md5_update_2))
ASYM(nbif_ebif_md5_update_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_md5_update_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_md5_update_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_md5_update_2))
#endif

#ifndef HAVE_nbif_md5_final_1
#define HAVE_nbif_md5_final_1
	GLOBAL(ASYM(nbif_md5_final_1))
ASYM(nbif_md5_final_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(md5_final_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_md5_final_1))
	TYPE_FUNCTION(ASYM(nbif_md5_final_1))
#endif

#ifndef HAVE_nbif_ebif_md5_final_1
#define HAVE_nbif_ebif_md5_final_1
	GLOBAL(ASYM(nbif_ebif_md5_final_1))
ASYM(nbif_ebif_md5_final_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_md5_final_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_md5_final_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_md5_final_1))
#endif

#ifndef HAVE_nbif_module_loaded_1
#define HAVE_nbif_module_loaded_1
	GLOBAL(ASYM(nbif_module_loaded_1))
ASYM(nbif_module_loaded_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(module_loaded_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_module_loaded_1))
	TYPE_FUNCTION(ASYM(nbif_module_loaded_1))
#endif

#ifndef HAVE_nbif_ebif_is_loaded_1
#define HAVE_nbif_ebif_is_loaded_1
	GLOBAL(ASYM(nbif_ebif_is_loaded_1))
ASYM(nbif_ebif_is_loaded_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_loaded_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_loaded_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_loaded_1))
#endif

#ifndef HAVE_nbif_function_exported_3
#define HAVE_nbif_function_exported_3
	GLOBAL(ASYM(nbif_function_exported_3))
ASYM(nbif_function_exported_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(function_exported_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_function_exported_3))
	TYPE_FUNCTION(ASYM(nbif_function_exported_3))
#endif

#ifndef HAVE_nbif_ebif_is_loaded_3
#define HAVE_nbif_ebif_is_loaded_3
	GLOBAL(ASYM(nbif_ebif_is_loaded_3))
ASYM(nbif_ebif_is_loaded_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_loaded_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_loaded_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_loaded_3))
#endif

#ifndef HAVE_nbif_monitor_node_2
#define HAVE_nbif_monitor_node_2
	GLOBAL(ASYM(nbif_monitor_node_2))
ASYM(nbif_monitor_node_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(monitor_node_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_monitor_node_2))
	TYPE_FUNCTION(ASYM(nbif_monitor_node_2))
#endif

#ifndef HAVE_nbif_ebif_monitor_node_2
#define HAVE_nbif_ebif_monitor_node_2
	GLOBAL(ASYM(nbif_ebif_monitor_node_2))
ASYM(nbif_ebif_monitor_node_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_monitor_node_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_monitor_node_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_monitor_node_2))
#endif

#ifndef HAVE_nbif_node_1
#define HAVE_nbif_node_1
	GLOBAL(ASYM(nbif_node_1))
ASYM(nbif_node_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(node_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_node_1))
	TYPE_FUNCTION(ASYM(nbif_node_1))
#endif

#ifndef HAVE_nbif_ebif_node_1
#define HAVE_nbif_ebif_node_1
	GLOBAL(ASYM(nbif_ebif_node_1))
ASYM(nbif_ebif_node_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_node_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_node_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_node_1))
#endif

#ifndef HAVE_nbif_node_0
#define HAVE_nbif_node_0
	GLOBAL(ASYM(nbif_node_0))
ASYM(nbif_node_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(node_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_node_0))
	TYPE_FUNCTION(ASYM(nbif_node_0))
#endif

#ifndef HAVE_nbif_ebif_node_0
#define HAVE_nbif_ebif_node_0
	GLOBAL(ASYM(nbif_ebif_node_0))
ASYM(nbif_ebif_node_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_node_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_node_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_node_0))
#endif

#ifndef HAVE_nbif_nodes_1
#define HAVE_nbif_nodes_1
	GLOBAL(ASYM(nbif_nodes_1))
ASYM(nbif_nodes_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(nodes_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_nodes_1))
	TYPE_FUNCTION(ASYM(nbif_nodes_1))
#endif

#ifndef HAVE_nbif_ebif_nodes_1
#define HAVE_nbif_ebif_nodes_1
	GLOBAL(ASYM(nbif_ebif_nodes_1))
ASYM(nbif_ebif_nodes_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_nodes_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_nodes_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_nodes_1))
#endif

#ifndef HAVE_nbif_now_0
#define HAVE_nbif_now_0
	GLOBAL(ASYM(nbif_now_0))
ASYM(nbif_now_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(now_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_now_0))
	TYPE_FUNCTION(ASYM(nbif_now_0))
#endif

#ifndef HAVE_nbif_ebif_now_0
#define HAVE_nbif_ebif_now_0
	GLOBAL(ASYM(nbif_ebif_now_0))
ASYM(nbif_ebif_now_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_now_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_now_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_now_0))
#endif

#ifndef HAVE_nbif_open_port_2
#define HAVE_nbif_open_port_2
	GLOBAL(ASYM(nbif_open_port_2))
ASYM(nbif_open_port_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(open_port_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_open_port_2))
	TYPE_FUNCTION(ASYM(nbif_open_port_2))
#endif

#ifndef HAVE_nbif_ebif_open_port_2
#define HAVE_nbif_ebif_open_port_2
	GLOBAL(ASYM(nbif_ebif_open_port_2))
ASYM(nbif_ebif_open_port_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_open_port_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_open_port_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_open_port_2))
#endif

#ifndef HAVE_nbif_pid_to_list_1
#define HAVE_nbif_pid_to_list_1
	GLOBAL(ASYM(nbif_pid_to_list_1))
ASYM(nbif_pid_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(pid_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_pid_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_pid_to_list_1))
#endif

#ifndef HAVE_nbif_ebif_pid_to_string_1
#define HAVE_nbif_ebif_pid_to_string_1
	GLOBAL(ASYM(nbif_ebif_pid_to_string_1))
ASYM(nbif_ebif_pid_to_string_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_pid_to_string_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_pid_to_string_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_pid_to_string_1))
#endif

#ifndef HAVE_nbif_port_info_1
#define HAVE_nbif_port_info_1
	GLOBAL(ASYM(nbif_port_info_1))
ASYM(nbif_port_info_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_info_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_port_info_1))
	TYPE_FUNCTION(ASYM(nbif_port_info_1))
#endif

#ifndef HAVE_nbif_ebif_port_info_1
#define HAVE_nbif_ebif_port_info_1
	GLOBAL(ASYM(nbif_ebif_port_info_1))
ASYM(nbif_ebif_port_info_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_info_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_info_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_info_1))
#endif

#ifndef HAVE_nbif_port_info_2
#define HAVE_nbif_port_info_2
	GLOBAL(ASYM(nbif_port_info_2))
ASYM(nbif_port_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_port_info_2))
	TYPE_FUNCTION(ASYM(nbif_port_info_2))
#endif

#ifndef HAVE_nbif_ebif_port_info_2
#define HAVE_nbif_ebif_port_info_2
	GLOBAL(ASYM(nbif_ebif_port_info_2))
ASYM(nbif_ebif_port_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_info_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_info_2))
#endif

#ifndef HAVE_nbif_ports_0
#define HAVE_nbif_ports_0
	GLOBAL(ASYM(nbif_ports_0))
ASYM(nbif_ports_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ports_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ports_0))
	TYPE_FUNCTION(ASYM(nbif_ports_0))
#endif

#ifndef HAVE_nbif_ebif_ports_0
#define HAVE_nbif_ebif_ports_0
	GLOBAL(ASYM(nbif_ebif_ports_0))
ASYM(nbif_ebif_ports_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ports_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ports_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_ports_0))
#endif

#ifndef HAVE_nbif_pre_loaded_0
#define HAVE_nbif_pre_loaded_0
	GLOBAL(ASYM(nbif_pre_loaded_0))
ASYM(nbif_pre_loaded_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(pre_loaded_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_pre_loaded_0))
	TYPE_FUNCTION(ASYM(nbif_pre_loaded_0))
#endif

#ifndef HAVE_nbif_ebif_pre_loaded_0
#define HAVE_nbif_ebif_pre_loaded_0
	GLOBAL(ASYM(nbif_ebif_pre_loaded_0))
ASYM(nbif_ebif_pre_loaded_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_pre_loaded_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_pre_loaded_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_pre_loaded_0))
#endif

#ifndef HAVE_nbif_process_flag_2
#define HAVE_nbif_process_flag_2
	GLOBAL(ASYM(nbif_process_flag_2))
ASYM(nbif_process_flag_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(process_flag_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_process_flag_2))
	TYPE_FUNCTION(ASYM(nbif_process_flag_2))
#endif

#ifndef HAVE_nbif_ebif_process_flag_2
#define HAVE_nbif_ebif_process_flag_2
	GLOBAL(ASYM(nbif_ebif_process_flag_2))
ASYM(nbif_ebif_process_flag_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_process_flag_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_process_flag_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_process_flag_2))
#endif

#ifndef HAVE_nbif_process_flag_3
#define HAVE_nbif_process_flag_3
	GLOBAL(ASYM(nbif_process_flag_3))
ASYM(nbif_process_flag_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(process_flag_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_process_flag_3))
	TYPE_FUNCTION(ASYM(nbif_process_flag_3))
#endif

#ifndef HAVE_nbif_ebif_process_flag_3
#define HAVE_nbif_ebif_process_flag_3
	GLOBAL(ASYM(nbif_ebif_process_flag_3))
ASYM(nbif_ebif_process_flag_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_process_flag_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_process_flag_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_process_flag_3))
#endif

#ifndef HAVE_nbif_process_info_1
#define HAVE_nbif_process_info_1
	GLOBAL(ASYM(nbif_process_info_1))
ASYM(nbif_process_info_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(process_info_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_process_info_1))
	TYPE_FUNCTION(ASYM(nbif_process_info_1))
#endif

#ifndef HAVE_nbif_ebif_process_info_1
#define HAVE_nbif_ebif_process_info_1
	GLOBAL(ASYM(nbif_ebif_process_info_1))
ASYM(nbif_ebif_process_info_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_process_info_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_process_info_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_process_info_1))
#endif

#ifndef HAVE_nbif_process_info_2
#define HAVE_nbif_process_info_2
	GLOBAL(ASYM(nbif_process_info_2))
ASYM(nbif_process_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(process_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_process_info_2))
	TYPE_FUNCTION(ASYM(nbif_process_info_2))
#endif

#ifndef HAVE_nbif_ebif_process_info_2
#define HAVE_nbif_ebif_process_info_2
	GLOBAL(ASYM(nbif_ebif_process_info_2))
ASYM(nbif_ebif_process_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_process_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_process_info_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_process_info_2))
#endif

#ifndef HAVE_nbif_processes_0
#define HAVE_nbif_processes_0
	GLOBAL(ASYM(nbif_processes_0))
ASYM(nbif_processes_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(processes_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_processes_0))
	TYPE_FUNCTION(ASYM(nbif_processes_0))
#endif

#ifndef HAVE_nbif_ebif_processes_0
#define HAVE_nbif_ebif_processes_0
	GLOBAL(ASYM(nbif_ebif_processes_0))
ASYM(nbif_ebif_processes_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_processes_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_processes_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_processes_0))
#endif

#ifndef HAVE_nbif_purge_module_1
#define HAVE_nbif_purge_module_1
	GLOBAL(ASYM(nbif_purge_module_1))
ASYM(nbif_purge_module_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(purge_module_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_purge_module_1))
	TYPE_FUNCTION(ASYM(nbif_purge_module_1))
#endif

#ifndef HAVE_nbif_ebif_purge_module_1
#define HAVE_nbif_ebif_purge_module_1
	GLOBAL(ASYM(nbif_ebif_purge_module_1))
ASYM(nbif_ebif_purge_module_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_purge_module_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_purge_module_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_purge_module_1))
#endif

#ifndef HAVE_nbif_put_2
#define HAVE_nbif_put_2
	GLOBAL(ASYM(nbif_put_2))
ASYM(nbif_put_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(put_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_put_2))
	TYPE_FUNCTION(ASYM(nbif_put_2))
#endif

#ifndef HAVE_nbif_ebif_put_2
#define HAVE_nbif_ebif_put_2
	GLOBAL(ASYM(nbif_ebif_put_2))
ASYM(nbif_ebif_put_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_put_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_put_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_put_2))
#endif

#ifndef HAVE_nbif_register_2
#define HAVE_nbif_register_2
	GLOBAL(ASYM(nbif_register_2))
ASYM(nbif_register_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(register_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_register_2))
	TYPE_FUNCTION(ASYM(nbif_register_2))
#endif

#ifndef HAVE_nbif_ebif_register_2
#define HAVE_nbif_ebif_register_2
	GLOBAL(ASYM(nbif_ebif_register_2))
ASYM(nbif_ebif_register_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_register_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_register_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_register_2))
#endif

#ifndef HAVE_nbif_registered_0
#define HAVE_nbif_registered_0
	GLOBAL(ASYM(nbif_registered_0))
ASYM(nbif_registered_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(registered_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_registered_0))
	TYPE_FUNCTION(ASYM(nbif_registered_0))
#endif

#ifndef HAVE_nbif_ebif_registered_0
#define HAVE_nbif_ebif_registered_0
	GLOBAL(ASYM(nbif_ebif_registered_0))
ASYM(nbif_ebif_registered_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_registered_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_registered_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_registered_0))
#endif

#ifndef HAVE_nbif_round_1
#define HAVE_nbif_round_1
	GLOBAL(ASYM(nbif_round_1))
ASYM(nbif_round_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(round_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_round_1))
	TYPE_FUNCTION(ASYM(nbif_round_1))
#endif

#ifndef HAVE_nbif_ebif_round_1
#define HAVE_nbif_ebif_round_1
	GLOBAL(ASYM(nbif_ebif_round_1))
ASYM(nbif_ebif_round_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_round_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_round_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_round_1))
#endif

#ifndef HAVE_nbif_self_0
#define HAVE_nbif_self_0
	GLOBAL(ASYM(nbif_self_0))
ASYM(nbif_self_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(self_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_self_0))
	TYPE_FUNCTION(ASYM(nbif_self_0))
#endif

#ifndef HAVE_nbif_ebif_self_0
#define HAVE_nbif_ebif_self_0
	GLOBAL(ASYM(nbif_ebif_self_0))
ASYM(nbif_ebif_self_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_self_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_self_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_self_0))
#endif

#ifndef HAVE_nbif_setelement_3
#define HAVE_nbif_setelement_3
	GLOBAL(ASYM(nbif_setelement_3))
ASYM(nbif_setelement_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(setelement_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_setelement_3))
	TYPE_FUNCTION(ASYM(nbif_setelement_3))
#endif

#ifndef HAVE_nbif_ebif_setelement_3
#define HAVE_nbif_ebif_setelement_3
	GLOBAL(ASYM(nbif_ebif_setelement_3))
ASYM(nbif_ebif_setelement_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_setelement_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_setelement_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_setelement_3))
#endif

#ifndef HAVE_nbif_size_1
#define HAVE_nbif_size_1
	GLOBAL(ASYM(nbif_size_1))
ASYM(nbif_size_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(size_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_size_1))
	TYPE_FUNCTION(ASYM(nbif_size_1))
#endif

#ifndef HAVE_nbif_ebif_size_1
#define HAVE_nbif_ebif_size_1
	GLOBAL(ASYM(nbif_ebif_size_1))
ASYM(nbif_ebif_size_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_size_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_size_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_size_1))
#endif

#ifndef HAVE_nbif_spawn_3
#define HAVE_nbif_spawn_3
	GLOBAL(ASYM(nbif_spawn_3))
ASYM(nbif_spawn_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(spawn_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_spawn_3))
	TYPE_FUNCTION(ASYM(nbif_spawn_3))
#endif

#ifndef HAVE_nbif_ebif_spawn_3
#define HAVE_nbif_ebif_spawn_3
	GLOBAL(ASYM(nbif_ebif_spawn_3))
ASYM(nbif_ebif_spawn_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_spawn_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_spawn_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_spawn_3))
#endif

#ifndef HAVE_nbif_spawn_link_3
#define HAVE_nbif_spawn_link_3
	GLOBAL(ASYM(nbif_spawn_link_3))
ASYM(nbif_spawn_link_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(spawn_link_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_spawn_link_3))
	TYPE_FUNCTION(ASYM(nbif_spawn_link_3))
#endif

#ifndef HAVE_nbif_ebif_spawn_link_3
#define HAVE_nbif_ebif_spawn_link_3
	GLOBAL(ASYM(nbif_ebif_spawn_link_3))
ASYM(nbif_ebif_spawn_link_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_spawn_link_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_spawn_link_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_spawn_link_3))
#endif

#ifndef HAVE_nbif_split_binary_2
#define HAVE_nbif_split_binary_2
	GLOBAL(ASYM(nbif_split_binary_2))
ASYM(nbif_split_binary_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(split_binary_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_split_binary_2))
	TYPE_FUNCTION(ASYM(nbif_split_binary_2))
#endif

#ifndef HAVE_nbif_ebif_split_binary_2
#define HAVE_nbif_ebif_split_binary_2
	GLOBAL(ASYM(nbif_ebif_split_binary_2))
ASYM(nbif_ebif_split_binary_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_split_binary_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_split_binary_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_split_binary_2))
#endif

#ifndef HAVE_nbif_statistics_1
#define HAVE_nbif_statistics_1
	GLOBAL(ASYM(nbif_statistics_1))
ASYM(nbif_statistics_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(statistics_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_statistics_1))
	TYPE_FUNCTION(ASYM(nbif_statistics_1))
#endif

#ifndef HAVE_nbif_ebif_statistics_1
#define HAVE_nbif_ebif_statistics_1
	GLOBAL(ASYM(nbif_ebif_statistics_1))
ASYM(nbif_ebif_statistics_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_statistics_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_statistics_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_statistics_1))
#endif

#ifndef HAVE_nbif_term_to_binary_1
#define HAVE_nbif_term_to_binary_1
	GLOBAL(ASYM(nbif_term_to_binary_1))
ASYM(nbif_term_to_binary_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(term_to_binary_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_term_to_binary_1))
	TYPE_FUNCTION(ASYM(nbif_term_to_binary_1))
#endif

#ifndef HAVE_nbif_ebif_term_to_binary_1
#define HAVE_nbif_ebif_term_to_binary_1
	GLOBAL(ASYM(nbif_ebif_term_to_binary_1))
ASYM(nbif_ebif_term_to_binary_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_term_to_binary_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_term_to_binary_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_term_to_binary_1))
#endif

#ifndef HAVE_nbif_term_to_binary_2
#define HAVE_nbif_term_to_binary_2
	GLOBAL(ASYM(nbif_term_to_binary_2))
ASYM(nbif_term_to_binary_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(term_to_binary_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_term_to_binary_2))
	TYPE_FUNCTION(ASYM(nbif_term_to_binary_2))
#endif

#ifndef HAVE_nbif_ebif_term_to_binary_2
#define HAVE_nbif_ebif_term_to_binary_2
	GLOBAL(ASYM(nbif_ebif_term_to_binary_2))
ASYM(nbif_ebif_term_to_binary_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_term_to_binary_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_term_to_binary_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_term_to_binary_2))
#endif

#ifndef HAVE_nbif_throw_1
#define HAVE_nbif_throw_1
	GLOBAL(ASYM(nbif_throw_1))
ASYM(nbif_throw_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(throw_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_throw_1))
	TYPE_FUNCTION(ASYM(nbif_throw_1))
#endif

#ifndef HAVE_nbif_ebif_throw_1
#define HAVE_nbif_ebif_throw_1
	GLOBAL(ASYM(nbif_ebif_throw_1))
ASYM(nbif_ebif_throw_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_throw_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_throw_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_throw_1))
#endif

#ifndef HAVE_nbif_time_0
#define HAVE_nbif_time_0
	GLOBAL(ASYM(nbif_time_0))
ASYM(nbif_time_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(time_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_time_0))
	TYPE_FUNCTION(ASYM(nbif_time_0))
#endif

#ifndef HAVE_nbif_ebif_time_0
#define HAVE_nbif_ebif_time_0
	GLOBAL(ASYM(nbif_ebif_time_0))
ASYM(nbif_ebif_time_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_time_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_time_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_time_0))
#endif

#ifndef HAVE_nbif_tl_1
#define HAVE_nbif_tl_1
	GLOBAL(ASYM(nbif_tl_1))
ASYM(nbif_tl_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(tl_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_tl_1))
	TYPE_FUNCTION(ASYM(nbif_tl_1))
#endif

#ifndef HAVE_nbif_ebif_tl_1
#define HAVE_nbif_ebif_tl_1
	GLOBAL(ASYM(nbif_ebif_tl_1))
ASYM(nbif_ebif_tl_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_tl_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_tl_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_tl_1))
#endif

#ifndef HAVE_nbif_trunc_1
#define HAVE_nbif_trunc_1
	GLOBAL(ASYM(nbif_trunc_1))
ASYM(nbif_trunc_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(trunc_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_trunc_1))
	TYPE_FUNCTION(ASYM(nbif_trunc_1))
#endif

#ifndef HAVE_nbif_ebif_trunc_1
#define HAVE_nbif_ebif_trunc_1
	GLOBAL(ASYM(nbif_ebif_trunc_1))
ASYM(nbif_ebif_trunc_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_trunc_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_trunc_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_trunc_1))
#endif

#ifndef HAVE_nbif_tuple_to_list_1
#define HAVE_nbif_tuple_to_list_1
	GLOBAL(ASYM(nbif_tuple_to_list_1))
ASYM(nbif_tuple_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(tuple_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_tuple_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_tuple_to_list_1))
#endif

#ifndef HAVE_nbif_ebif_tuple_to_list_1
#define HAVE_nbif_ebif_tuple_to_list_1
	GLOBAL(ASYM(nbif_ebif_tuple_to_list_1))
ASYM(nbif_ebif_tuple_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_tuple_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_tuple_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_tuple_to_list_1))
#endif

#ifndef HAVE_nbif_universaltime_0
#define HAVE_nbif_universaltime_0
	GLOBAL(ASYM(nbif_universaltime_0))
ASYM(nbif_universaltime_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(universaltime_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_universaltime_0))
	TYPE_FUNCTION(ASYM(nbif_universaltime_0))
#endif

#ifndef HAVE_nbif_ebif_universaltime_0
#define HAVE_nbif_ebif_universaltime_0
	GLOBAL(ASYM(nbif_ebif_universaltime_0))
ASYM(nbif_ebif_universaltime_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_universaltime_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_universaltime_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_universaltime_0))
#endif

#ifndef HAVE_nbif_universaltime_to_localtime_1
#define HAVE_nbif_universaltime_to_localtime_1
	GLOBAL(ASYM(nbif_universaltime_to_localtime_1))
ASYM(nbif_universaltime_to_localtime_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(universaltime_to_localtime_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_universaltime_to_localtime_1))
	TYPE_FUNCTION(ASYM(nbif_universaltime_to_localtime_1))
#endif

#ifndef HAVE_nbif_ebif_universaltime_to_localtime_1
#define HAVE_nbif_ebif_universaltime_to_localtime_1
	GLOBAL(ASYM(nbif_ebif_universaltime_to_localtime_1))
ASYM(nbif_ebif_universaltime_to_localtime_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_universaltime_to_localtime_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_universaltime_to_localtime_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_universaltime_to_localtime_1))
#endif

#ifndef HAVE_nbif_unlink_1
#define HAVE_nbif_unlink_1
	GLOBAL(ASYM(nbif_unlink_1))
ASYM(nbif_unlink_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(unlink_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_unlink_1))
	TYPE_FUNCTION(ASYM(nbif_unlink_1))
#endif

#ifndef HAVE_nbif_ebif_unlink_1
#define HAVE_nbif_ebif_unlink_1
	GLOBAL(ASYM(nbif_ebif_unlink_1))
ASYM(nbif_ebif_unlink_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_unlink_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_unlink_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_unlink_1))
#endif

#ifndef HAVE_nbif_unregister_1
#define HAVE_nbif_unregister_1
	GLOBAL(ASYM(nbif_unregister_1))
ASYM(nbif_unregister_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(unregister_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_unregister_1))
	TYPE_FUNCTION(ASYM(nbif_unregister_1))
#endif

#ifndef HAVE_nbif_ebif_unregister_1
#define HAVE_nbif_ebif_unregister_1
	GLOBAL(ASYM(nbif_ebif_unregister_1))
ASYM(nbif_ebif_unregister_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_unregister_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_unregister_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_unregister_1))
#endif

#ifndef HAVE_nbif_whereis_1
#define HAVE_nbif_whereis_1
	GLOBAL(ASYM(nbif_whereis_1))
ASYM(nbif_whereis_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(whereis_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_whereis_1))
	TYPE_FUNCTION(ASYM(nbif_whereis_1))
#endif

#ifndef HAVE_nbif_ebif_whereis_1
#define HAVE_nbif_ebif_whereis_1
	GLOBAL(ASYM(nbif_ebif_whereis_1))
ASYM(nbif_ebif_whereis_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_whereis_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_whereis_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_whereis_1))
#endif

#ifndef HAVE_nbif_spawn_opt_1
#define HAVE_nbif_spawn_opt_1
	GLOBAL(ASYM(nbif_spawn_opt_1))
ASYM(nbif_spawn_opt_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(spawn_opt_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_spawn_opt_1))
	TYPE_FUNCTION(ASYM(nbif_spawn_opt_1))
#endif

#ifndef HAVE_nbif_ebif_spawn_opt_1
#define HAVE_nbif_ebif_spawn_opt_1
	GLOBAL(ASYM(nbif_ebif_spawn_opt_1))
ASYM(nbif_ebif_spawn_opt_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_spawn_opt_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_spawn_opt_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_spawn_opt_1))
#endif

#ifndef HAVE_nbif_setnode_2
#define HAVE_nbif_setnode_2
	GLOBAL(ASYM(nbif_setnode_2))
ASYM(nbif_setnode_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(setnode_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_setnode_2))
	TYPE_FUNCTION(ASYM(nbif_setnode_2))
#endif

#ifndef HAVE_nbif_setnode_3
#define HAVE_nbif_setnode_3
	GLOBAL(ASYM(nbif_setnode_3))
ASYM(nbif_setnode_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(setnode_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_setnode_3))
	TYPE_FUNCTION(ASYM(nbif_setnode_3))
#endif

#ifndef HAVE_nbif_dist_exit_3
#define HAVE_nbif_dist_exit_3
	GLOBAL(ASYM(nbif_dist_exit_3))
ASYM(nbif_dist_exit_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(dist_exit_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_dist_exit_3))
	TYPE_FUNCTION(ASYM(nbif_dist_exit_3))
#endif

#ifndef HAVE_nbif_dist_unlink_2
#define HAVE_nbif_dist_unlink_2
	GLOBAL(ASYM(nbif_dist_unlink_2))
ASYM(nbif_dist_unlink_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(dist_unlink_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_dist_unlink_2))
	TYPE_FUNCTION(ASYM(nbif_dist_unlink_2))
#endif

#ifndef HAVE_nbif_dist_link_2
#define HAVE_nbif_dist_link_2
	GLOBAL(ASYM(nbif_dist_link_2))
ASYM(nbif_dist_link_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(dist_link_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_dist_link_2))
	TYPE_FUNCTION(ASYM(nbif_dist_link_2))
#endif

#ifndef HAVE_nbif_port_call_2
#define HAVE_nbif_port_call_2
	GLOBAL(ASYM(nbif_port_call_2))
ASYM(nbif_port_call_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_call_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_port_call_2))
	TYPE_FUNCTION(ASYM(nbif_port_call_2))
#endif

#ifndef HAVE_nbif_ebif_port_call_2
#define HAVE_nbif_ebif_port_call_2
	GLOBAL(ASYM(nbif_ebif_port_call_2))
ASYM(nbif_ebif_port_call_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_call_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_call_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_call_2))
#endif

#ifndef HAVE_nbif_port_call_3
#define HAVE_nbif_port_call_3
	GLOBAL(ASYM(nbif_port_call_3))
ASYM(nbif_port_call_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_call_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_port_call_3))
	TYPE_FUNCTION(ASYM(nbif_port_call_3))
#endif

#ifndef HAVE_nbif_ebif_port_call_3
#define HAVE_nbif_ebif_port_call_3
	GLOBAL(ASYM(nbif_ebif_port_call_3))
ASYM(nbif_ebif_port_call_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_call_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_call_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_call_3))
#endif

#ifndef HAVE_nbif_port_command_2
#define HAVE_nbif_port_command_2
	GLOBAL(ASYM(nbif_port_command_2))
ASYM(nbif_port_command_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_command_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_port_command_2))
	TYPE_FUNCTION(ASYM(nbif_port_command_2))
#endif

#ifndef HAVE_nbif_ebif_port_command_2
#define HAVE_nbif_ebif_port_command_2
	GLOBAL(ASYM(nbif_ebif_port_command_2))
ASYM(nbif_ebif_port_command_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_command_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_command_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_command_2))
#endif

#ifndef HAVE_nbif_port_control_3
#define HAVE_nbif_port_control_3
	GLOBAL(ASYM(nbif_port_control_3))
ASYM(nbif_port_control_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_control_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_port_control_3))
	TYPE_FUNCTION(ASYM(nbif_port_control_3))
#endif

#ifndef HAVE_nbif_ebif_port_control_3
#define HAVE_nbif_ebif_port_control_3
	GLOBAL(ASYM(nbif_ebif_port_control_3))
ASYM(nbif_ebif_port_control_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_control_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_control_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_control_3))
#endif

#ifndef HAVE_nbif_port_close_1
#define HAVE_nbif_port_close_1
	GLOBAL(ASYM(nbif_port_close_1))
ASYM(nbif_port_close_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_close_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_port_close_1))
	TYPE_FUNCTION(ASYM(nbif_port_close_1))
#endif

#ifndef HAVE_nbif_ebif_port_close_1
#define HAVE_nbif_ebif_port_close_1
	GLOBAL(ASYM(nbif_ebif_port_close_1))
ASYM(nbif_ebif_port_close_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_close_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_close_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_close_1))
#endif

#ifndef HAVE_nbif_port_connect_2
#define HAVE_nbif_port_connect_2
	GLOBAL(ASYM(nbif_port_connect_2))
ASYM(nbif_port_connect_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_connect_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_port_connect_2))
	TYPE_FUNCTION(ASYM(nbif_port_connect_2))
#endif

#ifndef HAVE_nbif_ebif_port_connect_2
#define HAVE_nbif_ebif_port_connect_2
	GLOBAL(ASYM(nbif_ebif_port_connect_2))
ASYM(nbif_ebif_port_connect_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_connect_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_connect_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_connect_2))
#endif

#ifndef HAVE_nbif_port_set_data_2
#define HAVE_nbif_port_set_data_2
	GLOBAL(ASYM(nbif_port_set_data_2))
ASYM(nbif_port_set_data_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_set_data_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_port_set_data_2))
	TYPE_FUNCTION(ASYM(nbif_port_set_data_2))
#endif

#ifndef HAVE_nbif_ebif_port_set_data_2
#define HAVE_nbif_ebif_port_set_data_2
	GLOBAL(ASYM(nbif_ebif_port_set_data_2))
ASYM(nbif_ebif_port_set_data_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_set_data_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_set_data_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_set_data_2))
#endif

#ifndef HAVE_nbif_port_get_data_1
#define HAVE_nbif_port_get_data_1
	GLOBAL(ASYM(nbif_port_get_data_1))
ASYM(nbif_port_get_data_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_get_data_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_port_get_data_1))
	TYPE_FUNCTION(ASYM(nbif_port_get_data_1))
#endif

#ifndef HAVE_nbif_ebif_port_get_data_1
#define HAVE_nbif_ebif_port_get_data_1
	GLOBAL(ASYM(nbif_ebif_port_get_data_1))
ASYM(nbif_ebif_port_get_data_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_get_data_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_get_data_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_get_data_1))
#endif

#ifndef HAVE_nbif_trace_pattern_2
#define HAVE_nbif_trace_pattern_2
	GLOBAL(ASYM(nbif_trace_pattern_2))
ASYM(nbif_trace_pattern_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(trace_pattern_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_trace_pattern_2))
	TYPE_FUNCTION(ASYM(nbif_trace_pattern_2))
#endif

#ifndef HAVE_nbif_ebif_trace_pattern_2
#define HAVE_nbif_ebif_trace_pattern_2
	GLOBAL(ASYM(nbif_ebif_trace_pattern_2))
ASYM(nbif_ebif_trace_pattern_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_trace_pattern_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_trace_pattern_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_trace_pattern_2))
#endif

#ifndef HAVE_nbif_trace_pattern_3
#define HAVE_nbif_trace_pattern_3
	GLOBAL(ASYM(nbif_trace_pattern_3))
ASYM(nbif_trace_pattern_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(trace_pattern_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_trace_pattern_3))
	TYPE_FUNCTION(ASYM(nbif_trace_pattern_3))
#endif

#ifndef HAVE_nbif_ebif_trace_pattern_3
#define HAVE_nbif_ebif_trace_pattern_3
	GLOBAL(ASYM(nbif_ebif_trace_pattern_3))
ASYM(nbif_ebif_trace_pattern_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_trace_pattern_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_trace_pattern_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_trace_pattern_3))
#endif

#ifndef HAVE_nbif_trace_3
#define HAVE_nbif_trace_3
	GLOBAL(ASYM(nbif_trace_3))
ASYM(nbif_trace_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(trace_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_trace_3))
	TYPE_FUNCTION(ASYM(nbif_trace_3))
#endif

#ifndef HAVE_nbif_ebif_trace_3
#define HAVE_nbif_ebif_trace_3
	GLOBAL(ASYM(nbif_ebif_trace_3))
ASYM(nbif_ebif_trace_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_trace_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_trace_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_trace_3))
#endif

#ifndef HAVE_nbif_trace_info_2
#define HAVE_nbif_trace_info_2
	GLOBAL(ASYM(nbif_trace_info_2))
ASYM(nbif_trace_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(trace_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_trace_info_2))
	TYPE_FUNCTION(ASYM(nbif_trace_info_2))
#endif

#ifndef HAVE_nbif_ebif_trace_info_2
#define HAVE_nbif_ebif_trace_info_2
	GLOBAL(ASYM(nbif_ebif_trace_info_2))
ASYM(nbif_ebif_trace_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_trace_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_trace_info_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_trace_info_2))
#endif

#ifndef HAVE_nbif_seq_trace_2
#define HAVE_nbif_seq_trace_2
	GLOBAL(ASYM(nbif_seq_trace_2))
ASYM(nbif_seq_trace_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(seq_trace_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_seq_trace_2))
	TYPE_FUNCTION(ASYM(nbif_seq_trace_2))
#endif

#ifndef HAVE_nbif_ebif_seq_trace_2
#define HAVE_nbif_ebif_seq_trace_2
	GLOBAL(ASYM(nbif_ebif_seq_trace_2))
ASYM(nbif_ebif_seq_trace_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_seq_trace_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_seq_trace_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_seq_trace_2))
#endif

#ifndef HAVE_nbif_seq_trace_info_1
#define HAVE_nbif_seq_trace_info_1
	GLOBAL(ASYM(nbif_seq_trace_info_1))
ASYM(nbif_seq_trace_info_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(seq_trace_info_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_seq_trace_info_1))
	TYPE_FUNCTION(ASYM(nbif_seq_trace_info_1))
#endif

#ifndef HAVE_nbif_ebif_seq_trace_info_1
#define HAVE_nbif_ebif_seq_trace_info_1
	GLOBAL(ASYM(nbif_ebif_seq_trace_info_1))
ASYM(nbif_ebif_seq_trace_info_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_seq_trace_info_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_seq_trace_info_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_seq_trace_info_1))
#endif

#ifndef HAVE_nbif_seq_trace_print_1
#define HAVE_nbif_seq_trace_print_1
	GLOBAL(ASYM(nbif_seq_trace_print_1))
ASYM(nbif_seq_trace_print_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(seq_trace_print_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_seq_trace_print_1))
	TYPE_FUNCTION(ASYM(nbif_seq_trace_print_1))
#endif

#ifndef HAVE_nbif_ebif_seq_trace_print_1
#define HAVE_nbif_ebif_seq_trace_print_1
	GLOBAL(ASYM(nbif_ebif_seq_trace_print_1))
ASYM(nbif_ebif_seq_trace_print_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_seq_trace_print_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_seq_trace_print_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_seq_trace_print_1))
#endif

#ifndef HAVE_nbif_seq_trace_print_2
#define HAVE_nbif_seq_trace_print_2
	GLOBAL(ASYM(nbif_seq_trace_print_2))
ASYM(nbif_seq_trace_print_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(seq_trace_print_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_seq_trace_print_2))
	TYPE_FUNCTION(ASYM(nbif_seq_trace_print_2))
#endif

#ifndef HAVE_nbif_ebif_seq_trace_print_2
#define HAVE_nbif_ebif_seq_trace_print_2
	GLOBAL(ASYM(nbif_ebif_seq_trace_print_2))
ASYM(nbif_ebif_seq_trace_print_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_seq_trace_print_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_seq_trace_print_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_seq_trace_print_2))
#endif

#ifndef HAVE_nbif_suspend_process_1
#define HAVE_nbif_suspend_process_1
	GLOBAL(ASYM(nbif_suspend_process_1))
ASYM(nbif_suspend_process_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(suspend_process_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_suspend_process_1))
	TYPE_FUNCTION(ASYM(nbif_suspend_process_1))
#endif

#ifndef HAVE_nbif_ebif_suspend_process_1
#define HAVE_nbif_ebif_suspend_process_1
	GLOBAL(ASYM(nbif_ebif_suspend_process_1))
ASYM(nbif_ebif_suspend_process_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_suspend_process_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_suspend_process_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_suspend_process_1))
#endif

#ifndef HAVE_nbif_resume_process_1
#define HAVE_nbif_resume_process_1
	GLOBAL(ASYM(nbif_resume_process_1))
ASYM(nbif_resume_process_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(resume_process_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_resume_process_1))
	TYPE_FUNCTION(ASYM(nbif_resume_process_1))
#endif

#ifndef HAVE_nbif_ebif_resume_process_1
#define HAVE_nbif_ebif_resume_process_1
	GLOBAL(ASYM(nbif_ebif_resume_process_1))
ASYM(nbif_ebif_resume_process_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_resume_process_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_resume_process_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_resume_process_1))
#endif

#ifndef HAVE_nbif_process_display_2
#define HAVE_nbif_process_display_2
	GLOBAL(ASYM(nbif_process_display_2))
ASYM(nbif_process_display_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(process_display_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_process_display_2))
	TYPE_FUNCTION(ASYM(nbif_process_display_2))
#endif

#ifndef HAVE_nbif_ebif_process_display_2
#define HAVE_nbif_ebif_process_display_2
	GLOBAL(ASYM(nbif_ebif_process_display_2))
ASYM(nbif_ebif_process_display_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_process_display_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_process_display_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_process_display_2))
#endif

#ifndef HAVE_nbif_bump_reductions_1
#define HAVE_nbif_bump_reductions_1
	GLOBAL(ASYM(nbif_bump_reductions_1))
ASYM(nbif_bump_reductions_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bump_reductions_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_bump_reductions_1))
	TYPE_FUNCTION(ASYM(nbif_bump_reductions_1))
#endif

#ifndef HAVE_nbif_ebif_bump_reductions_1
#define HAVE_nbif_ebif_bump_reductions_1
	GLOBAL(ASYM(nbif_ebif_bump_reductions_1))
ASYM(nbif_ebif_bump_reductions_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_bump_reductions_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_bump_reductions_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_bump_reductions_1))
#endif

#ifndef HAVE_nbif_math_cos_1
#define HAVE_nbif_math_cos_1
	GLOBAL(ASYM(nbif_math_cos_1))
ASYM(nbif_math_cos_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_cos_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_cos_1))
	TYPE_FUNCTION(ASYM(nbif_math_cos_1))
#endif

#ifndef HAVE_nbif_ebif_math_cos_1
#define HAVE_nbif_ebif_math_cos_1
	GLOBAL(ASYM(nbif_ebif_math_cos_1))
ASYM(nbif_ebif_math_cos_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_cos_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_cos_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_cos_1))
#endif

#ifndef HAVE_nbif_math_cosh_1
#define HAVE_nbif_math_cosh_1
	GLOBAL(ASYM(nbif_math_cosh_1))
ASYM(nbif_math_cosh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_cosh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_cosh_1))
	TYPE_FUNCTION(ASYM(nbif_math_cosh_1))
#endif

#ifndef HAVE_nbif_ebif_math_cosh_1
#define HAVE_nbif_ebif_math_cosh_1
	GLOBAL(ASYM(nbif_ebif_math_cosh_1))
ASYM(nbif_ebif_math_cosh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_cosh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_cosh_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_cosh_1))
#endif

#ifndef HAVE_nbif_math_sin_1
#define HAVE_nbif_math_sin_1
	GLOBAL(ASYM(nbif_math_sin_1))
ASYM(nbif_math_sin_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_sin_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_sin_1))
	TYPE_FUNCTION(ASYM(nbif_math_sin_1))
#endif

#ifndef HAVE_nbif_ebif_math_sin_1
#define HAVE_nbif_ebif_math_sin_1
	GLOBAL(ASYM(nbif_ebif_math_sin_1))
ASYM(nbif_ebif_math_sin_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_sin_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_sin_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_sin_1))
#endif

#ifndef HAVE_nbif_math_sinh_1
#define HAVE_nbif_math_sinh_1
	GLOBAL(ASYM(nbif_math_sinh_1))
ASYM(nbif_math_sinh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_sinh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_sinh_1))
	TYPE_FUNCTION(ASYM(nbif_math_sinh_1))
#endif

#ifndef HAVE_nbif_ebif_math_sinh_1
#define HAVE_nbif_ebif_math_sinh_1
	GLOBAL(ASYM(nbif_ebif_math_sinh_1))
ASYM(nbif_ebif_math_sinh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_sinh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_sinh_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_sinh_1))
#endif

#ifndef HAVE_nbif_math_tan_1
#define HAVE_nbif_math_tan_1
	GLOBAL(ASYM(nbif_math_tan_1))
ASYM(nbif_math_tan_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_tan_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_tan_1))
	TYPE_FUNCTION(ASYM(nbif_math_tan_1))
#endif

#ifndef HAVE_nbif_ebif_math_tan_1
#define HAVE_nbif_ebif_math_tan_1
	GLOBAL(ASYM(nbif_ebif_math_tan_1))
ASYM(nbif_ebif_math_tan_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_tan_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_tan_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_tan_1))
#endif

#ifndef HAVE_nbif_math_tanh_1
#define HAVE_nbif_math_tanh_1
	GLOBAL(ASYM(nbif_math_tanh_1))
ASYM(nbif_math_tanh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_tanh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_tanh_1))
	TYPE_FUNCTION(ASYM(nbif_math_tanh_1))
#endif

#ifndef HAVE_nbif_ebif_math_tanh_1
#define HAVE_nbif_ebif_math_tanh_1
	GLOBAL(ASYM(nbif_ebif_math_tanh_1))
ASYM(nbif_ebif_math_tanh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_tanh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_tanh_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_tanh_1))
#endif

#ifndef HAVE_nbif_math_acos_1
#define HAVE_nbif_math_acos_1
	GLOBAL(ASYM(nbif_math_acos_1))
ASYM(nbif_math_acos_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_acos_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_acos_1))
	TYPE_FUNCTION(ASYM(nbif_math_acos_1))
#endif

#ifndef HAVE_nbif_ebif_math_acos_1
#define HAVE_nbif_ebif_math_acos_1
	GLOBAL(ASYM(nbif_ebif_math_acos_1))
ASYM(nbif_ebif_math_acos_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_acos_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_acos_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_acos_1))
#endif

#ifndef HAVE_nbif_math_acosh_1
#define HAVE_nbif_math_acosh_1
	GLOBAL(ASYM(nbif_math_acosh_1))
ASYM(nbif_math_acosh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_acosh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_acosh_1))
	TYPE_FUNCTION(ASYM(nbif_math_acosh_1))
#endif

#ifndef HAVE_nbif_ebif_math_acosh_1
#define HAVE_nbif_ebif_math_acosh_1
	GLOBAL(ASYM(nbif_ebif_math_acosh_1))
ASYM(nbif_ebif_math_acosh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_acosh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_acosh_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_acosh_1))
#endif

#ifndef HAVE_nbif_math_asin_1
#define HAVE_nbif_math_asin_1
	GLOBAL(ASYM(nbif_math_asin_1))
ASYM(nbif_math_asin_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_asin_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_asin_1))
	TYPE_FUNCTION(ASYM(nbif_math_asin_1))
#endif

#ifndef HAVE_nbif_ebif_math_asin_1
#define HAVE_nbif_ebif_math_asin_1
	GLOBAL(ASYM(nbif_ebif_math_asin_1))
ASYM(nbif_ebif_math_asin_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_asin_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_asin_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_asin_1))
#endif

#ifndef HAVE_nbif_math_asinh_1
#define HAVE_nbif_math_asinh_1
	GLOBAL(ASYM(nbif_math_asinh_1))
ASYM(nbif_math_asinh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_asinh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_asinh_1))
	TYPE_FUNCTION(ASYM(nbif_math_asinh_1))
#endif

#ifndef HAVE_nbif_ebif_math_asinh_1
#define HAVE_nbif_ebif_math_asinh_1
	GLOBAL(ASYM(nbif_ebif_math_asinh_1))
ASYM(nbif_ebif_math_asinh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_asinh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_asinh_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_asinh_1))
#endif

#ifndef HAVE_nbif_math_atan_1
#define HAVE_nbif_math_atan_1
	GLOBAL(ASYM(nbif_math_atan_1))
ASYM(nbif_math_atan_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_atan_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_atan_1))
	TYPE_FUNCTION(ASYM(nbif_math_atan_1))
#endif

#ifndef HAVE_nbif_ebif_math_atan_1
#define HAVE_nbif_ebif_math_atan_1
	GLOBAL(ASYM(nbif_ebif_math_atan_1))
ASYM(nbif_ebif_math_atan_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_atan_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_atan_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_atan_1))
#endif

#ifndef HAVE_nbif_math_atanh_1
#define HAVE_nbif_math_atanh_1
	GLOBAL(ASYM(nbif_math_atanh_1))
ASYM(nbif_math_atanh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_atanh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_atanh_1))
	TYPE_FUNCTION(ASYM(nbif_math_atanh_1))
#endif

#ifndef HAVE_nbif_ebif_math_atanh_1
#define HAVE_nbif_ebif_math_atanh_1
	GLOBAL(ASYM(nbif_ebif_math_atanh_1))
ASYM(nbif_ebif_math_atanh_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_atanh_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_atanh_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_atanh_1))
#endif

#ifndef HAVE_nbif_math_erf_1
#define HAVE_nbif_math_erf_1
	GLOBAL(ASYM(nbif_math_erf_1))
ASYM(nbif_math_erf_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_erf_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_erf_1))
	TYPE_FUNCTION(ASYM(nbif_math_erf_1))
#endif

#ifndef HAVE_nbif_ebif_math_erf_1
#define HAVE_nbif_ebif_math_erf_1
	GLOBAL(ASYM(nbif_ebif_math_erf_1))
ASYM(nbif_ebif_math_erf_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_erf_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_erf_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_erf_1))
#endif

#ifndef HAVE_nbif_math_erfc_1
#define HAVE_nbif_math_erfc_1
	GLOBAL(ASYM(nbif_math_erfc_1))
ASYM(nbif_math_erfc_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_erfc_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_erfc_1))
	TYPE_FUNCTION(ASYM(nbif_math_erfc_1))
#endif

#ifndef HAVE_nbif_ebif_math_erfc_1
#define HAVE_nbif_ebif_math_erfc_1
	GLOBAL(ASYM(nbif_ebif_math_erfc_1))
ASYM(nbif_ebif_math_erfc_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_erfc_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_erfc_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_erfc_1))
#endif

#ifndef HAVE_nbif_math_exp_1
#define HAVE_nbif_math_exp_1
	GLOBAL(ASYM(nbif_math_exp_1))
ASYM(nbif_math_exp_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_exp_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_exp_1))
	TYPE_FUNCTION(ASYM(nbif_math_exp_1))
#endif

#ifndef HAVE_nbif_ebif_math_exp_1
#define HAVE_nbif_ebif_math_exp_1
	GLOBAL(ASYM(nbif_ebif_math_exp_1))
ASYM(nbif_ebif_math_exp_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_exp_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_exp_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_exp_1))
#endif

#ifndef HAVE_nbif_math_log_1
#define HAVE_nbif_math_log_1
	GLOBAL(ASYM(nbif_math_log_1))
ASYM(nbif_math_log_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_log_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_log_1))
	TYPE_FUNCTION(ASYM(nbif_math_log_1))
#endif

#ifndef HAVE_nbif_ebif_math_log_1
#define HAVE_nbif_ebif_math_log_1
	GLOBAL(ASYM(nbif_ebif_math_log_1))
ASYM(nbif_ebif_math_log_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_log_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_log_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_log_1))
#endif

#ifndef HAVE_nbif_math_log10_1
#define HAVE_nbif_math_log10_1
	GLOBAL(ASYM(nbif_math_log10_1))
ASYM(nbif_math_log10_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_log10_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_log10_1))
	TYPE_FUNCTION(ASYM(nbif_math_log10_1))
#endif

#ifndef HAVE_nbif_ebif_math_log10_1
#define HAVE_nbif_ebif_math_log10_1
	GLOBAL(ASYM(nbif_ebif_math_log10_1))
ASYM(nbif_ebif_math_log10_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_log10_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_log10_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_log10_1))
#endif

#ifndef HAVE_nbif_math_sqrt_1
#define HAVE_nbif_math_sqrt_1
	GLOBAL(ASYM(nbif_math_sqrt_1))
ASYM(nbif_math_sqrt_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_sqrt_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_math_sqrt_1))
	TYPE_FUNCTION(ASYM(nbif_math_sqrt_1))
#endif

#ifndef HAVE_nbif_ebif_math_sqrt_1
#define HAVE_nbif_ebif_math_sqrt_1
	GLOBAL(ASYM(nbif_ebif_math_sqrt_1))
ASYM(nbif_ebif_math_sqrt_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_sqrt_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_sqrt_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_sqrt_1))
#endif

#ifndef HAVE_nbif_math_atan2_2
#define HAVE_nbif_math_atan2_2
	GLOBAL(ASYM(nbif_math_atan2_2))
ASYM(nbif_math_atan2_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_atan2_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_math_atan2_2))
	TYPE_FUNCTION(ASYM(nbif_math_atan2_2))
#endif

#ifndef HAVE_nbif_ebif_math_atan2_2
#define HAVE_nbif_ebif_math_atan2_2
	GLOBAL(ASYM(nbif_ebif_math_atan2_2))
ASYM(nbif_ebif_math_atan2_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_atan2_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_atan2_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_atan2_2))
#endif

#ifndef HAVE_nbif_math_pow_2
#define HAVE_nbif_math_pow_2
	GLOBAL(ASYM(nbif_math_pow_2))
ASYM(nbif_math_pow_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(math_pow_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_math_pow_2))
	TYPE_FUNCTION(ASYM(nbif_math_pow_2))
#endif

#ifndef HAVE_nbif_ebif_math_pow_2
#define HAVE_nbif_ebif_math_pow_2
	GLOBAL(ASYM(nbif_ebif_math_pow_2))
ASYM(nbif_ebif_math_pow_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_math_pow_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_math_pow_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_math_pow_2))
#endif

#ifndef HAVE_nbif_start_timer_3
#define HAVE_nbif_start_timer_3
	GLOBAL(ASYM(nbif_start_timer_3))
ASYM(nbif_start_timer_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(start_timer_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_start_timer_3))
	TYPE_FUNCTION(ASYM(nbif_start_timer_3))
#endif

#ifndef HAVE_nbif_ebif_start_timer_3
#define HAVE_nbif_ebif_start_timer_3
	GLOBAL(ASYM(nbif_ebif_start_timer_3))
ASYM(nbif_ebif_start_timer_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_start_timer_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_start_timer_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_start_timer_3))
#endif

#ifndef HAVE_nbif_send_after_3
#define HAVE_nbif_send_after_3
	GLOBAL(ASYM(nbif_send_after_3))
ASYM(nbif_send_after_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(send_after_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_send_after_3))
	TYPE_FUNCTION(ASYM(nbif_send_after_3))
#endif

#ifndef HAVE_nbif_ebif_send_after_3
#define HAVE_nbif_ebif_send_after_3
	GLOBAL(ASYM(nbif_ebif_send_after_3))
ASYM(nbif_ebif_send_after_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_send_after_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_send_after_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_send_after_3))
#endif

#ifndef HAVE_nbif_cancel_timer_1
#define HAVE_nbif_cancel_timer_1
	GLOBAL(ASYM(nbif_cancel_timer_1))
ASYM(nbif_cancel_timer_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(cancel_timer_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_cancel_timer_1))
	TYPE_FUNCTION(ASYM(nbif_cancel_timer_1))
#endif

#ifndef HAVE_nbif_ebif_cancel_timer_1
#define HAVE_nbif_ebif_cancel_timer_1
	GLOBAL(ASYM(nbif_ebif_cancel_timer_1))
ASYM(nbif_ebif_cancel_timer_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_cancel_timer_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_cancel_timer_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_cancel_timer_1))
#endif

#ifndef HAVE_nbif_read_timer_1
#define HAVE_nbif_read_timer_1
	GLOBAL(ASYM(nbif_read_timer_1))
ASYM(nbif_read_timer_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(read_timer_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_read_timer_1))
	TYPE_FUNCTION(ASYM(nbif_read_timer_1))
#endif

#ifndef HAVE_nbif_ebif_read_timer_1
#define HAVE_nbif_ebif_read_timer_1
	GLOBAL(ASYM(nbif_ebif_read_timer_1))
ASYM(nbif_ebif_read_timer_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_read_timer_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_read_timer_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_read_timer_1))
#endif

#ifndef HAVE_nbif_make_tuple_2
#define HAVE_nbif_make_tuple_2
	GLOBAL(ASYM(nbif_make_tuple_2))
ASYM(nbif_make_tuple_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(make_tuple_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_make_tuple_2))
	TYPE_FUNCTION(ASYM(nbif_make_tuple_2))
#endif

#ifndef HAVE_nbif_ebif_make_tuple_2
#define HAVE_nbif_ebif_make_tuple_2
	GLOBAL(ASYM(nbif_ebif_make_tuple_2))
ASYM(nbif_ebif_make_tuple_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_make_tuple_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_make_tuple_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_make_tuple_2))
#endif

#ifndef HAVE_nbif_append_element_2
#define HAVE_nbif_append_element_2
	GLOBAL(ASYM(nbif_append_element_2))
ASYM(nbif_append_element_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(append_element_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_append_element_2))
	TYPE_FUNCTION(ASYM(nbif_append_element_2))
#endif

#ifndef HAVE_nbif_ebif_append_element_2
#define HAVE_nbif_ebif_append_element_2
	GLOBAL(ASYM(nbif_ebif_append_element_2))
ASYM(nbif_ebif_append_element_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_append_element_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_append_element_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_append_element_2))
#endif

#ifndef HAVE_nbif_system_flag_2
#define HAVE_nbif_system_flag_2
	GLOBAL(ASYM(nbif_system_flag_2))
ASYM(nbif_system_flag_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(system_flag_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_system_flag_2))
	TYPE_FUNCTION(ASYM(nbif_system_flag_2))
#endif

#ifndef HAVE_nbif_ebif_system_flag_2
#define HAVE_nbif_ebif_system_flag_2
	GLOBAL(ASYM(nbif_ebif_system_flag_2))
ASYM(nbif_ebif_system_flag_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_system_flag_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_system_flag_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_system_flag_2))
#endif

#ifndef HAVE_nbif_system_info_1
#define HAVE_nbif_system_info_1
	GLOBAL(ASYM(nbif_system_info_1))
ASYM(nbif_system_info_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(system_info_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_system_info_1))
	TYPE_FUNCTION(ASYM(nbif_system_info_1))
#endif

#ifndef HAVE_nbif_ebif_system_info_1
#define HAVE_nbif_ebif_system_info_1
	GLOBAL(ASYM(nbif_ebif_system_info_1))
ASYM(nbif_ebif_system_info_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_system_info_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_system_info_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_system_info_1))
#endif

#ifndef HAVE_nbif_system_monitor_0
#define HAVE_nbif_system_monitor_0
	GLOBAL(ASYM(nbif_system_monitor_0))
ASYM(nbif_system_monitor_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(system_monitor_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_system_monitor_0))
	TYPE_FUNCTION(ASYM(nbif_system_monitor_0))
#endif

#ifndef HAVE_nbif_ebif_system_monitor_0
#define HAVE_nbif_ebif_system_monitor_0
	GLOBAL(ASYM(nbif_ebif_system_monitor_0))
ASYM(nbif_ebif_system_monitor_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_system_monitor_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_system_monitor_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_system_monitor_0))
#endif

#ifndef HAVE_nbif_system_monitor_1
#define HAVE_nbif_system_monitor_1
	GLOBAL(ASYM(nbif_system_monitor_1))
ASYM(nbif_system_monitor_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(system_monitor_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_system_monitor_1))
	TYPE_FUNCTION(ASYM(nbif_system_monitor_1))
#endif

#ifndef HAVE_nbif_ebif_system_monitor_1
#define HAVE_nbif_ebif_system_monitor_1
	GLOBAL(ASYM(nbif_ebif_system_monitor_1))
ASYM(nbif_ebif_system_monitor_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_system_monitor_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_system_monitor_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_system_monitor_1))
#endif

#ifndef HAVE_nbif_system_monitor_2
#define HAVE_nbif_system_monitor_2
	GLOBAL(ASYM(nbif_system_monitor_2))
ASYM(nbif_system_monitor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(system_monitor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_system_monitor_2))
	TYPE_FUNCTION(ASYM(nbif_system_monitor_2))
#endif

#ifndef HAVE_nbif_ebif_system_monitor_2
#define HAVE_nbif_ebif_system_monitor_2
	GLOBAL(ASYM(nbif_ebif_system_monitor_2))
ASYM(nbif_ebif_system_monitor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_system_monitor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_system_monitor_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_system_monitor_2))
#endif

#ifndef HAVE_nbif_ref_to_list_1
#define HAVE_nbif_ref_to_list_1
	GLOBAL(ASYM(nbif_ref_to_list_1))
ASYM(nbif_ref_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ref_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ref_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_ref_to_list_1))
#endif

#ifndef HAVE_nbif_ebif_ref_to_string_1
#define HAVE_nbif_ebif_ref_to_string_1
	GLOBAL(ASYM(nbif_ebif_ref_to_string_1))
ASYM(nbif_ebif_ref_to_string_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ref_to_string_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ref_to_string_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ref_to_string_1))
#endif

#ifndef HAVE_nbif_port_to_list_1
#define HAVE_nbif_port_to_list_1
	GLOBAL(ASYM(nbif_port_to_list_1))
ASYM(nbif_port_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(port_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_port_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_port_to_list_1))
#endif

#ifndef HAVE_nbif_ebif_port_to_string_1
#define HAVE_nbif_ebif_port_to_string_1
	GLOBAL(ASYM(nbif_ebif_port_to_string_1))
ASYM(nbif_ebif_port_to_string_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_port_to_string_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_port_to_string_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_port_to_string_1))
#endif

#ifndef HAVE_nbif_fun_to_list_1
#define HAVE_nbif_fun_to_list_1
	GLOBAL(ASYM(nbif_fun_to_list_1))
ASYM(nbif_fun_to_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(fun_to_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_fun_to_list_1))
	TYPE_FUNCTION(ASYM(nbif_fun_to_list_1))
#endif

#ifndef HAVE_nbif_ebif_fun_to_string_1
#define HAVE_nbif_ebif_fun_to_string_1
	GLOBAL(ASYM(nbif_ebif_fun_to_string_1))
ASYM(nbif_ebif_fun_to_string_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_fun_to_string_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_fun_to_string_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_fun_to_string_1))
#endif

#ifndef HAVE_nbif_monitor_2
#define HAVE_nbif_monitor_2
	GLOBAL(ASYM(nbif_monitor_2))
ASYM(nbif_monitor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(monitor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_monitor_2))
	TYPE_FUNCTION(ASYM(nbif_monitor_2))
#endif

#ifndef HAVE_nbif_ebif_monitor_2
#define HAVE_nbif_ebif_monitor_2
	GLOBAL(ASYM(nbif_ebif_monitor_2))
ASYM(nbif_ebif_monitor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_monitor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_monitor_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_monitor_2))
#endif

#ifndef HAVE_nbif_demonitor_1
#define HAVE_nbif_demonitor_1
	GLOBAL(ASYM(nbif_demonitor_1))
ASYM(nbif_demonitor_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(demonitor_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_demonitor_1))
	TYPE_FUNCTION(ASYM(nbif_demonitor_1))
#endif

#ifndef HAVE_nbif_ebif_demonitor_1
#define HAVE_nbif_ebif_demonitor_1
	GLOBAL(ASYM(nbif_ebif_demonitor_1))
ASYM(nbif_ebif_demonitor_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_demonitor_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_demonitor_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_demonitor_1))
#endif

#ifndef HAVE_nbif_is_process_alive_1
#define HAVE_nbif_is_process_alive_1
	GLOBAL(ASYM(nbif_is_process_alive_1))
ASYM(nbif_is_process_alive_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_process_alive_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_process_alive_1))
	TYPE_FUNCTION(ASYM(nbif_is_process_alive_1))
#endif

#ifndef HAVE_nbif_ebif_proc_is_alive_1
#define HAVE_nbif_ebif_proc_is_alive_1
	GLOBAL(ASYM(nbif_ebif_proc_is_alive_1))
ASYM(nbif_ebif_proc_is_alive_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_proc_is_alive_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_proc_is_alive_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_proc_is_alive_1))
#endif

#ifndef HAVE_nbif_error_1
#define HAVE_nbif_error_1
	GLOBAL(ASYM(nbif_error_1))
ASYM(nbif_error_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(error_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_error_1))
	TYPE_FUNCTION(ASYM(nbif_error_1))
#endif

#ifndef HAVE_nbif_fault_1
#define HAVE_nbif_fault_1
	GLOBAL(ASYM(nbif_fault_1))
ASYM(nbif_fault_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(fault_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_fault_1))
	TYPE_FUNCTION(ASYM(nbif_fault_1))
#endif

#ifndef HAVE_nbif_ebif_error_1
#define HAVE_nbif_ebif_error_1
	GLOBAL(ASYM(nbif_ebif_error_1))
ASYM(nbif_ebif_error_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_error_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_error_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_error_1))
#endif

#ifndef HAVE_nbif_error_2
#define HAVE_nbif_error_2
	GLOBAL(ASYM(nbif_error_2))
ASYM(nbif_error_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(error_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_error_2))
	TYPE_FUNCTION(ASYM(nbif_error_2))
#endif

#ifndef HAVE_nbif_fault_2
#define HAVE_nbif_fault_2
	GLOBAL(ASYM(nbif_fault_2))
ASYM(nbif_fault_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(fault_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_fault_2))
	TYPE_FUNCTION(ASYM(nbif_fault_2))
#endif

#ifndef HAVE_nbif_ebif_error_2
#define HAVE_nbif_ebif_error_2
	GLOBAL(ASYM(nbif_ebif_error_2))
ASYM(nbif_ebif_error_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_error_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_error_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_error_2))
#endif

#ifndef HAVE_nbif_raise_3
#define HAVE_nbif_raise_3
	GLOBAL(ASYM(nbif_raise_3))
ASYM(nbif_raise_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(raise_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_raise_3))
	TYPE_FUNCTION(ASYM(nbif_raise_3))
#endif

#ifndef HAVE_nbif_ebif_raise_3
#define HAVE_nbif_ebif_raise_3
	GLOBAL(ASYM(nbif_ebif_raise_3))
ASYM(nbif_ebif_raise_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_raise_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_raise_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_raise_3))
#endif

#ifndef HAVE_nbif_get_stacktrace_0
#define HAVE_nbif_get_stacktrace_0
	GLOBAL(ASYM(nbif_get_stacktrace_0))
ASYM(nbif_get_stacktrace_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(get_stacktrace_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_get_stacktrace_0))
	TYPE_FUNCTION(ASYM(nbif_get_stacktrace_0))
#endif

#ifndef HAVE_nbif_ebif_get_stacktrace_0
#define HAVE_nbif_ebif_get_stacktrace_0
	GLOBAL(ASYM(nbif_ebif_get_stacktrace_0))
ASYM(nbif_ebif_get_stacktrace_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_get_stacktrace_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_get_stacktrace_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_get_stacktrace_0))
#endif

#ifndef HAVE_nbif_is_builtin_3
#define HAVE_nbif_is_builtin_3
	GLOBAL(ASYM(nbif_is_builtin_3))
ASYM(nbif_is_builtin_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_builtin_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_is_builtin_3))
	TYPE_FUNCTION(ASYM(nbif_is_builtin_3))
#endif

#ifndef HAVE_nbif_ebif_is_builtin_3
#define HAVE_nbif_ebif_is_builtin_3
	GLOBAL(ASYM(nbif_ebif_is_builtin_3))
ASYM(nbif_ebif_is_builtin_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_builtin_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_builtin_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_builtin_3))
#endif

#ifndef HAVE_nbif_and_2
#define HAVE_nbif_and_2
	GLOBAL(ASYM(nbif_and_2))
ASYM(nbif_and_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(and_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_and_2))
	TYPE_FUNCTION(ASYM(nbif_and_2))
#endif

#ifndef HAVE_nbif_ebif_and_2
#define HAVE_nbif_ebif_and_2
	GLOBAL(ASYM(nbif_ebif_and_2))
ASYM(nbif_ebif_and_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_and_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_and_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_and_2))
#endif

#ifndef HAVE_nbif_or_2
#define HAVE_nbif_or_2
	GLOBAL(ASYM(nbif_or_2))
ASYM(nbif_or_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(or_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_or_2))
	TYPE_FUNCTION(ASYM(nbif_or_2))
#endif

#ifndef HAVE_nbif_ebif_or_2
#define HAVE_nbif_ebif_or_2
	GLOBAL(ASYM(nbif_ebif_or_2))
ASYM(nbif_ebif_or_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_or_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_or_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_or_2))
#endif

#ifndef HAVE_nbif_xor_2
#define HAVE_nbif_xor_2
	GLOBAL(ASYM(nbif_xor_2))
ASYM(nbif_xor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(xor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_xor_2))
	TYPE_FUNCTION(ASYM(nbif_xor_2))
#endif

#ifndef HAVE_nbif_ebif_xor_2
#define HAVE_nbif_ebif_xor_2
	GLOBAL(ASYM(nbif_ebif_xor_2))
ASYM(nbif_ebif_xor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_xor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_xor_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_xor_2))
#endif

#ifndef HAVE_nbif_not_1
#define HAVE_nbif_not_1
	GLOBAL(ASYM(nbif_not_1))
ASYM(nbif_not_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(not_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_not_1))
	TYPE_FUNCTION(ASYM(nbif_not_1))
#endif

#ifndef HAVE_nbif_ebif_not_1
#define HAVE_nbif_ebif_not_1
	GLOBAL(ASYM(nbif_ebif_not_1))
ASYM(nbif_ebif_not_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_not_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_not_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_not_1))
#endif

#ifndef HAVE_nbif_sgt_2
#define HAVE_nbif_sgt_2
	GLOBAL(ASYM(nbif_sgt_2))
ASYM(nbif_sgt_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(sgt_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_sgt_2))
	TYPE_FUNCTION(ASYM(nbif_sgt_2))
#endif

#ifndef HAVE_nbif_ebif_gt_2
#define HAVE_nbif_ebif_gt_2
	GLOBAL(ASYM(nbif_ebif_gt_2))
ASYM(nbif_ebif_gt_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_gt_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_gt_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_gt_2))
#endif

#ifndef HAVE_nbif_sge_2
#define HAVE_nbif_sge_2
	GLOBAL(ASYM(nbif_sge_2))
ASYM(nbif_sge_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(sge_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_sge_2))
	TYPE_FUNCTION(ASYM(nbif_sge_2))
#endif

#ifndef HAVE_nbif_ebif_ge_2
#define HAVE_nbif_ebif_ge_2
	GLOBAL(ASYM(nbif_ebif_ge_2))
ASYM(nbif_ebif_ge_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ge_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ge_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ge_2))
#endif

#ifndef HAVE_nbif_slt_2
#define HAVE_nbif_slt_2
	GLOBAL(ASYM(nbif_slt_2))
ASYM(nbif_slt_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(slt_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_slt_2))
	TYPE_FUNCTION(ASYM(nbif_slt_2))
#endif

#ifndef HAVE_nbif_ebif_lt_2
#define HAVE_nbif_ebif_lt_2
	GLOBAL(ASYM(nbif_ebif_lt_2))
ASYM(nbif_ebif_lt_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_lt_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_lt_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_lt_2))
#endif

#ifndef HAVE_nbif_sle_2
#define HAVE_nbif_sle_2
	GLOBAL(ASYM(nbif_sle_2))
ASYM(nbif_sle_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(sle_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_sle_2))
	TYPE_FUNCTION(ASYM(nbif_sle_2))
#endif

#ifndef HAVE_nbif_ebif_le_2
#define HAVE_nbif_ebif_le_2
	GLOBAL(ASYM(nbif_ebif_le_2))
ASYM(nbif_ebif_le_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_le_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_le_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_le_2))
#endif

#ifndef HAVE_nbif_seq_2
#define HAVE_nbif_seq_2
	GLOBAL(ASYM(nbif_seq_2))
ASYM(nbif_seq_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(seq_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_seq_2))
	TYPE_FUNCTION(ASYM(nbif_seq_2))
#endif

#ifndef HAVE_nbif_ebif_eq_2
#define HAVE_nbif_ebif_eq_2
	GLOBAL(ASYM(nbif_ebif_eq_2))
ASYM(nbif_ebif_eq_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_eq_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_eq_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_eq_2))
#endif

#ifndef HAVE_nbif_seqeq_2
#define HAVE_nbif_seqeq_2
	GLOBAL(ASYM(nbif_seqeq_2))
ASYM(nbif_seqeq_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(seqeq_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_seqeq_2))
	TYPE_FUNCTION(ASYM(nbif_seqeq_2))
#endif

#ifndef HAVE_nbif_ebif_areq_2
#define HAVE_nbif_ebif_areq_2
	GLOBAL(ASYM(nbif_ebif_areq_2))
ASYM(nbif_ebif_areq_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_areq_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_areq_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_areq_2))
#endif

#ifndef HAVE_nbif_sneq_2
#define HAVE_nbif_sneq_2
	GLOBAL(ASYM(nbif_sneq_2))
ASYM(nbif_sneq_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(sneq_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_sneq_2))
	TYPE_FUNCTION(ASYM(nbif_sneq_2))
#endif

#ifndef HAVE_nbif_ebif_neq_2
#define HAVE_nbif_ebif_neq_2
	GLOBAL(ASYM(nbif_ebif_neq_2))
ASYM(nbif_ebif_neq_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_neq_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_neq_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_neq_2))
#endif

#ifndef HAVE_nbif_sneqeq_2
#define HAVE_nbif_sneqeq_2
	GLOBAL(ASYM(nbif_sneqeq_2))
ASYM(nbif_sneqeq_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(sneqeq_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_sneqeq_2))
	TYPE_FUNCTION(ASYM(nbif_sneqeq_2))
#endif

#ifndef HAVE_nbif_ebif_nareq_2
#define HAVE_nbif_ebif_nareq_2
	GLOBAL(ASYM(nbif_ebif_nareq_2))
ASYM(nbif_ebif_nareq_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_nareq_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_nareq_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_nareq_2))
#endif

#ifndef HAVE_nbif_splus_2
#define HAVE_nbif_splus_2
	GLOBAL(ASYM(nbif_splus_2))
ASYM(nbif_splus_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(splus_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_splus_2))
	TYPE_FUNCTION(ASYM(nbif_splus_2))
#endif

#ifndef HAVE_nbif_ebif_plus_2
#define HAVE_nbif_ebif_plus_2
	GLOBAL(ASYM(nbif_ebif_plus_2))
ASYM(nbif_ebif_plus_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_plus_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_plus_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_plus_2))
#endif

#ifndef HAVE_nbif_sminus_2
#define HAVE_nbif_sminus_2
	GLOBAL(ASYM(nbif_sminus_2))
ASYM(nbif_sminus_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(sminus_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_sminus_2))
	TYPE_FUNCTION(ASYM(nbif_sminus_2))
#endif

#ifndef HAVE_nbif_ebif_minus_2
#define HAVE_nbif_ebif_minus_2
	GLOBAL(ASYM(nbif_ebif_minus_2))
ASYM(nbif_ebif_minus_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_minus_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_minus_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_minus_2))
#endif

#ifndef HAVE_nbif_stimes_2
#define HAVE_nbif_stimes_2
	GLOBAL(ASYM(nbif_stimes_2))
ASYM(nbif_stimes_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(stimes_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_stimes_2))
	TYPE_FUNCTION(ASYM(nbif_stimes_2))
#endif

#ifndef HAVE_nbif_ebif_multiply_2
#define HAVE_nbif_ebif_multiply_2
	GLOBAL(ASYM(nbif_ebif_multiply_2))
ASYM(nbif_ebif_multiply_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_multiply_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_multiply_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_multiply_2))
#endif

#ifndef HAVE_nbif_div_2
#define HAVE_nbif_div_2
	GLOBAL(ASYM(nbif_div_2))
ASYM(nbif_div_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(div_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_div_2))
	TYPE_FUNCTION(ASYM(nbif_div_2))
#endif

#ifndef HAVE_nbif_ebif_divide_2
#define HAVE_nbif_ebif_divide_2
	GLOBAL(ASYM(nbif_ebif_divide_2))
ASYM(nbif_ebif_divide_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_divide_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_divide_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_divide_2))
#endif

#ifndef HAVE_nbif_intdiv_2
#define HAVE_nbif_intdiv_2
	GLOBAL(ASYM(nbif_intdiv_2))
ASYM(nbif_intdiv_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(intdiv_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_intdiv_2))
	TYPE_FUNCTION(ASYM(nbif_intdiv_2))
#endif

#ifndef HAVE_nbif_ebif_intdiv_2
#define HAVE_nbif_ebif_intdiv_2
	GLOBAL(ASYM(nbif_ebif_intdiv_2))
ASYM(nbif_ebif_intdiv_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_intdiv_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_intdiv_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_intdiv_2))
#endif

#ifndef HAVE_nbif_rem_2
#define HAVE_nbif_rem_2
	GLOBAL(ASYM(nbif_rem_2))
ASYM(nbif_rem_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(rem_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_rem_2))
	TYPE_FUNCTION(ASYM(nbif_rem_2))
#endif

#ifndef HAVE_nbif_ebif_rem_2
#define HAVE_nbif_ebif_rem_2
	GLOBAL(ASYM(nbif_ebif_rem_2))
ASYM(nbif_ebif_rem_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_rem_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_rem_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_rem_2))
#endif

#ifndef HAVE_nbif_bor_2
#define HAVE_nbif_bor_2
	GLOBAL(ASYM(nbif_bor_2))
ASYM(nbif_bor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_bor_2))
	TYPE_FUNCTION(ASYM(nbif_bor_2))
#endif

#ifndef HAVE_nbif_ebif_bor_2
#define HAVE_nbif_ebif_bor_2
	GLOBAL(ASYM(nbif_ebif_bor_2))
ASYM(nbif_ebif_bor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_bor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_bor_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_bor_2))
#endif

#ifndef HAVE_nbif_band_2
#define HAVE_nbif_band_2
	GLOBAL(ASYM(nbif_band_2))
ASYM(nbif_band_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(band_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_band_2))
	TYPE_FUNCTION(ASYM(nbif_band_2))
#endif

#ifndef HAVE_nbif_ebif_band_2
#define HAVE_nbif_ebif_band_2
	GLOBAL(ASYM(nbif_ebif_band_2))
ASYM(nbif_ebif_band_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_band_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_band_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_band_2))
#endif

#ifndef HAVE_nbif_bxor_2
#define HAVE_nbif_bxor_2
	GLOBAL(ASYM(nbif_bxor_2))
ASYM(nbif_bxor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bxor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_bxor_2))
	TYPE_FUNCTION(ASYM(nbif_bxor_2))
#endif

#ifndef HAVE_nbif_ebif_bxor_2
#define HAVE_nbif_ebif_bxor_2
	GLOBAL(ASYM(nbif_ebif_bxor_2))
ASYM(nbif_ebif_bxor_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_bxor_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_bxor_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_bxor_2))
#endif

#ifndef HAVE_nbif_bsl_2
#define HAVE_nbif_bsl_2
	GLOBAL(ASYM(nbif_bsl_2))
ASYM(nbif_bsl_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bsl_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_bsl_2))
	TYPE_FUNCTION(ASYM(nbif_bsl_2))
#endif

#ifndef HAVE_nbif_ebif_bsl_2
#define HAVE_nbif_ebif_bsl_2
	GLOBAL(ASYM(nbif_ebif_bsl_2))
ASYM(nbif_ebif_bsl_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_bsl_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_bsl_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_bsl_2))
#endif

#ifndef HAVE_nbif_bsr_2
#define HAVE_nbif_bsr_2
	GLOBAL(ASYM(nbif_bsr_2))
ASYM(nbif_bsr_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bsr_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_bsr_2))
	TYPE_FUNCTION(ASYM(nbif_bsr_2))
#endif

#ifndef HAVE_nbif_ebif_bsr_2
#define HAVE_nbif_ebif_bsr_2
	GLOBAL(ASYM(nbif_ebif_bsr_2))
ASYM(nbif_ebif_bsr_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_bsr_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_bsr_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_bsr_2))
#endif

#ifndef HAVE_nbif_bnot_1
#define HAVE_nbif_bnot_1
	GLOBAL(ASYM(nbif_bnot_1))
ASYM(nbif_bnot_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(bnot_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_bnot_1))
	TYPE_FUNCTION(ASYM(nbif_bnot_1))
#endif

#ifndef HAVE_nbif_ebif_bnot_1
#define HAVE_nbif_ebif_bnot_1
	GLOBAL(ASYM(nbif_ebif_bnot_1))
ASYM(nbif_ebif_bnot_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_bnot_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_bnot_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_bnot_1))
#endif

#ifndef HAVE_nbif_sminus_1
#define HAVE_nbif_sminus_1
	GLOBAL(ASYM(nbif_sminus_1))
ASYM(nbif_sminus_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(sminus_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_sminus_1))
	TYPE_FUNCTION(ASYM(nbif_sminus_1))
#endif

#ifndef HAVE_nbif_ebif_minus_1
#define HAVE_nbif_ebif_minus_1
	GLOBAL(ASYM(nbif_ebif_minus_1))
ASYM(nbif_ebif_minus_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_minus_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_minus_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_minus_1))
#endif

#ifndef HAVE_nbif_splus_1
#define HAVE_nbif_splus_1
	GLOBAL(ASYM(nbif_splus_1))
ASYM(nbif_splus_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(splus_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_splus_1))
	TYPE_FUNCTION(ASYM(nbif_splus_1))
#endif

#ifndef HAVE_nbif_ebif_plus_1
#define HAVE_nbif_ebif_plus_1
	GLOBAL(ASYM(nbif_ebif_plus_1))
ASYM(nbif_ebif_plus_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_plus_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_plus_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_plus_1))
#endif

#ifndef HAVE_nbif_ebif_bang_2
#define HAVE_nbif_ebif_bang_2
	GLOBAL(ASYM(nbif_ebif_bang_2))
ASYM(nbif_ebif_bang_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_bang_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_bang_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_bang_2))
#endif

#ifndef HAVE_nbif_ebif_send_2
#define HAVE_nbif_ebif_send_2
	GLOBAL(ASYM(nbif_ebif_send_2))
ASYM(nbif_ebif_send_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_send_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_send_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_send_2))
#endif

#ifndef HAVE_nbif_send_2
#define HAVE_nbif_send_2
	GLOBAL(ASYM(nbif_send_2))
ASYM(nbif_send_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(send_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_send_2))
	TYPE_FUNCTION(ASYM(nbif_send_2))
#endif

#ifndef HAVE_nbif_ebif_send_3
#define HAVE_nbif_ebif_send_3
	GLOBAL(ASYM(nbif_ebif_send_3))
ASYM(nbif_ebif_send_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_send_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_send_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_send_3))
#endif

#ifndef HAVE_nbif_send_3
#define HAVE_nbif_send_3
	GLOBAL(ASYM(nbif_send_3))
ASYM(nbif_send_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(send_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_send_3))
	TYPE_FUNCTION(ASYM(nbif_send_3))
#endif

#ifndef HAVE_nbif_ebif_plusplus_2
#define HAVE_nbif_ebif_plusplus_2
	GLOBAL(ASYM(nbif_ebif_plusplus_2))
ASYM(nbif_ebif_plusplus_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_plusplus_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_plusplus_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_plusplus_2))
#endif

#ifndef HAVE_nbif_ebif_append_2
#define HAVE_nbif_ebif_append_2
	GLOBAL(ASYM(nbif_ebif_append_2))
ASYM(nbif_ebif_append_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_append_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_append_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_append_2))
#endif

#ifndef HAVE_nbif_append_2
#define HAVE_nbif_append_2
	GLOBAL(ASYM(nbif_append_2))
ASYM(nbif_append_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(append_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_append_2))
	TYPE_FUNCTION(ASYM(nbif_append_2))
#endif

#ifndef HAVE_nbif_ebif_minusminus_2
#define HAVE_nbif_ebif_minusminus_2
	GLOBAL(ASYM(nbif_ebif_minusminus_2))
ASYM(nbif_ebif_minusminus_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_minusminus_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_minusminus_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_minusminus_2))
#endif

#ifndef HAVE_nbif_ebif_list_subtract_2
#define HAVE_nbif_ebif_list_subtract_2
	GLOBAL(ASYM(nbif_ebif_list_subtract_2))
ASYM(nbif_ebif_list_subtract_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_list_subtract_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_list_subtract_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_list_subtract_2))
#endif

#ifndef HAVE_nbif_subtract_2
#define HAVE_nbif_subtract_2
	GLOBAL(ASYM(nbif_subtract_2))
ASYM(nbif_subtract_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(subtract_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_subtract_2))
	TYPE_FUNCTION(ASYM(nbif_subtract_2))
#endif

#ifndef HAVE_nbif_is_atom_1
#define HAVE_nbif_is_atom_1
	GLOBAL(ASYM(nbif_is_atom_1))
ASYM(nbif_is_atom_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_atom_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_atom_1))
	TYPE_FUNCTION(ASYM(nbif_is_atom_1))
#endif

#ifndef HAVE_nbif_ebif_is_atom_1
#define HAVE_nbif_ebif_is_atom_1
	GLOBAL(ASYM(nbif_ebif_is_atom_1))
ASYM(nbif_ebif_is_atom_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_atom_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_atom_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_atom_1))
#endif

#ifndef HAVE_nbif_is_list_1
#define HAVE_nbif_is_list_1
	GLOBAL(ASYM(nbif_is_list_1))
ASYM(nbif_is_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_list_1))
	TYPE_FUNCTION(ASYM(nbif_is_list_1))
#endif

#ifndef HAVE_nbif_ebif_is_list_1
#define HAVE_nbif_ebif_is_list_1
	GLOBAL(ASYM(nbif_ebif_is_list_1))
ASYM(nbif_ebif_is_list_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_list_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_list_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_list_1))
#endif

#ifndef HAVE_nbif_is_tuple_1
#define HAVE_nbif_is_tuple_1
	GLOBAL(ASYM(nbif_is_tuple_1))
ASYM(nbif_is_tuple_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_tuple_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_tuple_1))
	TYPE_FUNCTION(ASYM(nbif_is_tuple_1))
#endif

#ifndef HAVE_nbif_ebif_is_tuple_1
#define HAVE_nbif_ebif_is_tuple_1
	GLOBAL(ASYM(nbif_ebif_is_tuple_1))
ASYM(nbif_ebif_is_tuple_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_tuple_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_tuple_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_tuple_1))
#endif

#ifndef HAVE_nbif_is_constant_1
#define HAVE_nbif_is_constant_1
	GLOBAL(ASYM(nbif_is_constant_1))
ASYM(nbif_is_constant_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_constant_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_constant_1))
	TYPE_FUNCTION(ASYM(nbif_is_constant_1))
#endif

#ifndef HAVE_nbif_ebif_is_constant_1
#define HAVE_nbif_ebif_is_constant_1
	GLOBAL(ASYM(nbif_ebif_is_constant_1))
ASYM(nbif_ebif_is_constant_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_constant_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_constant_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_constant_1))
#endif

#ifndef HAVE_nbif_is_float_1
#define HAVE_nbif_is_float_1
	GLOBAL(ASYM(nbif_is_float_1))
ASYM(nbif_is_float_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_float_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_float_1))
	TYPE_FUNCTION(ASYM(nbif_is_float_1))
#endif

#ifndef HAVE_nbif_ebif_is_float_1
#define HAVE_nbif_ebif_is_float_1
	GLOBAL(ASYM(nbif_ebif_is_float_1))
ASYM(nbif_ebif_is_float_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_float_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_float_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_float_1))
#endif

#ifndef HAVE_nbif_is_integer_1
#define HAVE_nbif_is_integer_1
	GLOBAL(ASYM(nbif_is_integer_1))
ASYM(nbif_is_integer_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_integer_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_integer_1))
	TYPE_FUNCTION(ASYM(nbif_is_integer_1))
#endif

#ifndef HAVE_nbif_ebif_is_integer_1
#define HAVE_nbif_ebif_is_integer_1
	GLOBAL(ASYM(nbif_ebif_is_integer_1))
ASYM(nbif_ebif_is_integer_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_integer_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_integer_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_integer_1))
#endif

#ifndef HAVE_nbif_is_number_1
#define HAVE_nbif_is_number_1
	GLOBAL(ASYM(nbif_is_number_1))
ASYM(nbif_is_number_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_number_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_number_1))
	TYPE_FUNCTION(ASYM(nbif_is_number_1))
#endif

#ifndef HAVE_nbif_ebif_is_number_1
#define HAVE_nbif_ebif_is_number_1
	GLOBAL(ASYM(nbif_ebif_is_number_1))
ASYM(nbif_ebif_is_number_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_number_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_number_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_number_1))
#endif

#ifndef HAVE_nbif_is_pid_1
#define HAVE_nbif_is_pid_1
	GLOBAL(ASYM(nbif_is_pid_1))
ASYM(nbif_is_pid_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_pid_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_pid_1))
	TYPE_FUNCTION(ASYM(nbif_is_pid_1))
#endif

#ifndef HAVE_nbif_ebif_is_pid_1
#define HAVE_nbif_ebif_is_pid_1
	GLOBAL(ASYM(nbif_ebif_is_pid_1))
ASYM(nbif_ebif_is_pid_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_pid_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_pid_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_pid_1))
#endif

#ifndef HAVE_nbif_is_port_1
#define HAVE_nbif_is_port_1
	GLOBAL(ASYM(nbif_is_port_1))
ASYM(nbif_is_port_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_port_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_port_1))
	TYPE_FUNCTION(ASYM(nbif_is_port_1))
#endif

#ifndef HAVE_nbif_ebif_is_port_1
#define HAVE_nbif_ebif_is_port_1
	GLOBAL(ASYM(nbif_ebif_is_port_1))
ASYM(nbif_ebif_is_port_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_port_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_port_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_port_1))
#endif

#ifndef HAVE_nbif_is_reference_1
#define HAVE_nbif_is_reference_1
	GLOBAL(ASYM(nbif_is_reference_1))
ASYM(nbif_is_reference_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_reference_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_reference_1))
	TYPE_FUNCTION(ASYM(nbif_is_reference_1))
#endif

#ifndef HAVE_nbif_ebif_is_reference_1
#define HAVE_nbif_ebif_is_reference_1
	GLOBAL(ASYM(nbif_ebif_is_reference_1))
ASYM(nbif_ebif_is_reference_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_reference_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_reference_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_reference_1))
#endif

#ifndef HAVE_nbif_is_binary_1
#define HAVE_nbif_is_binary_1
	GLOBAL(ASYM(nbif_is_binary_1))
ASYM(nbif_is_binary_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_binary_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_binary_1))
	TYPE_FUNCTION(ASYM(nbif_is_binary_1))
#endif

#ifndef HAVE_nbif_ebif_is_binary_1
#define HAVE_nbif_ebif_is_binary_1
	GLOBAL(ASYM(nbif_ebif_is_binary_1))
ASYM(nbif_ebif_is_binary_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_binary_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_binary_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_binary_1))
#endif

#ifndef HAVE_nbif_is_function_1
#define HAVE_nbif_is_function_1
	GLOBAL(ASYM(nbif_is_function_1))
ASYM(nbif_is_function_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_function_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_function_1))
	TYPE_FUNCTION(ASYM(nbif_is_function_1))
#endif

#ifndef HAVE_nbif_ebif_is_function_1
#define HAVE_nbif_ebif_is_function_1
	GLOBAL(ASYM(nbif_ebif_is_function_1))
ASYM(nbif_ebif_is_function_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_function_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_function_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_function_1))
#endif

#ifndef HAVE_nbif_is_function_2
#define HAVE_nbif_is_function_2
	GLOBAL(ASYM(nbif_is_function_2))
ASYM(nbif_is_function_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_function_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_is_function_2))
	TYPE_FUNCTION(ASYM(nbif_is_function_2))
#endif

#ifndef HAVE_nbif_ebif_is_function_2
#define HAVE_nbif_ebif_is_function_2
	GLOBAL(ASYM(nbif_ebif_is_function_2))
ASYM(nbif_ebif_is_function_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_function_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_function_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_function_2))
#endif

#ifndef HAVE_nbif_is_record_2
#define HAVE_nbif_is_record_2
	GLOBAL(ASYM(nbif_is_record_2))
ASYM(nbif_is_record_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_record_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_is_record_2))
	TYPE_FUNCTION(ASYM(nbif_is_record_2))
#endif

#ifndef HAVE_nbif_ebif_is_record_2
#define HAVE_nbif_ebif_is_record_2
	GLOBAL(ASYM(nbif_ebif_is_record_2))
ASYM(nbif_ebif_is_record_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_record_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_record_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_record_2))
#endif

#ifndef HAVE_nbif_is_record_3
#define HAVE_nbif_is_record_3
	GLOBAL(ASYM(nbif_is_record_3))
ASYM(nbif_is_record_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_record_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_is_record_3))
	TYPE_FUNCTION(ASYM(nbif_is_record_3))
#endif

#ifndef HAVE_nbif_ebif_is_record_3
#define HAVE_nbif_ebif_is_record_3
	GLOBAL(ASYM(nbif_ebif_is_record_3))
ASYM(nbif_ebif_is_record_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_is_record_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_is_record_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_is_record_3))
#endif

#ifndef HAVE_nbif_match_spec_test_3
#define HAVE_nbif_match_spec_test_3
	GLOBAL(ASYM(nbif_match_spec_test_3))
ASYM(nbif_match_spec_test_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(match_spec_test_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_match_spec_test_3))
	TYPE_FUNCTION(ASYM(nbif_match_spec_test_3))
#endif

#ifndef HAVE_nbif_dollar_put_2
#define HAVE_nbif_dollar_put_2
	GLOBAL(ASYM(nbif_dollar_put_2))
ASYM(nbif_dollar_put_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(dollar_put_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_dollar_put_2))
	TYPE_FUNCTION(ASYM(nbif_dollar_put_2))
#endif

#ifndef HAVE_nbif_dollar_get_0
#define HAVE_nbif_dollar_get_0
	GLOBAL(ASYM(nbif_dollar_get_0))
ASYM(nbif_dollar_get_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(dollar_get_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_dollar_get_0))
	TYPE_FUNCTION(ASYM(nbif_dollar_get_0))
#endif

#ifndef HAVE_nbif_dollar_get_1
#define HAVE_nbif_dollar_get_1
	GLOBAL(ASYM(nbif_dollar_get_1))
ASYM(nbif_dollar_get_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(dollar_get_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_dollar_get_1))
	TYPE_FUNCTION(ASYM(nbif_dollar_get_1))
#endif

#ifndef HAVE_nbif_dollar_get_keys_1
#define HAVE_nbif_dollar_get_keys_1
	GLOBAL(ASYM(nbif_dollar_get_keys_1))
ASYM(nbif_dollar_get_keys_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(dollar_get_keys_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_dollar_get_keys_1))
	TYPE_FUNCTION(ASYM(nbif_dollar_get_keys_1))
#endif

#ifndef HAVE_nbif_dollar_erase_0
#define HAVE_nbif_dollar_erase_0
	GLOBAL(ASYM(nbif_dollar_erase_0))
ASYM(nbif_dollar_erase_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(dollar_erase_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_dollar_erase_0))
	TYPE_FUNCTION(ASYM(nbif_dollar_erase_0))
#endif

#ifndef HAVE_nbif_dollar_erase_1
#define HAVE_nbif_dollar_erase_1
	GLOBAL(ASYM(nbif_dollar_erase_1))
ASYM(nbif_dollar_erase_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(dollar_erase_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_dollar_erase_1))
	TYPE_FUNCTION(ASYM(nbif_dollar_erase_1))
#endif

#ifndef HAVE_nbif_ets_all_0
#define HAVE_nbif_ets_all_0
	GLOBAL(ASYM(nbif_ets_all_0))
ASYM(nbif_ets_all_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_all_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ets_all_0))
	TYPE_FUNCTION(ASYM(nbif_ets_all_0))
#endif

#ifndef HAVE_nbif_ebif_ets_all_0
#define HAVE_nbif_ebif_ets_all_0
	GLOBAL(ASYM(nbif_ebif_ets_all_0))
ASYM(nbif_ebif_ets_all_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_all_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_all_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_all_0))
#endif

#ifndef HAVE_nbif_ets_new_2
#define HAVE_nbif_ets_new_2
	GLOBAL(ASYM(nbif_ets_new_2))
ASYM(nbif_ets_new_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_new_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_new_2))
	TYPE_FUNCTION(ASYM(nbif_ets_new_2))
#endif

#ifndef HAVE_nbif_ebif_ets_new_2
#define HAVE_nbif_ebif_ets_new_2
	GLOBAL(ASYM(nbif_ebif_ets_new_2))
ASYM(nbif_ebif_ets_new_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_new_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_new_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_new_2))
#endif

#ifndef HAVE_nbif_ets_db_delete_1
#define HAVE_nbif_ets_db_delete_1
	GLOBAL(ASYM(nbif_ets_db_delete_1))
ASYM(nbif_ets_db_delete_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_db_delete_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ets_db_delete_1))
	TYPE_FUNCTION(ASYM(nbif_ets_db_delete_1))
#endif

#ifndef HAVE_nbif_ebif_ets_db_delete_1
#define HAVE_nbif_ebif_ets_db_delete_1
	GLOBAL(ASYM(nbif_ebif_ets_db_delete_1))
ASYM(nbif_ebif_ets_db_delete_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_db_delete_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_db_delete_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_db_delete_1))
#endif

#ifndef HAVE_nbif_ets_delete_2
#define HAVE_nbif_ets_delete_2
	GLOBAL(ASYM(nbif_ets_delete_2))
ASYM(nbif_ets_delete_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_delete_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_delete_2))
	TYPE_FUNCTION(ASYM(nbif_ets_delete_2))
#endif

#ifndef HAVE_nbif_ebif_ets_delete_2
#define HAVE_nbif_ebif_ets_delete_2
	GLOBAL(ASYM(nbif_ebif_ets_delete_2))
ASYM(nbif_ebif_ets_delete_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_delete_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_delete_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_delete_2))
#endif

#ifndef HAVE_nbif_ets_delete_all_objects_1
#define HAVE_nbif_ets_delete_all_objects_1
	GLOBAL(ASYM(nbif_ets_delete_all_objects_1))
ASYM(nbif_ets_delete_all_objects_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_delete_all_objects_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ets_delete_all_objects_1))
	TYPE_FUNCTION(ASYM(nbif_ets_delete_all_objects_1))
#endif

#ifndef HAVE_nbif_ebif_ets_delete_all_objects_1
#define HAVE_nbif_ebif_ets_delete_all_objects_1
	GLOBAL(ASYM(nbif_ebif_ets_delete_all_objects_1))
ASYM(nbif_ebif_ets_delete_all_objects_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_delete_all_objects_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_delete_all_objects_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_delete_all_objects_1))
#endif

#ifndef HAVE_nbif_ets_delete_object_2
#define HAVE_nbif_ets_delete_object_2
	GLOBAL(ASYM(nbif_ets_delete_object_2))
ASYM(nbif_ets_delete_object_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_delete_object_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_delete_object_2))
	TYPE_FUNCTION(ASYM(nbif_ets_delete_object_2))
#endif

#ifndef HAVE_nbif_ebif_ets_delete_object_2
#define HAVE_nbif_ebif_ets_delete_object_2
	GLOBAL(ASYM(nbif_ebif_ets_delete_object_2))
ASYM(nbif_ebif_ets_delete_object_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_delete_object_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_delete_object_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_delete_object_2))
#endif

#ifndef HAVE_nbif_ets_first_1
#define HAVE_nbif_ets_first_1
	GLOBAL(ASYM(nbif_ets_first_1))
ASYM(nbif_ets_first_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_first_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ets_first_1))
	TYPE_FUNCTION(ASYM(nbif_ets_first_1))
#endif

#ifndef HAVE_nbif_ebif_ets_first_1
#define HAVE_nbif_ebif_ets_first_1
	GLOBAL(ASYM(nbif_ebif_ets_first_1))
ASYM(nbif_ebif_ets_first_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_first_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_first_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_first_1))
#endif

#ifndef HAVE_nbif_ets_fixtable_2
#define HAVE_nbif_ets_fixtable_2
	GLOBAL(ASYM(nbif_ets_fixtable_2))
ASYM(nbif_ets_fixtable_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_fixtable_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_fixtable_2))
	TYPE_FUNCTION(ASYM(nbif_ets_fixtable_2))
#endif

#ifndef HAVE_nbif_ebif_ets_fixtable_2
#define HAVE_nbif_ebif_ets_fixtable_2
	GLOBAL(ASYM(nbif_ebif_ets_fixtable_2))
ASYM(nbif_ebif_ets_fixtable_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_fixtable_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_fixtable_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_fixtable_2))
#endif

#ifndef HAVE_nbif_ets_is_compiled_ms_1
#define HAVE_nbif_ets_is_compiled_ms_1
	GLOBAL(ASYM(nbif_ets_is_compiled_ms_1))
ASYM(nbif_ets_is_compiled_ms_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_is_compiled_ms_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ets_is_compiled_ms_1))
	TYPE_FUNCTION(ASYM(nbif_ets_is_compiled_ms_1))
#endif

#ifndef HAVE_nbif_ebif_ets_is_compiled_ms_1
#define HAVE_nbif_ebif_ets_is_compiled_ms_1
	GLOBAL(ASYM(nbif_ebif_ets_is_compiled_ms_1))
ASYM(nbif_ebif_ets_is_compiled_ms_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_is_compiled_ms_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_is_compiled_ms_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_is_compiled_ms_1))
#endif

#ifndef HAVE_nbif_ets_lookup_2
#define HAVE_nbif_ets_lookup_2
	GLOBAL(ASYM(nbif_ets_lookup_2))
ASYM(nbif_ets_lookup_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_lookup_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_lookup_2))
	TYPE_FUNCTION(ASYM(nbif_ets_lookup_2))
#endif

#ifndef HAVE_nbif_ebif_ets_lookup_2
#define HAVE_nbif_ebif_ets_lookup_2
	GLOBAL(ASYM(nbif_ebif_ets_lookup_2))
ASYM(nbif_ebif_ets_lookup_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_lookup_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_lookup_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_lookup_2))
#endif

#ifndef HAVE_nbif_ets_lookup_element_3
#define HAVE_nbif_ets_lookup_element_3
	GLOBAL(ASYM(nbif_ets_lookup_element_3))
ASYM(nbif_ets_lookup_element_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_lookup_element_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ets_lookup_element_3))
	TYPE_FUNCTION(ASYM(nbif_ets_lookup_element_3))
#endif

#ifndef HAVE_nbif_ebif_ets_lookup_element_3
#define HAVE_nbif_ebif_ets_lookup_element_3
	GLOBAL(ASYM(nbif_ebif_ets_lookup_element_3))
ASYM(nbif_ebif_ets_lookup_element_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_lookup_element_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_lookup_element_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_lookup_element_3))
#endif

#ifndef HAVE_nbif_ets_db_info_2
#define HAVE_nbif_ets_db_info_2
	GLOBAL(ASYM(nbif_ets_db_info_2))
ASYM(nbif_ets_db_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_db_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_db_info_2))
	TYPE_FUNCTION(ASYM(nbif_ets_db_info_2))
#endif

#ifndef HAVE_nbif_ebif_ets_db_info_2
#define HAVE_nbif_ebif_ets_db_info_2
	GLOBAL(ASYM(nbif_ebif_ets_db_info_2))
ASYM(nbif_ebif_ets_db_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_db_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_db_info_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_db_info_2))
#endif

#ifndef HAVE_nbif_ets_last_1
#define HAVE_nbif_ets_last_1
	GLOBAL(ASYM(nbif_ets_last_1))
ASYM(nbif_ets_last_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_last_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ets_last_1))
	TYPE_FUNCTION(ASYM(nbif_ets_last_1))
#endif

#ifndef HAVE_nbif_ebif_ets_last_1
#define HAVE_nbif_ebif_ets_last_1
	GLOBAL(ASYM(nbif_ebif_ets_last_1))
ASYM(nbif_ebif_ets_last_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_last_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_last_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_last_1))
#endif

#ifndef HAVE_nbif_ets_match_1
#define HAVE_nbif_ets_match_1
	GLOBAL(ASYM(nbif_ets_match_1))
ASYM(nbif_ets_match_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_match_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ets_match_1))
	TYPE_FUNCTION(ASYM(nbif_ets_match_1))
#endif

#ifndef HAVE_nbif_ebif_ets_match_1
#define HAVE_nbif_ebif_ets_match_1
	GLOBAL(ASYM(nbif_ebif_ets_match_1))
ASYM(nbif_ebif_ets_match_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_match_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_match_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_match_1))
#endif

#ifndef HAVE_nbif_ets_match_2
#define HAVE_nbif_ets_match_2
	GLOBAL(ASYM(nbif_ets_match_2))
ASYM(nbif_ets_match_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_match_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_match_2))
	TYPE_FUNCTION(ASYM(nbif_ets_match_2))
#endif

#ifndef HAVE_nbif_ebif_ets_match_2
#define HAVE_nbif_ebif_ets_match_2
	GLOBAL(ASYM(nbif_ebif_ets_match_2))
ASYM(nbif_ebif_ets_match_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_match_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_match_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_match_2))
#endif

#ifndef HAVE_nbif_ets_match_3
#define HAVE_nbif_ets_match_3
	GLOBAL(ASYM(nbif_ets_match_3))
ASYM(nbif_ets_match_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_match_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ets_match_3))
	TYPE_FUNCTION(ASYM(nbif_ets_match_3))
#endif

#ifndef HAVE_nbif_ebif_ets_match_3
#define HAVE_nbif_ebif_ets_match_3
	GLOBAL(ASYM(nbif_ebif_ets_match_3))
ASYM(nbif_ebif_ets_match_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_match_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_match_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_match_3))
#endif

#ifndef HAVE_nbif_ets_match_object_1
#define HAVE_nbif_ets_match_object_1
	GLOBAL(ASYM(nbif_ets_match_object_1))
ASYM(nbif_ets_match_object_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_match_object_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ets_match_object_1))
	TYPE_FUNCTION(ASYM(nbif_ets_match_object_1))
#endif

#ifndef HAVE_nbif_ebif_ets_match_object_1
#define HAVE_nbif_ebif_ets_match_object_1
	GLOBAL(ASYM(nbif_ebif_ets_match_object_1))
ASYM(nbif_ebif_ets_match_object_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_match_object_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_match_object_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_match_object_1))
#endif

#ifndef HAVE_nbif_ets_match_object_2
#define HAVE_nbif_ets_match_object_2
	GLOBAL(ASYM(nbif_ets_match_object_2))
ASYM(nbif_ets_match_object_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_match_object_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_match_object_2))
	TYPE_FUNCTION(ASYM(nbif_ets_match_object_2))
#endif

#ifndef HAVE_nbif_ebif_ets_match_object_2
#define HAVE_nbif_ebif_ets_match_object_2
	GLOBAL(ASYM(nbif_ebif_ets_match_object_2))
ASYM(nbif_ebif_ets_match_object_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_match_object_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_match_object_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_match_object_2))
#endif

#ifndef HAVE_nbif_ets_match_object_3
#define HAVE_nbif_ets_match_object_3
	GLOBAL(ASYM(nbif_ets_match_object_3))
ASYM(nbif_ets_match_object_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_match_object_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ets_match_object_3))
	TYPE_FUNCTION(ASYM(nbif_ets_match_object_3))
#endif

#ifndef HAVE_nbif_ebif_ets_match_object_3
#define HAVE_nbif_ebif_ets_match_object_3
	GLOBAL(ASYM(nbif_ebif_ets_match_object_3))
ASYM(nbif_ebif_ets_match_object_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_match_object_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_match_object_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_match_object_3))
#endif

#ifndef HAVE_nbif_ets_member_2
#define HAVE_nbif_ets_member_2
	GLOBAL(ASYM(nbif_ets_member_2))
ASYM(nbif_ets_member_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_member_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_member_2))
	TYPE_FUNCTION(ASYM(nbif_ets_member_2))
#endif

#ifndef HAVE_nbif_ebif_ets_member_2
#define HAVE_nbif_ebif_ets_member_2
	GLOBAL(ASYM(nbif_ebif_ets_member_2))
ASYM(nbif_ebif_ets_member_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_member_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_member_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_member_2))
#endif

#ifndef HAVE_nbif_ets_next_2
#define HAVE_nbif_ets_next_2
	GLOBAL(ASYM(nbif_ets_next_2))
ASYM(nbif_ets_next_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_next_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_next_2))
	TYPE_FUNCTION(ASYM(nbif_ets_next_2))
#endif

#ifndef HAVE_nbif_ebif_ets_next_2
#define HAVE_nbif_ebif_ets_next_2
	GLOBAL(ASYM(nbif_ebif_ets_next_2))
ASYM(nbif_ebif_ets_next_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_next_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_next_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_next_2))
#endif

#ifndef HAVE_nbif_ets_prev_2
#define HAVE_nbif_ets_prev_2
	GLOBAL(ASYM(nbif_ets_prev_2))
ASYM(nbif_ets_prev_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_prev_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_prev_2))
	TYPE_FUNCTION(ASYM(nbif_ets_prev_2))
#endif

#ifndef HAVE_nbif_ebif_ets_prev_2
#define HAVE_nbif_ebif_ets_prev_2
	GLOBAL(ASYM(nbif_ebif_ets_prev_2))
ASYM(nbif_ebif_ets_prev_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_prev_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_prev_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_prev_2))
#endif

#ifndef HAVE_nbif_ets_insert_2
#define HAVE_nbif_ets_insert_2
	GLOBAL(ASYM(nbif_ets_insert_2))
ASYM(nbif_ets_insert_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_insert_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_insert_2))
	TYPE_FUNCTION(ASYM(nbif_ets_insert_2))
#endif

#ifndef HAVE_nbif_ebif_ets_insert_2
#define HAVE_nbif_ebif_ets_insert_2
	GLOBAL(ASYM(nbif_ebif_ets_insert_2))
ASYM(nbif_ebif_ets_insert_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_insert_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_insert_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_insert_2))
#endif

#ifndef HAVE_nbif_ets_insert_new_2
#define HAVE_nbif_ets_insert_new_2
	GLOBAL(ASYM(nbif_ets_insert_new_2))
ASYM(nbif_ets_insert_new_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_insert_new_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_insert_new_2))
	TYPE_FUNCTION(ASYM(nbif_ets_insert_new_2))
#endif

#ifndef HAVE_nbif_ebif_ets_insert_new_2
#define HAVE_nbif_ebif_ets_insert_new_2
	GLOBAL(ASYM(nbif_ebif_ets_insert_new_2))
ASYM(nbif_ebif_ets_insert_new_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_insert_new_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_insert_new_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_insert_new_2))
#endif

#ifndef HAVE_nbif_ets_rename_2
#define HAVE_nbif_ets_rename_2
	GLOBAL(ASYM(nbif_ets_rename_2))
ASYM(nbif_ets_rename_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_rename_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_rename_2))
	TYPE_FUNCTION(ASYM(nbif_ets_rename_2))
#endif

#ifndef HAVE_nbif_ebif_ets_rename_2
#define HAVE_nbif_ebif_ets_rename_2
	GLOBAL(ASYM(nbif_ebif_ets_rename_2))
ASYM(nbif_ebif_ets_rename_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_rename_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_rename_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_rename_2))
#endif

#ifndef HAVE_nbif_ets_safe_fixtable_2
#define HAVE_nbif_ets_safe_fixtable_2
	GLOBAL(ASYM(nbif_ets_safe_fixtable_2))
ASYM(nbif_ets_safe_fixtable_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_safe_fixtable_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_safe_fixtable_2))
	TYPE_FUNCTION(ASYM(nbif_ets_safe_fixtable_2))
#endif

#ifndef HAVE_nbif_ebif_ets_safe_fixtable_2
#define HAVE_nbif_ebif_ets_safe_fixtable_2
	GLOBAL(ASYM(nbif_ebif_ets_safe_fixtable_2))
ASYM(nbif_ebif_ets_safe_fixtable_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_safe_fixtable_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_safe_fixtable_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_safe_fixtable_2))
#endif

#ifndef HAVE_nbif_ets_slot_2
#define HAVE_nbif_ets_slot_2
	GLOBAL(ASYM(nbif_ets_slot_2))
ASYM(nbif_ets_slot_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_slot_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_slot_2))
	TYPE_FUNCTION(ASYM(nbif_ets_slot_2))
#endif

#ifndef HAVE_nbif_ebif_ets_slot_2
#define HAVE_nbif_ebif_ets_slot_2
	GLOBAL(ASYM(nbif_ebif_ets_slot_2))
ASYM(nbif_ebif_ets_slot_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_slot_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_slot_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_slot_2))
#endif

#ifndef HAVE_nbif_ets_update_counter_3
#define HAVE_nbif_ets_update_counter_3
	GLOBAL(ASYM(nbif_ets_update_counter_3))
ASYM(nbif_ets_update_counter_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_update_counter_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ets_update_counter_3))
	TYPE_FUNCTION(ASYM(nbif_ets_update_counter_3))
#endif

#ifndef HAVE_nbif_ebif_ets_update_counter_3
#define HAVE_nbif_ebif_ets_update_counter_3
	GLOBAL(ASYM(nbif_ebif_ets_update_counter_3))
ASYM(nbif_ebif_ets_update_counter_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_update_counter_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_update_counter_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_update_counter_3))
#endif

#ifndef HAVE_nbif_ets_select_1
#define HAVE_nbif_ets_select_1
	GLOBAL(ASYM(nbif_ets_select_1))
ASYM(nbif_ets_select_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_select_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ets_select_1))
	TYPE_FUNCTION(ASYM(nbif_ets_select_1))
#endif

#ifndef HAVE_nbif_ebif_ets_select_1
#define HAVE_nbif_ebif_ets_select_1
	GLOBAL(ASYM(nbif_ebif_ets_select_1))
ASYM(nbif_ebif_ets_select_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_select_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_select_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_select_1))
#endif

#ifndef HAVE_nbif_ets_select_2
#define HAVE_nbif_ets_select_2
	GLOBAL(ASYM(nbif_ets_select_2))
ASYM(nbif_ets_select_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_select_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_select_2))
	TYPE_FUNCTION(ASYM(nbif_ets_select_2))
#endif

#ifndef HAVE_nbif_ebif_ets_select_2
#define HAVE_nbif_ebif_ets_select_2
	GLOBAL(ASYM(nbif_ebif_ets_select_2))
ASYM(nbif_ebif_ets_select_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_select_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_select_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_select_2))
#endif

#ifndef HAVE_nbif_ets_select_3
#define HAVE_nbif_ets_select_3
	GLOBAL(ASYM(nbif_ets_select_3))
ASYM(nbif_ets_select_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_select_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ets_select_3))
	TYPE_FUNCTION(ASYM(nbif_ets_select_3))
#endif

#ifndef HAVE_nbif_ebif_ets_select_3
#define HAVE_nbif_ebif_ets_select_3
	GLOBAL(ASYM(nbif_ebif_ets_select_3))
ASYM(nbif_ebif_ets_select_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_select_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_select_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_select_3))
#endif

#ifndef HAVE_nbif_ets_select_count_2
#define HAVE_nbif_ets_select_count_2
	GLOBAL(ASYM(nbif_ets_select_count_2))
ASYM(nbif_ets_select_count_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_select_count_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_select_count_2))
	TYPE_FUNCTION(ASYM(nbif_ets_select_count_2))
#endif

#ifndef HAVE_nbif_ebif_ets_select_count_2
#define HAVE_nbif_ebif_ets_select_count_2
	GLOBAL(ASYM(nbif_ebif_ets_select_count_2))
ASYM(nbif_ebif_ets_select_count_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_select_count_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_select_count_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_select_count_2))
#endif

#ifndef HAVE_nbif_ets_select_reverse_1
#define HAVE_nbif_ets_select_reverse_1
	GLOBAL(ASYM(nbif_ets_select_reverse_1))
ASYM(nbif_ets_select_reverse_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_select_reverse_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ets_select_reverse_1))
	TYPE_FUNCTION(ASYM(nbif_ets_select_reverse_1))
#endif

#ifndef HAVE_nbif_ebif_ets_select_reverse_1
#define HAVE_nbif_ebif_ets_select_reverse_1
	GLOBAL(ASYM(nbif_ebif_ets_select_reverse_1))
ASYM(nbif_ebif_ets_select_reverse_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_select_reverse_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_select_reverse_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_select_reverse_1))
#endif

#ifndef HAVE_nbif_ets_select_reverse_2
#define HAVE_nbif_ets_select_reverse_2
	GLOBAL(ASYM(nbif_ets_select_reverse_2))
ASYM(nbif_ets_select_reverse_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_select_reverse_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_select_reverse_2))
	TYPE_FUNCTION(ASYM(nbif_ets_select_reverse_2))
#endif

#ifndef HAVE_nbif_ebif_ets_select_reverse_2
#define HAVE_nbif_ebif_ets_select_reverse_2
	GLOBAL(ASYM(nbif_ebif_ets_select_reverse_2))
ASYM(nbif_ebif_ets_select_reverse_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_select_reverse_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_select_reverse_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_select_reverse_2))
#endif

#ifndef HAVE_nbif_ets_select_reverse_3
#define HAVE_nbif_ets_select_reverse_3
	GLOBAL(ASYM(nbif_ets_select_reverse_3))
ASYM(nbif_ets_select_reverse_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_select_reverse_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ets_select_reverse_3))
	TYPE_FUNCTION(ASYM(nbif_ets_select_reverse_3))
#endif

#ifndef HAVE_nbif_ebif_ets_select_reverse_3
#define HAVE_nbif_ebif_ets_select_reverse_3
	GLOBAL(ASYM(nbif_ebif_ets_select_reverse_3))
ASYM(nbif_ebif_ets_select_reverse_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_select_reverse_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_select_reverse_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_select_reverse_3))
#endif

#ifndef HAVE_nbif_ets_select_delete_2
#define HAVE_nbif_ets_select_delete_2
	GLOBAL(ASYM(nbif_ets_select_delete_2))
ASYM(nbif_ets_select_delete_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_select_delete_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ets_select_delete_2))
	TYPE_FUNCTION(ASYM(nbif_ets_select_delete_2))
#endif

#ifndef HAVE_nbif_ebif_ets_select_delete_2
#define HAVE_nbif_ebif_ets_select_delete_2
	GLOBAL(ASYM(nbif_ebif_ets_select_delete_2))
ASYM(nbif_ebif_ets_select_delete_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_select_delete_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_select_delete_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_select_delete_2))
#endif

#ifndef HAVE_nbif_ets_match_spec_compile_1
#define HAVE_nbif_ets_match_spec_compile_1
	GLOBAL(ASYM(nbif_ets_match_spec_compile_1))
ASYM(nbif_ets_match_spec_compile_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_match_spec_compile_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ets_match_spec_compile_1))
	TYPE_FUNCTION(ASYM(nbif_ets_match_spec_compile_1))
#endif

#ifndef HAVE_nbif_ebif_ets_match_spec_compile_1
#define HAVE_nbif_ebif_ets_match_spec_compile_1
	GLOBAL(ASYM(nbif_ebif_ets_match_spec_compile_1))
ASYM(nbif_ebif_ets_match_spec_compile_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_match_spec_compile_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_match_spec_compile_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_match_spec_compile_1))
#endif

#ifndef HAVE_nbif_ets_match_spec_run_r_3
#define HAVE_nbif_ets_match_spec_run_r_3
	GLOBAL(ASYM(nbif_ets_match_spec_run_r_3))
ASYM(nbif_ets_match_spec_run_r_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ets_match_spec_run_r_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ets_match_spec_run_r_3))
	TYPE_FUNCTION(ASYM(nbif_ets_match_spec_run_r_3))
#endif

#ifndef HAVE_nbif_ebif_ets_match_spec_run_r_3
#define HAVE_nbif_ebif_ets_match_spec_run_r_3
	GLOBAL(ASYM(nbif_ebif_ets_match_spec_run_r_3))
ASYM(nbif_ebif_ets_match_spec_run_r_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_ets_match_spec_run_r_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_ets_match_spec_run_r_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_ets_match_spec_run_r_3))
#endif

#ifndef HAVE_nbif_os_putenv_2
#define HAVE_nbif_os_putenv_2
	GLOBAL(ASYM(nbif_os_putenv_2))
ASYM(nbif_os_putenv_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(os_putenv_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_os_putenv_2))
	TYPE_FUNCTION(ASYM(nbif_os_putenv_2))
#endif

#ifndef HAVE_nbif_ebif_os_setenv_2
#define HAVE_nbif_ebif_os_setenv_2
	GLOBAL(ASYM(nbif_ebif_os_setenv_2))
ASYM(nbif_ebif_os_setenv_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_os_setenv_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_os_setenv_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_os_setenv_2))
#endif

#ifndef HAVE_nbif_os_getenv_0
#define HAVE_nbif_os_getenv_0
	GLOBAL(ASYM(nbif_os_getenv_0))
ASYM(nbif_os_getenv_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(os_getenv_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_os_getenv_0))
	TYPE_FUNCTION(ASYM(nbif_os_getenv_0))
#endif

#ifndef HAVE_nbif_ebif_os_getenv_0
#define HAVE_nbif_ebif_os_getenv_0
	GLOBAL(ASYM(nbif_ebif_os_getenv_0))
ASYM(nbif_ebif_os_getenv_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_os_getenv_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_os_getenv_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_os_getenv_0))
#endif

#ifndef HAVE_nbif_os_getenv_1
#define HAVE_nbif_os_getenv_1
	GLOBAL(ASYM(nbif_os_getenv_1))
ASYM(nbif_os_getenv_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(os_getenv_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_os_getenv_1))
	TYPE_FUNCTION(ASYM(nbif_os_getenv_1))
#endif

#ifndef HAVE_nbif_ebif_os_getenv_1
#define HAVE_nbif_ebif_os_getenv_1
	GLOBAL(ASYM(nbif_ebif_os_getenv_1))
ASYM(nbif_ebif_os_getenv_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_os_getenv_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_os_getenv_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_os_getenv_1))
#endif

#ifndef HAVE_nbif_os_getpid_0
#define HAVE_nbif_os_getpid_0
	GLOBAL(ASYM(nbif_os_getpid_0))
ASYM(nbif_os_getpid_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(os_getpid_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_os_getpid_0))
	TYPE_FUNCTION(ASYM(nbif_os_getpid_0))
#endif

#ifndef HAVE_nbif_ebif_os_pid_0
#define HAVE_nbif_ebif_os_pid_0
	GLOBAL(ASYM(nbif_ebif_os_pid_0))
ASYM(nbif_ebif_os_pid_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_os_pid_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_os_pid_0))
	TYPE_FUNCTION(ASYM(nbif_ebif_os_pid_0))
#endif

#ifndef HAVE_nbif_lists_member_2
#define HAVE_nbif_lists_member_2
	GLOBAL(ASYM(nbif_lists_member_2))
ASYM(nbif_lists_member_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(lists_member_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_lists_member_2))
	TYPE_FUNCTION(ASYM(nbif_lists_member_2))
#endif

#ifndef HAVE_nbif_ebif_list_is_element_2
#define HAVE_nbif_ebif_list_is_element_2
	GLOBAL(ASYM(nbif_ebif_list_is_element_2))
ASYM(nbif_ebif_list_is_element_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_list_is_element_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_list_is_element_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_list_is_element_2))
#endif

#ifndef HAVE_nbif_lists_reverse_2
#define HAVE_nbif_lists_reverse_2
	GLOBAL(ASYM(nbif_lists_reverse_2))
ASYM(nbif_lists_reverse_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(lists_reverse_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_lists_reverse_2))
	TYPE_FUNCTION(ASYM(nbif_lists_reverse_2))
#endif

#ifndef HAVE_nbif_ebif_list_reverse_2
#define HAVE_nbif_ebif_list_reverse_2
	GLOBAL(ASYM(nbif_ebif_list_reverse_2))
ASYM(nbif_ebif_list_reverse_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_list_reverse_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_list_reverse_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_list_reverse_2))
#endif

#ifndef HAVE_nbif_lists_keymember_3
#define HAVE_nbif_lists_keymember_3
	GLOBAL(ASYM(nbif_lists_keymember_3))
ASYM(nbif_lists_keymember_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(lists_keymember_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_lists_keymember_3))
	TYPE_FUNCTION(ASYM(nbif_lists_keymember_3))
#endif

#ifndef HAVE_nbif_ebif_keylist_is_element_3
#define HAVE_nbif_ebif_keylist_is_element_3
	GLOBAL(ASYM(nbif_ebif_keylist_is_element_3))
ASYM(nbif_ebif_keylist_is_element_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_keylist_is_element_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_keylist_is_element_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_keylist_is_element_3))
#endif

#ifndef HAVE_nbif_lists_keysearch_3
#define HAVE_nbif_lists_keysearch_3
	GLOBAL(ASYM(nbif_lists_keysearch_3))
ASYM(nbif_lists_keysearch_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(lists_keysearch_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_lists_keysearch_3))
	TYPE_FUNCTION(ASYM(nbif_lists_keysearch_3))
#endif

#ifndef HAVE_nbif_ebif_keylist_search_3
#define HAVE_nbif_ebif_keylist_search_3
	GLOBAL(ASYM(nbif_ebif_keylist_search_3))
ASYM(nbif_ebif_keylist_search_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_keylist_search_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_keylist_search_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_keylist_search_3))
#endif

#ifndef HAVE_nbif_erts_debug_disassemble_1
#define HAVE_nbif_erts_debug_disassemble_1
	GLOBAL(ASYM(nbif_erts_debug_disassemble_1))
ASYM(nbif_erts_debug_disassemble_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_debug_disassemble_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_erts_debug_disassemble_1))
	TYPE_FUNCTION(ASYM(nbif_erts_debug_disassemble_1))
#endif

#ifndef HAVE_nbif_ebif_erts_debug_disassemble_1
#define HAVE_nbif_ebif_erts_debug_disassemble_1
	GLOBAL(ASYM(nbif_ebif_erts_debug_disassemble_1))
ASYM(nbif_ebif_erts_debug_disassemble_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_erts_debug_disassemble_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_erts_debug_disassemble_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_erts_debug_disassemble_1))
#endif

#ifndef HAVE_nbif_erts_debug_breakpoint_2
#define HAVE_nbif_erts_debug_breakpoint_2
	GLOBAL(ASYM(nbif_erts_debug_breakpoint_2))
ASYM(nbif_erts_debug_breakpoint_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_debug_breakpoint_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_erts_debug_breakpoint_2))
	TYPE_FUNCTION(ASYM(nbif_erts_debug_breakpoint_2))
#endif

#ifndef HAVE_nbif_ebif_erts_debug_breakpoint_2
#define HAVE_nbif_ebif_erts_debug_breakpoint_2
	GLOBAL(ASYM(nbif_ebif_erts_debug_breakpoint_2))
ASYM(nbif_ebif_erts_debug_breakpoint_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_erts_debug_breakpoint_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_erts_debug_breakpoint_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_erts_debug_breakpoint_2))
#endif

#ifndef HAVE_nbif_erts_debug_same_2
#define HAVE_nbif_erts_debug_same_2
	GLOBAL(ASYM(nbif_erts_debug_same_2))
ASYM(nbif_erts_debug_same_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_debug_same_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_erts_debug_same_2))
	TYPE_FUNCTION(ASYM(nbif_erts_debug_same_2))
#endif

#ifndef HAVE_nbif_ebif_erts_debug_same_2
#define HAVE_nbif_ebif_erts_debug_same_2
	GLOBAL(ASYM(nbif_ebif_erts_debug_same_2))
ASYM(nbif_ebif_erts_debug_same_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_erts_debug_same_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_erts_debug_same_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_erts_debug_same_2))
#endif

#ifndef HAVE_nbif_erts_debug_flat_size_1
#define HAVE_nbif_erts_debug_flat_size_1
	GLOBAL(ASYM(nbif_erts_debug_flat_size_1))
ASYM(nbif_erts_debug_flat_size_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_debug_flat_size_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_erts_debug_flat_size_1))
	TYPE_FUNCTION(ASYM(nbif_erts_debug_flat_size_1))
#endif

#ifndef HAVE_nbif_ebif_erts_debug_flat_size_1
#define HAVE_nbif_ebif_erts_debug_flat_size_1
	GLOBAL(ASYM(nbif_ebif_erts_debug_flat_size_1))
ASYM(nbif_ebif_erts_debug_flat_size_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_erts_debug_flat_size_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_erts_debug_flat_size_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_erts_debug_flat_size_1))
#endif

#ifndef HAVE_nbif_erts_debug_dump_monitors_1
#define HAVE_nbif_erts_debug_dump_monitors_1
	GLOBAL(ASYM(nbif_erts_debug_dump_monitors_1))
ASYM(nbif_erts_debug_dump_monitors_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_debug_dump_monitors_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_erts_debug_dump_monitors_1))
	TYPE_FUNCTION(ASYM(nbif_erts_debug_dump_monitors_1))
#endif

#ifndef HAVE_nbif_erts_debug_dump_links_1
#define HAVE_nbif_erts_debug_dump_links_1
	GLOBAL(ASYM(nbif_erts_debug_dump_links_1))
ASYM(nbif_erts_debug_dump_links_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(erts_debug_dump_links_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_erts_debug_dump_links_1))
	TYPE_FUNCTION(ASYM(nbif_erts_debug_dump_links_1))
#endif

#ifndef HAVE_nbif_code_get_chunk_2
#define HAVE_nbif_code_get_chunk_2
	GLOBAL(ASYM(nbif_code_get_chunk_2))
ASYM(nbif_code_get_chunk_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(code_get_chunk_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_code_get_chunk_2))
	TYPE_FUNCTION(ASYM(nbif_code_get_chunk_2))
#endif

#ifndef HAVE_nbif_ebif_code_get_chunk_2
#define HAVE_nbif_ebif_code_get_chunk_2
	GLOBAL(ASYM(nbif_ebif_code_get_chunk_2))
ASYM(nbif_ebif_code_get_chunk_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_code_get_chunk_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_code_get_chunk_2))
	TYPE_FUNCTION(ASYM(nbif_ebif_code_get_chunk_2))
#endif

#ifndef HAVE_nbif_code_module_md5_1
#define HAVE_nbif_code_module_md5_1
	GLOBAL(ASYM(nbif_code_module_md5_1))
ASYM(nbif_code_module_md5_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(code_module_md5_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_code_module_md5_1))
	TYPE_FUNCTION(ASYM(nbif_code_module_md5_1))
#endif

#ifndef HAVE_nbif_ebif_code_module_md5_1
#define HAVE_nbif_ebif_code_module_md5_1
	GLOBAL(ASYM(nbif_ebif_code_module_md5_1))
ASYM(nbif_ebif_code_module_md5_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_code_module_md5_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_code_module_md5_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_code_module_md5_1))
#endif

#ifndef HAVE_nbif_code_make_stub_module_3
#define HAVE_nbif_code_make_stub_module_3
	GLOBAL(ASYM(nbif_code_make_stub_module_3))
ASYM(nbif_code_make_stub_module_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(code_make_stub_module_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_code_make_stub_module_3))
	TYPE_FUNCTION(ASYM(nbif_code_make_stub_module_3))
#endif

#ifndef HAVE_nbif_ebif_code_make_stub_module_3
#define HAVE_nbif_ebif_code_make_stub_module_3
	GLOBAL(ASYM(nbif_ebif_code_make_stub_module_3))
ASYM(nbif_ebif_code_make_stub_module_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_code_make_stub_module_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_code_make_stub_module_3))
	TYPE_FUNCTION(ASYM(nbif_ebif_code_make_stub_module_3))
#endif

#ifndef HAVE_nbif_code_is_module_native_1
#define HAVE_nbif_code_is_module_native_1
	GLOBAL(ASYM(nbif_code_is_module_native_1))
ASYM(nbif_code_is_module_native_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(code_is_module_native_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_code_is_module_native_1))
	TYPE_FUNCTION(ASYM(nbif_code_is_module_native_1))
#endif

#ifndef HAVE_nbif_ebif_code_is_native_1
#define HAVE_nbif_ebif_code_is_native_1
	GLOBAL(ASYM(nbif_ebif_code_is_native_1))
ASYM(nbif_ebif_code_is_native_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(ebif_code_is_native_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_ebif_code_is_native_1))
	TYPE_FUNCTION(ASYM(nbif_ebif_code_is_native_1))
#endif

#ifndef HAVE_nbif_blocking_read_file_1
#define HAVE_nbif_blocking_read_file_1
	GLOBAL(ASYM(nbif_blocking_read_file_1))
ASYM(nbif_blocking_read_file_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(blocking_read_file_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_blocking_read_file_1))
	TYPE_FUNCTION(ASYM(nbif_blocking_read_file_1))
#endif

#ifndef HAVE_nbif_hibernate_3
#define HAVE_nbif_hibernate_3
	GLOBAL(ASYM(nbif_hibernate_3))
ASYM(nbif_hibernate_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hibernate_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_hibernate_3))
	TYPE_FUNCTION(ASYM(nbif_hibernate_3))
#endif

#ifndef HAVE_nbif_error_logger_warning_map_0
#define HAVE_nbif_error_logger_warning_map_0
	GLOBAL(ASYM(nbif_error_logger_warning_map_0))
ASYM(nbif_error_logger_warning_map_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(error_logger_warning_map_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_error_logger_warning_map_0))
	TYPE_FUNCTION(ASYM(nbif_error_logger_warning_map_0))
#endif

#ifndef HAVE_nbif_get_module_info_1
#define HAVE_nbif_get_module_info_1
	GLOBAL(ASYM(nbif_get_module_info_1))
ASYM(nbif_get_module_info_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(get_module_info_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_get_module_info_1))
	TYPE_FUNCTION(ASYM(nbif_get_module_info_1))
#endif

#ifndef HAVE_nbif_get_module_info_2
#define HAVE_nbif_get_module_info_2
	GLOBAL(ASYM(nbif_get_module_info_2))
ASYM(nbif_get_module_info_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(get_module_info_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_get_module_info_2))
	TYPE_FUNCTION(ASYM(nbif_get_module_info_2))
#endif

#ifndef HAVE_nbif_is_boolean_1
#define HAVE_nbif_is_boolean_1
	GLOBAL(ASYM(nbif_is_boolean_1))
ASYM(nbif_is_boolean_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(is_boolean_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_is_boolean_1))
	TYPE_FUNCTION(ASYM(nbif_is_boolean_1))
#endif

#ifndef HAVE_nbif_string_to_integer_1
#define HAVE_nbif_string_to_integer_1
	GLOBAL(ASYM(nbif_string_to_integer_1))
ASYM(nbif_string_to_integer_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(string_to_integer_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_string_to_integer_1))
	TYPE_FUNCTION(ASYM(nbif_string_to_integer_1))
#endif

#ifndef HAVE_nbif_string_to_float_1
#define HAVE_nbif_string_to_float_1
	GLOBAL(ASYM(nbif_string_to_float_1))
ASYM(nbif_string_to_float_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(string_to_float_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_string_to_float_1))
	TYPE_FUNCTION(ASYM(nbif_string_to_float_1))
#endif

#ifndef HAVE_nbif_make_fun_3
#define HAVE_nbif_make_fun_3
	GLOBAL(ASYM(nbif_make_fun_3))
ASYM(nbif_make_fun_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(make_fun_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_make_fun_3))
	TYPE_FUNCTION(ASYM(nbif_make_fun_3))
#endif

#ifndef HAVE_nbif_iolist_size_1
#define HAVE_nbif_iolist_size_1
	GLOBAL(ASYM(nbif_iolist_size_1))
ASYM(nbif_iolist_size_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(iolist_size_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_iolist_size_1))
	TYPE_FUNCTION(ASYM(nbif_iolist_size_1))
#endif

#ifndef HAVE_nbif_iolist_to_binary_1
#define HAVE_nbif_iolist_to_binary_1
	GLOBAL(ASYM(nbif_iolist_to_binary_1))
ASYM(nbif_iolist_to_binary_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(iolist_to_binary_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_iolist_to_binary_1))
	TYPE_FUNCTION(ASYM(nbif_iolist_to_binary_1))
#endif

#ifndef HAVE_nbif_list_to_existing_atom_1
#define HAVE_nbif_list_to_existing_atom_1
	GLOBAL(ASYM(nbif_list_to_existing_atom_1))
ASYM(nbif_list_to_existing_atom_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(list_to_existing_atom_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_list_to_existing_atom_1))
	TYPE_FUNCTION(ASYM(nbif_list_to_existing_atom_1))
#endif

#ifndef HAVE_nbif_hash_2
#define HAVE_nbif_hash_2
	GLOBAL(ASYM(nbif_hash_2))
ASYM(nbif_hash_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hash_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hash_2))
	TYPE_FUNCTION(ASYM(nbif_hash_2))
#endif

#ifndef HAVE_nbif_old_binary_to_term_1
#define HAVE_nbif_old_binary_to_term_1
	GLOBAL(ASYM(nbif_old_binary_to_term_1))
ASYM(nbif_old_binary_to_term_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(old_binary_to_term_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_old_binary_to_term_1))
	TYPE_FUNCTION(ASYM(nbif_old_binary_to_term_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_write_u8_2
#define HAVE_nbif_hipe_bifs_write_u8_2
	GLOBAL(ASYM(nbif_hipe_bifs_write_u8_2))
ASYM(nbif_hipe_bifs_write_u8_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_write_u8_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_write_u8_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_write_u8_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_write_u32_2
#define HAVE_nbif_hipe_bifs_write_u32_2
	GLOBAL(ASYM(nbif_hipe_bifs_write_u32_2))
ASYM(nbif_hipe_bifs_write_u32_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_write_u32_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_write_u32_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_write_u32_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_bytearray_2
#define HAVE_nbif_hipe_bifs_bytearray_2
	GLOBAL(ASYM(nbif_hipe_bifs_bytearray_2))
ASYM(nbif_hipe_bifs_bytearray_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_bytearray_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_bytearray_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_bytearray_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_bytearray_sub_2
#define HAVE_nbif_hipe_bifs_bytearray_sub_2
	GLOBAL(ASYM(nbif_hipe_bifs_bytearray_sub_2))
ASYM(nbif_hipe_bifs_bytearray_sub_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_bytearray_sub_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_bytearray_sub_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_bytearray_sub_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_bytearray_update_3
#define HAVE_nbif_hipe_bifs_bytearray_update_3
	GLOBAL(ASYM(nbif_hipe_bifs_bytearray_update_3))
ASYM(nbif_hipe_bifs_bytearray_update_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_bytearray_update_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_bytearray_update_3))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_bytearray_update_3))
#endif

#ifndef HAVE_nbif_hipe_bifs_array_2
#define HAVE_nbif_hipe_bifs_array_2
	GLOBAL(ASYM(nbif_hipe_bifs_array_2))
ASYM(nbif_hipe_bifs_array_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_array_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_array_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_array_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_array_length_1
#define HAVE_nbif_hipe_bifs_array_length_1
	GLOBAL(ASYM(nbif_hipe_bifs_array_length_1))
ASYM(nbif_hipe_bifs_array_length_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_array_length_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_array_length_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_array_length_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_array_sub_2
#define HAVE_nbif_hipe_bifs_array_sub_2
	GLOBAL(ASYM(nbif_hipe_bifs_array_sub_2))
ASYM(nbif_hipe_bifs_array_sub_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_array_sub_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_array_sub_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_array_sub_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_array_update_3
#define HAVE_nbif_hipe_bifs_array_update_3
	GLOBAL(ASYM(nbif_hipe_bifs_array_update_3))
ASYM(nbif_hipe_bifs_array_update_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_array_update_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_array_update_3))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_array_update_3))
#endif

#ifndef HAVE_nbif_hipe_bifs_ref_1
#define HAVE_nbif_hipe_bifs_ref_1
	GLOBAL(ASYM(nbif_hipe_bifs_ref_1))
ASYM(nbif_hipe_bifs_ref_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_ref_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_ref_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_ref_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_ref_get_1
#define HAVE_nbif_hipe_bifs_ref_get_1
	GLOBAL(ASYM(nbif_hipe_bifs_ref_get_1))
ASYM(nbif_hipe_bifs_ref_get_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_ref_get_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_ref_get_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_ref_get_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_ref_set_2
#define HAVE_nbif_hipe_bifs_ref_set_2
	GLOBAL(ASYM(nbif_hipe_bifs_ref_set_2))
ASYM(nbif_hipe_bifs_ref_set_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_ref_set_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_ref_set_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_ref_set_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_enter_code_2
#define HAVE_nbif_hipe_bifs_enter_code_2
	GLOBAL(ASYM(nbif_hipe_bifs_enter_code_2))
ASYM(nbif_hipe_bifs_enter_code_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_enter_code_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_enter_code_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_enter_code_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_alloc_data_2
#define HAVE_nbif_hipe_bifs_alloc_data_2
	GLOBAL(ASYM(nbif_hipe_bifs_alloc_data_2))
ASYM(nbif_hipe_bifs_alloc_data_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_alloc_data_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_alloc_data_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_alloc_data_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_constants_size_0
#define HAVE_nbif_hipe_bifs_constants_size_0
	GLOBAL(ASYM(nbif_hipe_bifs_constants_size_0))
ASYM(nbif_hipe_bifs_constants_size_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_constants_size_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_constants_size_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_constants_size_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_merge_term_1
#define HAVE_nbif_hipe_bifs_merge_term_1
	GLOBAL(ASYM(nbif_hipe_bifs_merge_term_1))
ASYM(nbif_hipe_bifs_merge_term_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_merge_term_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_merge_term_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_merge_term_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_fun_to_address_1
#define HAVE_nbif_hipe_bifs_fun_to_address_1
	GLOBAL(ASYM(nbif_hipe_bifs_fun_to_address_1))
ASYM(nbif_hipe_bifs_fun_to_address_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_fun_to_address_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_fun_to_address_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_fun_to_address_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_set_native_address_3
#define HAVE_nbif_hipe_bifs_set_native_address_3
	GLOBAL(ASYM(nbif_hipe_bifs_set_native_address_3))
ASYM(nbif_hipe_bifs_set_native_address_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_set_native_address_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_set_native_address_3))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_set_native_address_3))
#endif

#ifndef HAVE_nbif_hipe_bifs_set_funinfo_native_address_3
#define HAVE_nbif_hipe_bifs_set_funinfo_native_address_3
	GLOBAL(ASYM(nbif_hipe_bifs_set_funinfo_native_address_3))
ASYM(nbif_hipe_bifs_set_funinfo_native_address_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_set_funinfo_native_address_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_set_funinfo_native_address_3))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_set_funinfo_native_address_3))
#endif

#ifndef HAVE_nbif_hipe_bifs_invalidate_funinfo_native_addresses_1
#define HAVE_nbif_hipe_bifs_invalidate_funinfo_native_addresses_1
	GLOBAL(ASYM(nbif_hipe_bifs_invalidate_funinfo_native_addresses_1))
ASYM(nbif_hipe_bifs_invalidate_funinfo_native_addresses_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_invalidate_funinfo_native_addresses_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_invalidate_funinfo_native_addresses_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_invalidate_funinfo_native_addresses_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_update_code_size_3
#define HAVE_nbif_hipe_bifs_update_code_size_3
	GLOBAL(ASYM(nbif_hipe_bifs_update_code_size_3))
ASYM(nbif_hipe_bifs_update_code_size_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_update_code_size_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_update_code_size_3))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_update_code_size_3))
#endif

#ifndef HAVE_nbif_hipe_bifs_code_size_1
#define HAVE_nbif_hipe_bifs_code_size_1
	GLOBAL(ASYM(nbif_hipe_bifs_code_size_1))
ASYM(nbif_hipe_bifs_code_size_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_code_size_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_code_size_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_code_size_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_enter_sdesc_1
#define HAVE_nbif_hipe_bifs_enter_sdesc_1
	GLOBAL(ASYM(nbif_hipe_bifs_enter_sdesc_1))
ASYM(nbif_hipe_bifs_enter_sdesc_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_enter_sdesc_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_enter_sdesc_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_enter_sdesc_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_bif_address_3
#define HAVE_nbif_hipe_bifs_bif_address_3
	GLOBAL(ASYM(nbif_hipe_bifs_bif_address_3))
ASYM(nbif_hipe_bifs_bif_address_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_bif_address_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_bif_address_3))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_bif_address_3))
#endif

#ifndef HAVE_nbif_hipe_bifs_primop_address_1
#define HAVE_nbif_hipe_bifs_primop_address_1
	GLOBAL(ASYM(nbif_hipe_bifs_primop_address_1))
ASYM(nbif_hipe_bifs_primop_address_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_primop_address_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_primop_address_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_primop_address_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_atom_to_word_1
#define HAVE_nbif_hipe_bifs_atom_to_word_1
	GLOBAL(ASYM(nbif_hipe_bifs_atom_to_word_1))
ASYM(nbif_hipe_bifs_atom_to_word_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_atom_to_word_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_atom_to_word_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_atom_to_word_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_term_to_word_1
#define HAVE_nbif_hipe_bifs_term_to_word_1
	GLOBAL(ASYM(nbif_hipe_bifs_term_to_word_1))
ASYM(nbif_hipe_bifs_term_to_word_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_term_to_word_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_term_to_word_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_term_to_word_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_make_fe_3
#define HAVE_nbif_hipe_bifs_make_fe_3
	GLOBAL(ASYM(nbif_hipe_bifs_make_fe_3))
ASYM(nbif_hipe_bifs_make_fe_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_make_fe_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_make_fe_3))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_make_fe_3))
#endif

#ifndef HAVE_nbif_hipe_bifs_find_na_or_make_stub_2
#define HAVE_nbif_hipe_bifs_find_na_or_make_stub_2
	GLOBAL(ASYM(nbif_hipe_bifs_find_na_or_make_stub_2))
ASYM(nbif_hipe_bifs_find_na_or_make_stub_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_find_na_or_make_stub_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_find_na_or_make_stub_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_find_na_or_make_stub_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_check_crc_1
#define HAVE_nbif_hipe_bifs_check_crc_1
	GLOBAL(ASYM(nbif_hipe_bifs_check_crc_1))
ASYM(nbif_hipe_bifs_check_crc_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_check_crc_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_check_crc_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_check_crc_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_system_crc_1
#define HAVE_nbif_hipe_bifs_system_crc_1
	GLOBAL(ASYM(nbif_hipe_bifs_system_crc_1))
ASYM(nbif_hipe_bifs_system_crc_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_system_crc_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_system_crc_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_system_crc_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_get_rts_param_1
#define HAVE_nbif_hipe_bifs_get_rts_param_1
	GLOBAL(ASYM(nbif_hipe_bifs_get_rts_param_1))
ASYM(nbif_hipe_bifs_get_rts_param_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_get_rts_param_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_get_rts_param_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_get_rts_param_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_patch_insn_3
#define HAVE_nbif_hipe_bifs_patch_insn_3
	GLOBAL(ASYM(nbif_hipe_bifs_patch_insn_3))
ASYM(nbif_hipe_bifs_patch_insn_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_patch_insn_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_patch_insn_3))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_patch_insn_3))
#endif

#ifndef HAVE_nbif_hipe_bifs_patch_call_3
#define HAVE_nbif_hipe_bifs_patch_call_3
	GLOBAL(ASYM(nbif_hipe_bifs_patch_call_3))
ASYM(nbif_hipe_bifs_patch_call_3):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5
	# mr r6, r6

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_patch_call_3)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_3_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_patch_call_3))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_patch_call_3))
#endif

#ifndef HAVE_nbif_hipe_bifs_add_ref_2
#define HAVE_nbif_hipe_bifs_add_ref_2
	GLOBAL(ASYM(nbif_hipe_bifs_add_ref_2))
ASYM(nbif_hipe_bifs_add_ref_2):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4
	# mr r5, r5

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_add_ref_2)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_2_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_add_ref_2))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_add_ref_2))
#endif

#ifndef HAVE_nbif_hipe_bifs_mark_referred_from_1
#define HAVE_nbif_hipe_bifs_mark_referred_from_1
	GLOBAL(ASYM(nbif_hipe_bifs_mark_referred_from_1))
ASYM(nbif_hipe_bifs_mark_referred_from_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_mark_referred_from_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_mark_referred_from_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_mark_referred_from_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_remove_refs_from_1
#define HAVE_nbif_hipe_bifs_remove_refs_from_1
	GLOBAL(ASYM(nbif_hipe_bifs_remove_refs_from_1))
ASYM(nbif_hipe_bifs_remove_refs_from_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_remove_refs_from_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_remove_refs_from_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_remove_refs_from_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_redirect_referred_from_1
#define HAVE_nbif_hipe_bifs_redirect_referred_from_1
	GLOBAL(ASYM(nbif_hipe_bifs_redirect_referred_from_1))
ASYM(nbif_hipe_bifs_redirect_referred_from_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_redirect_referred_from_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_redirect_referred_from_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_redirect_referred_from_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_call_count_on_1
#define HAVE_nbif_hipe_bifs_call_count_on_1
	GLOBAL(ASYM(nbif_hipe_bifs_call_count_on_1))
ASYM(nbif_hipe_bifs_call_count_on_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_call_count_on_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_call_count_on_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_call_count_on_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_call_count_off_1
#define HAVE_nbif_hipe_bifs_call_count_off_1
	GLOBAL(ASYM(nbif_hipe_bifs_call_count_off_1))
ASYM(nbif_hipe_bifs_call_count_off_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_call_count_off_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_call_count_off_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_call_count_off_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_call_count_get_1
#define HAVE_nbif_hipe_bifs_call_count_get_1
	GLOBAL(ASYM(nbif_hipe_bifs_call_count_get_1))
ASYM(nbif_hipe_bifs_call_count_get_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_call_count_get_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_call_count_get_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_call_count_get_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_call_count_clear_1
#define HAVE_nbif_hipe_bifs_call_count_clear_1
	GLOBAL(ASYM(nbif_hipe_bifs_call_count_clear_1))
ASYM(nbif_hipe_bifs_call_count_clear_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_call_count_clear_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_call_count_clear_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_call_count_clear_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_trap_count_get_0
#define HAVE_nbif_hipe_bifs_trap_count_get_0
	GLOBAL(ASYM(nbif_hipe_bifs_trap_count_get_0))
ASYM(nbif_hipe_bifs_trap_count_get_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_trap_count_get_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_trap_count_get_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_trap_count_get_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_trap_count_clear_0
#define HAVE_nbif_hipe_bifs_trap_count_clear_0
	GLOBAL(ASYM(nbif_hipe_bifs_trap_count_clear_0))
ASYM(nbif_hipe_bifs_trap_count_clear_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_trap_count_clear_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_trap_count_clear_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_trap_count_clear_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_process_info_0
#define HAVE_nbif_hipe_bifs_process_info_0
	GLOBAL(ASYM(nbif_hipe_bifs_process_info_0))
ASYM(nbif_hipe_bifs_process_info_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_process_info_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_process_info_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_process_info_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_process_info_clear_0
#define HAVE_nbif_hipe_bifs_process_info_clear_0
	GLOBAL(ASYM(nbif_hipe_bifs_process_info_clear_0))
ASYM(nbif_hipe_bifs_process_info_clear_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_process_info_clear_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_process_info_clear_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_process_info_clear_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_message_info_0
#define HAVE_nbif_hipe_bifs_message_info_0
	GLOBAL(ASYM(nbif_hipe_bifs_message_info_0))
ASYM(nbif_hipe_bifs_message_info_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_message_info_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_message_info_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_message_info_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_message_info_clear_0
#define HAVE_nbif_hipe_bifs_message_info_clear_0
	GLOBAL(ASYM(nbif_hipe_bifs_message_info_clear_0))
ASYM(nbif_hipe_bifs_message_info_clear_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_message_info_clear_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_message_info_clear_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_message_info_clear_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_message_sizes_0
#define HAVE_nbif_hipe_bifs_message_sizes_0
	GLOBAL(ASYM(nbif_hipe_bifs_message_sizes_0))
ASYM(nbif_hipe_bifs_message_sizes_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_message_sizes_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_message_sizes_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_message_sizes_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_gc_info_0
#define HAVE_nbif_hipe_bifs_gc_info_0
	GLOBAL(ASYM(nbif_hipe_bifs_gc_info_0))
ASYM(nbif_hipe_bifs_gc_info_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_gc_info_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_gc_info_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_gc_info_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_shared_gc_info_0
#define HAVE_nbif_hipe_bifs_shared_gc_info_0
	GLOBAL(ASYM(nbif_hipe_bifs_shared_gc_info_0))
ASYM(nbif_hipe_bifs_shared_gc_info_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_shared_gc_info_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_shared_gc_info_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_shared_gc_info_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_incremental_gc_info_0
#define HAVE_nbif_hipe_bifs_incremental_gc_info_0
	GLOBAL(ASYM(nbif_hipe_bifs_incremental_gc_info_0))
ASYM(nbif_hipe_bifs_incremental_gc_info_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_incremental_gc_info_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_incremental_gc_info_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_incremental_gc_info_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_gc_info_clear_0
#define HAVE_nbif_hipe_bifs_gc_info_clear_0
	GLOBAL(ASYM(nbif_hipe_bifs_gc_info_clear_0))
ASYM(nbif_hipe_bifs_gc_info_clear_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_gc_info_clear_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_gc_info_clear_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_gc_info_clear_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_pause_times_0
#define HAVE_nbif_hipe_bifs_pause_times_0
	GLOBAL(ASYM(nbif_hipe_bifs_pause_times_0))
ASYM(nbif_hipe_bifs_pause_times_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_pause_times_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_pause_times_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_pause_times_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_system_timer_0
#define HAVE_nbif_hipe_bifs_system_timer_0
	GLOBAL(ASYM(nbif_hipe_bifs_system_timer_0))
ASYM(nbif_hipe_bifs_system_timer_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_system_timer_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_system_timer_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_system_timer_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_system_timer_clear_0
#define HAVE_nbif_hipe_bifs_system_timer_clear_0
	GLOBAL(ASYM(nbif_hipe_bifs_system_timer_clear_0))
ASYM(nbif_hipe_bifs_system_timer_clear_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_system_timer_clear_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_system_timer_clear_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_system_timer_clear_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_send_timer_0
#define HAVE_nbif_hipe_bifs_send_timer_0
	GLOBAL(ASYM(nbif_hipe_bifs_send_timer_0))
ASYM(nbif_hipe_bifs_send_timer_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_send_timer_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_send_timer_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_send_timer_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_send_timer_clear_0
#define HAVE_nbif_hipe_bifs_send_timer_clear_0
	GLOBAL(ASYM(nbif_hipe_bifs_send_timer_clear_0))
ASYM(nbif_hipe_bifs_send_timer_clear_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_send_timer_clear_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_send_timer_clear_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_send_timer_clear_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_gc_timer_0
#define HAVE_nbif_hipe_bifs_gc_timer_0
	GLOBAL(ASYM(nbif_hipe_bifs_gc_timer_0))
ASYM(nbif_hipe_bifs_gc_timer_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_gc_timer_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_gc_timer_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_gc_timer_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_shared_gc_timer_0
#define HAVE_nbif_hipe_bifs_shared_gc_timer_0
	GLOBAL(ASYM(nbif_hipe_bifs_shared_gc_timer_0))
ASYM(nbif_hipe_bifs_shared_gc_timer_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_shared_gc_timer_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_shared_gc_timer_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_shared_gc_timer_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_gc_timer_clear_0
#define HAVE_nbif_hipe_bifs_gc_timer_clear_0
	GLOBAL(ASYM(nbif_hipe_bifs_gc_timer_clear_0))
ASYM(nbif_hipe_bifs_gc_timer_clear_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_gc_timer_clear_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_gc_timer_clear_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_gc_timer_clear_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_misc_timer_0
#define HAVE_nbif_hipe_bifs_misc_timer_0
	GLOBAL(ASYM(nbif_hipe_bifs_misc_timer_0))
ASYM(nbif_hipe_bifs_misc_timer_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_misc_timer_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_misc_timer_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_misc_timer_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_misc_timer_clear_0
#define HAVE_nbif_hipe_bifs_misc_timer_clear_0
	GLOBAL(ASYM(nbif_hipe_bifs_misc_timer_clear_0))
ASYM(nbif_hipe_bifs_misc_timer_clear_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_misc_timer_clear_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_misc_timer_clear_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_misc_timer_clear_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_get_hrvtime_0
#define HAVE_nbif_hipe_bifs_get_hrvtime_0
	GLOBAL(ASYM(nbif_hipe_bifs_get_hrvtime_0))
ASYM(nbif_hipe_bifs_get_hrvtime_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_get_hrvtime_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_get_hrvtime_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_get_hrvtime_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_stop_hrvtime_0
#define HAVE_nbif_hipe_bifs_stop_hrvtime_0
	GLOBAL(ASYM(nbif_hipe_bifs_stop_hrvtime_0))
ASYM(nbif_hipe_bifs_stop_hrvtime_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_stop_hrvtime_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_stop_hrvtime_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_stop_hrvtime_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_show_estack_1
#define HAVE_nbif_hipe_bifs_show_estack_1
	GLOBAL(ASYM(nbif_hipe_bifs_show_estack_1))
ASYM(nbif_hipe_bifs_show_estack_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_show_estack_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_show_estack_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_show_estack_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_show_heap_1
#define HAVE_nbif_hipe_bifs_show_heap_1
	GLOBAL(ASYM(nbif_hipe_bifs_show_heap_1))
ASYM(nbif_hipe_bifs_show_heap_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_show_heap_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_show_heap_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_show_heap_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_show_nstack_1
#define HAVE_nbif_hipe_bifs_show_nstack_1
	GLOBAL(ASYM(nbif_hipe_bifs_show_nstack_1))
ASYM(nbif_hipe_bifs_show_nstack_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_show_nstack_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_show_nstack_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_show_nstack_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_nstack_used_size_0
#define HAVE_nbif_hipe_bifs_nstack_used_size_0
	GLOBAL(ASYM(nbif_hipe_bifs_nstack_used_size_0))
ASYM(nbif_hipe_bifs_nstack_used_size_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_nstack_used_size_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_nstack_used_size_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_nstack_used_size_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_show_pcb_1
#define HAVE_nbif_hipe_bifs_show_pcb_1
	GLOBAL(ASYM(nbif_hipe_bifs_show_pcb_1))
ASYM(nbif_hipe_bifs_show_pcb_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_show_pcb_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_show_pcb_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_show_pcb_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_show_term_1
#define HAVE_nbif_hipe_bifs_show_term_1
	GLOBAL(ASYM(nbif_hipe_bifs_show_term_1))
ASYM(nbif_hipe_bifs_show_term_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_show_term_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_show_term_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_show_term_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_show_literals_0
#define HAVE_nbif_hipe_bifs_show_literals_0
	GLOBAL(ASYM(nbif_hipe_bifs_show_literals_0))
ASYM(nbif_hipe_bifs_show_literals_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_show_literals_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_show_literals_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_show_literals_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_in_native_0
#define HAVE_nbif_hipe_bifs_in_native_0
	GLOBAL(ASYM(nbif_hipe_bifs_in_native_0))
ASYM(nbif_hipe_bifs_in_native_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_in_native_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_in_native_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_in_native_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_modeswitch_debug_on_0
#define HAVE_nbif_hipe_bifs_modeswitch_debug_on_0
	GLOBAL(ASYM(nbif_hipe_bifs_modeswitch_debug_on_0))
ASYM(nbif_hipe_bifs_modeswitch_debug_on_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_modeswitch_debug_on_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_modeswitch_debug_on_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_modeswitch_debug_on_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_modeswitch_debug_off_0
#define HAVE_nbif_hipe_bifs_modeswitch_debug_off_0
	GLOBAL(ASYM(nbif_hipe_bifs_modeswitch_debug_off_0))
ASYM(nbif_hipe_bifs_modeswitch_debug_off_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_modeswitch_debug_off_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_modeswitch_debug_off_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_modeswitch_debug_off_0))
#endif

#ifndef HAVE_nbif_hipe_bifs_test_reschedule_1
#define HAVE_nbif_hipe_bifs_test_reschedule_1
	GLOBAL(ASYM(nbif_hipe_bifs_test_reschedule_1))
ASYM(nbif_hipe_bifs_test_reschedule_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_test_reschedule_1)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_1_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_test_reschedule_1))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_test_reschedule_1))
#endif

#ifndef HAVE_nbif_hipe_bifs_show_message_area_0
#define HAVE_nbif_hipe_bifs_show_message_area_0
	GLOBAL(ASYM(nbif_hipe_bifs_show_message_area_0))
ASYM(nbif_hipe_bifs_show_message_area_0):
	/* Set up C argument registers. */
	mr	r3, P

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(hipe_bifs_show_message_area_0)

	/* Restore registers. Check for exception. */
	cmpwi	r3, THE_NON_VALUE
	RESTORE_CONTEXT
	beq-	1f
	blr
1:	/* workaround for bc:s small offset operand */
	b	CSYM(nbif_0_simple_exception)
	SET_SIZE(ASYM(nbif_hipe_bifs_show_message_area_0))
	TYPE_FUNCTION(ASYM(nbif_hipe_bifs_show_message_area_0))
#endif


/*
 * Guard BIFs.
 * GBIF_LIST(FunctionAtom,Arity,CFun)
 */

/* $Id$
 * GBIF_LIST(FunctionAtom,Arity,CFun)
 * manually maintained for now -- expand when necessary
 */

#ifndef HAVE_gbif_node_1
#define HAVE_gbif_node_1
	GLOBAL(ASYM(gbif_node_1))
ASYM(gbif_node_1):
	/* Set up C argument registers. */
	mr	r3, P
	# mr r4, r4

	/* Save caller-save registers and call the C function. */
	SAVE_CONTEXT
	bl	CSYM(node_1)

	/* Restore registers. */
	RESTORE_CONTEXT
	blr
	SET_SIZE(ASYM(gbif_node_1))
	TYPE_FUNCTION(ASYM(gbif_node_1))
#endif


